VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMemShare"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Code is COPYRIGHT AlienX Software  2000-2006 - all rights reserved
'Please ASK to use this code - its only polite
'Email: AlienX@AlienXSoftware.co.uk (Also MSN Enabled)
Public sInputFile As String
Private sCont As String, lAddr() As Long, lAddrCount As Long, lCursor As Long

Public Function Init(sFile As String) As Boolean
    Me.sInputFile = sFile
    Me.ResetCursor
    lAddrCount = 0
    sCont = ""
    ReDim lAddr(0)
    Init = Me.LoadAddressList
End Function

Public Function LoadAddressList() As Boolean
    On Error GoTo ReturnFalse
    
    Dim s As String, i As Integer
    
    LoadAddressList = False
    
    If sInputFile = "" Or Not FileExists(sInputFile) Then
        Exit Function
    End If
    
    Open Me.sInputFile For Binary As #1
        s = Input(FileLen(Me.sInputFile), #1)
    Close #1
    
    sCont = s
    lAddrCount = 0
    
    For i = 1 To Len(sCont) Step 4
        If (Len(sCont) - i + 1) >= 4 Then
            ReDim Preserve lAddr(lAddrCount)
            lAddr(lAddrCount) = BytesToLong(Mid(sCont, i, 4))
            lAddrCount = lAddrCount + 1
        End If
    Next
    
    LoadAddressList = True
    
ReturnFalse:
    Exit Function
End Function

Public Function NextAddress(Optional bAdvanceCursor = True) As Long
    NextAddress = lAddr(lCursor)
    If lCursor < lAddrCount - 1 Then lCursor = lCursor + 1
End Function

Public Sub ResetCursor(Optional lPos As Long = 0)
    If lPos >= 0 And lPos < lAddrCount Then lCursor = lPos
End Sub

