Attribute VB_Name = "Mod_EncDec"
'Code is COPYRIGHT AlienX Software  2000-2006 - all rights reserved
'Please ASK to use this code - its only polite
'Email: AlienX@AlienXSoftware.co.uk (Also MSN Enabled)
Const Base = "mtpxnyeo7c0434sxdfZqC%P%DK<|!^ZS#d>}<C?B6Xc9WW~x8miG\Ouenfuena[03,I(OW&G+.>~Y:HM&LJP9&]CTtHXD%*..h9-$bpQl}R&[?:aFE4s.FZTe,?!jx<5Io5eu5}|sR^K/]ZqC%P%DK<|!^ZS#d>}<C?B6Xc9WW~x8miG\OO-|1Xa*^fjI(OW&G+.>~Y:HM&LJz:0PAQF9&]/]ZqC%P%DK<|!^ZS#d>}<C?B6Xc9WW~x8miG\OO-|"
Private BaseArray() As Byte 'will get to hold exactly 256 bytes

Public Function Enc(sData() As Byte, sPass As String) As Byte()
    On Error GoTo EH
    
    Dim k As Long
    Dim UB As Long
    Dim d As Integer
    Dim Ptr As Integer
    Dim Avg As Byte
    Dim TBytes As Long
    Dim PWLen As Integer
    Dim PWarray() As Byte
    Dim PWB As Byte
    Dim MPAR As Byte
    
    'checkings
    If Len(Base) <> 256 Then Exit Function
    If Len(sPass) > 128 Then Exit Function
    
    If sPass = "" Then
        'no pass
        Exit Function
    End If
    
    If sPass = "" Then
        'no pass
        Exit Function
    End If
    
    UB = -1
    UB = UBound(sData)
    If UB = -1 Then
        'no input data
        Exit Function
    End If
    
    'load base array
    BaseArray = StrConv(Base, vbFromUnicode)
    
    'load pass
    PWLen = Len(sPass)
    PWarray = StrConv(sPass, vbFromUnicode)
    
    k = 0
    
    'make sum
    For k = 1 To PWLen
        TBytes = TBytes + PWarray(k - 1)
    Next k
    
    'avg
    Avg = Int(TBytes / k)
    
    k = 0
    Do
        d = sData(k)
        Ptr = k Mod 256
        PWB = Ptr Mod PWLen
        MPAR = (PWarray(PWLen - PWB - 1) * Ptr + Avg) Mod 256
        d = (d + BaseArray(Ptr) + MPAR) Mod 256
        d = d Xor 255
        d = (d + Avg + PWarray(PWB)) Mod 256
        sData(k) = d
        k = k + 1
    Loop Until k = UB
    
    Enc = sData
    
    Exit Function
    
EH:
End Function

Public Function Dec(sData() As Byte, sPass As String) As Byte()
    On Error GoTo EH

    Dim k As Long
    Dim UB As Long
    Dim d As Integer
    Dim Ptr As Integer
    Dim Avg As Byte
    Dim TBytes As Long
    Dim PWLen As Integer
    Dim PWarray() As Byte
    Dim PWB As Byte
    Dim MPAR As Byte
    
    'checkings
    If Len(Base) <> 256 Then Exit Function
    If Len(sPass) > 128 Then Exit Function
    
    If sPass = "" Then
        'no pass
        Exit Function
    End If
    
    UB = -1
    UB = UBound(sData)
    If UB = -1 Then
        'no input data
        Exit Function
    End If
    
    'load base array
    BaseArray = StrConv(Base, vbFromUnicode)
    
    PWLen = Len(sPass)
    
    PWarray = StrConv(sPass, vbFromUnicode)
    
    k = 0
    
    'make sum
    For k = 1 To PWLen
        TBytes = TBytes + PWarray(k - 1)
    Next k
    
    'avg
    Avg = Int(TBytes / k)
    
    k = 0
    Do
        d = sData(k)
        Ptr = k Mod 256
        PWB = Ptr Mod PWLen
        MPAR = (PWarray(PWLen - PWB - 1) * Ptr + Avg) Mod 256
        d = (512 + d - PWarray(PWB) - Avg) Mod 256
        d = d Xor 255
        d = (512 + d - BaseArray(Ptr) - MPAR) Mod 256
        
        sData(k) = d
        k = k + 1
    Loop Until k = UB
    
    Dec = sData
    
    Exit Function
    
EH:
End Function


'Functions to convert between strings and byte arrays
Public Function STRING_TO_BYTES(sString As String) As Byte()
    STRING_TO_BYTES = StrConv(sString, vbFromUnicode)
End Function

Public Function BYTES_TO_STRING(bBytes() As Byte) As String
    BYTES_TO_STRING = bBytes
    BYTES_TO_STRING = StrConv(BYTES_TO_STRING, vbUnicode)
End Function


Public Function Encrypt(sPass As String, sData As String) As String
    Dim b() As Byte
    
    b() = STRING_TO_BYTES(sData)
    b() = Enc(b(), sPass)
    Encrypt = BYTES_TO_STRING(b())
End Function

Public Function Decrypt(sPass As String, sData As String) As String
    Dim b() As Byte
    
    b() = STRING_TO_BYTES(sData)
    b() = Dec(b(), sPass)
    Decrypt = BYTES_TO_STRING(b())
End Function

Public Function GenerateRandomKey(sLen As Integer) As String
    Dim s As String
    Dim k As Long
    
    If sLen < 2 Then Exit Function
    
    For k = 1 To sLen
        Randomize
        s = s + Chr(Int(Rnd * 95) + 32)
    Next
    GenerateRandomKey = s

End Function
