Attribute VB_Name = "Mod_MapEngine"
Public MapEngine As MAPENG_Default
Public MapEngine_Storage(1 To 5000) As MAPENG_Storage

Private Type MAPENG_Storage
    ObjectSpawned As Boolean
    Pending As Boolean
    PendingDelete As Boolean
    Location As XYZVertex
    Rotation As XYZVertex
    SCMID As Long
    Model As Long
    Recieved As Boolean
End Type

Private Type MAPENG_Default
    Objects As Long
    ObjectsRecieved As Long
End Type



'All calls are in GTAHOOK
'   CreateObject (CreateObjectServerIDModelIDXYZRXRYRZ)
'       Return: ObjCreatedObjectIDServerID
'   DestroyObject
'       Return: Unknown

'Scanning Thread: (spawns and deletes objects as they are far/close)
'Works the same way as vehicles do ;)
Public Sub ScanWorld()
Dim i As Integer
Dim Distance As Single
Dim PlayerLocation As XYZVertex

    

    For i = 1 To MapEngine.Objects
        'DoEvents
        'Get the current player location
        If FrmMain.GTAHOOK.IsPlayerDriving Then
            'vehicle
            PlayerLocation.x = FrmMain.GTAHOOK.Vehicle_Get_XLocation
            PlayerLocation.y = FrmMain.GTAHOOK.Vehicle_Get_YLocation
            PlayerLocation.Z = FrmMain.GTAHOOK.Vehicle_Get_ZLocation
        Else
            'foot
            PlayerLocation.x = FrmMain.GTAHOOK.Player_Get_XLocation
            PlayerLocation.y = FrmMain.GTAHOOK.Player_Get_YLocation
            PlayerLocation.Z = FrmMain.GTAHOOK.Player_Get_ZLocation
        End If
        
        If MapEngine_Storage(i).ObjectSpawned Then
            'work out distance
            Distance = FrmMain.GTAHOOK.GetDistanceBetween2Points(PlayerLocation.x, PlayerLocation.y, PlayerLocation.Z, MapEngine_Storage(i).Location.x, MapEngine_Storage(i).Location.y, MapEngine_Storage(i).Location.Z)

            If Distance > 141 Then
                FrmMain.GTAHOOK.DestroyObject CLng(i), MapEngine_Storage(i).SCMID
            End If
        Else
            'work out distance
            Distance = FrmMain.GTAHOOK.GetDistanceBetween2Points(PlayerLocation.x, PlayerLocation.y, PlayerLocation.Z, MapEngine_Storage(i).Location.x, MapEngine_Storage(i).Location.y, MapEngine_Storage(i).Location.Z)
            
            If Distance < 140 Then
                'Spawn this object (checks are done within the spawn procedure
                FrmMain.GTAHOOK.CreateObject CLng(i), _
                                            MapEngine_Storage(i).Model, _
                                            MapEngine_Storage(i).Location.x, _
                                            MapEngine_Storage(i).Location.y, _
                                            MapEngine_Storage(i).Location.Z, _
                                            MapEngine_Storage(i).Rotation.x, _
                                            MapEngine_Storage(i).Rotation.y, _
                                            MapEngine_Storage(i).Rotation.Z
            End If
        End If
    Next i

End Sub
