Attribute VB_Name = "Mod_ScriptSpheres"
'Define Sphere Type
Private Type SPHERE_TYPE
    x As Single
    y As Single
    Z As Single
    Radius As Single
    ServerID As Integer
    InUse As Boolean
    SCMID As Long
    MarkerID As Long
End Type

'Make it public
Public ScriptSpheres(0 To 1000) As SPHERE_TYPE

Public Sub InstallSphere(x As Single, y As Single, Z As Single, Radius As Single, ServerID As Integer, SCMID As Long)
Dim fss As Integer
    fss = FindFreeSphereSlot
    ScriptSpheres(fss).x = x
    ScriptSpheres(fss).y = y
    ScriptSpheres(fss).Z = Z
    ScriptSpheres(fss).Radius = Radius
    ScriptSpheres(fss).ServerID = ServerID
    ScriptSpheres(fss).InUse = True
    
    FrmMain.GTAHOOK.CreateSphere fss
End Sub

Public Sub UninstallSphere(ServerID As Integer)
Dim i As Integer
    For i = 1 To 1000
        If ScriptSpheres(i).ServerID = ServerID Then
            ScriptSpheres(i).InUse = False
            FrmMain.GTAHOOK.DestroySphere i
            Exit For
        End If
    Next
End Sub

Public Function FindFreeSphereSlot() As Integer
Dim i As Integer
    For i = 1 To 1000
        If Not ScriptSpheres(i).InUse Then
            FindFreeSphereSlot = i
            Exit For
        End If
    Next
End Function
