Attribute VB_Name = "mod_MemShare"
'Code is COPYRIGHT AlienX Software  2000-2006 - all rights reserved
'Please ASK to use this code - its only polite
'Email: AlienX@AlienXSoftware.co.uk (Also MSN Enabled)
Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Public Declare Function VirtualProtectEx Lib "kernel32" (ByVal hProcess As Long, lpAddress As Any, ByVal dwSize As Long, ByVal flNewProtect As Long, lpflOldProtect As Long) As Long

Global lAddrNotice As Long, lAddrChat As Long
Global lAddrShowSay As Long, lAddrSay  As Long
Global lAddrNumPlayers As Long
Global lAddrDrawScoreboard As Long, lAddrScoreboard As Long, lAddrPlayers As Long
Global sChatHistory(0 To 255) As String

Public Type PlayerInfo
    lRconID As Long
    lRank As Long
    lAddr As Long
    cR As Byte
    cG As Byte
    cB As Byte
    sName As String
    lScore As Long
End Type

Global Players() As PlayerInfo, lNumPlayers As Long
Dim lSizeofPlayer As Long 'sizeof(player_info)

'The following must be the same as in the C++ DLL
Public Const cChatLineCount = 256
Public Const cChatLineLen = 1024
Public Const cPlayerNameLen = 16

'End

Dim lSizeofSE As Long 'sizeof(scoreboard_entry)

Global ms As clsMemShare

Public Function LoadAddresses(sFile As String) As Boolean
    LoadAddresses = False
    
    Set ms = New clsMemShare
    
    If Not ms.Init(sFile) Then
        Exit Function
    End If
    
    SetSizes
    
    lAddrNotice = ms.NextAddress
    lAddrChat = ms.NextAddress
    lAddrShowSay = ms.NextAddress
    lAddrSay = ms.NextAddress
    lAddrNumPlayers = ms.NextAddress
    lAddrPlayers = ms.NextAddress
    lAddrDrawScoreboard = ms.NextAddress
    
    LoadAddresses = True
End Function

Public Sub ShowScoreboard()
    WriteByte lAddrDrawScoreboard, 1
End Sub

Public Sub HideScoreboard()
    WriteByte lAddrDrawScoreboard, 0
End Sub

Public Sub UpdateScoreboard()
    Dim i As Long
    
    WriteLong lAddrNumPlayers, 3
    
    SetScoreboardEntry 0, 1, 0, 0, 255, "DesertEagle", 11, 7, 43
    SetScoreboardEntry 1, 2, 255, 0, 0, "AlienX", 9, 9, 36
    SetScoreboardEntry 2, 3, 0, 255, 0, "Somebody Else", 4, 8, 50
    
    'For i = 0 To 1
    '    SetScoreboardEntry i, i + 1
    'Next
End Sub

'Public Sub SetScoreboardEntry(lEntryID As Long, iRank As Integer, cR As Byte, cG As Byte, cB As Byte, sPlayerName As String, iKills As Integer, iDeaths As Integer, iPing As Integer)
Public Sub SetScoreboardEntry(lEntryID As Long, iRank As Long, cR As Byte, cG As Byte, cB As Byte, sPlayerName As String, iKills As Long, iDeaths As Long, iPing As Long)
    Dim lAddr As Long
    
    lAddr = lAddrScoreboard + lEntryID * lSizeofSE
    
    WriteLong lAddr, iRank
    WriteByte lAddr, cR, 4
    WriteByte lAddr, cG, 5
    WriteByte lAddr, cB, 6
    WriteString lAddr, sPlayerName & Chr(0), 7
    
    lAddr = lAddr + cPlayerNameLen + 8
    
    WriteLong lAddr, iKills
    WriteLong lAddr, iDeaths, 4
    WriteLong lAddr, iPing, 8
End Sub

Public Sub AddChatLine(sLine As String)
    Dim i As Long
    
    If Len(sLine) > cChatLineLen Then
        sLine = Mid(sLine, 1, cChatLineLen)
    End If
    
    For i = cChatLineCount - 1 To 1 Step -1
        sChatHistory(i) = sChatHistory(i - 1)
    Next
    
    sChatHistory(0) = sLine & Chr(0)
    

    For i = 0 To cChatLineCount - 1
        WriteString lAddrChat + i * cChatLineLen, sChatHistory(i)
    Next
End Sub

Public Sub ShowSayTextbox()
    WriteByte lAddrShowSay, 1
End Sub

Public Sub HideSayTextbox()
    WriteByte lAddrShowSay, 0
End Sub

Public Sub Say(sLine As String)
    AddChatLine sLine
    HideSayTextbox
End Sub

Public Sub SetSayText(ByVal sText As String)
    If Len(sText) > cChatLineLen Then
        sText = Mid(sText, 1, cChatLineLen)
    End If
    
    sText = sText & Chr(0)
    WriteString lAddrSay, sText
End Sub

Public Sub SetSizes()
    lSizeofPlayer = 4 + 4 + 4 + 1 + 1 + 1 + (16 + 1) + 4
End Sub

Public Function BytesToLong(ByVal sBytes As String) As Long
    Dim l As Long, i As Integer
    
    BytesToLong = 0
    
    If Len(sBytes) < 4 Then
        Exit Function
    End If
    
    l = 0
    
    For i = 4 To 1 Step -1
        l = l * 256 + Asc(Mid(sBytes, i, 1))
    Next
    
    BytesToLong = l
End Function

Public Function WriteBytes(ByVal Addr As Long, Buffer() As Byte, Optional Offset As Long = 0) As Boolean
    On Error Resume Next
    Dim lProcess As Long, r As Long
    
    Addr = Offset + Addr
    'lProcess = OpenProcess(PROCESS_READ_WRITE_QUERY, False, p.ID)
    r = VirtualProtectEx(GameData.ProcessID, ByVal Addr, UBound(Buffer) + 1, PAGE_READWRITE, 0)
    r = WriteProcessMemory(GameData.ProcessID, ByVal Addr, Buffer(0), UBound(Buffer) + 1, 0&)
    'CloseHandle lProcess
    
    WriteBytes = (r = 1)
End Function

Public Function WriteByte(ByVal Addr As Long, value As Byte, Optional Offset As Long = 0) As Boolean
    On Error Resume Next
    Dim lProcess As Long, r As Long
    
    Addr = Offset + Addr
    'lProcess = OpenProcess(PROCESS_READ_WRITE_QUERY, False, p.ID)
    r = VirtualProtectEx(GameData.ProcessID, ByVal Addr, 1, PAGE_READWRITE, 0)
    r = WriteProcessMemory(GameData.ProcessID, ByVal Addr, value, 1, 0)
    'CloseHandle GameData.ProcessID
    
    WriteByte = (r = 1)
End Function

Public Function WriteInt(ByVal Addr As Long, value As Integer, Optional Offset As Long = 0) As Boolean
    On Error Resume Next
    Dim r As Long
    
    Addr = Offset + Addr
    r = VirtualProtectEx(GameData.ProcessID, ByVal Addr, 2, PAGE_READWRITE, 0)
    r = WriteProcessMemory(GameData.ProcessID, ByVal Addr, value, 2, 0)
    CloseHandle lProcess
    
    WriteInt = (r = 1)
End Function

Public Function WriteLong(ByVal Addr As Long, value As Long, Optional Offset As Long = 0) As Boolean
    On Error Resume Next
    Dim r As Long
    
    Addr = Offset + Addr
    ''lProcess = OpenProcess(PROCESS_READ_WRITE_QUERY, False, p.ID)
    r = VirtualProtectEx(GameData.ProcessID, ByVal Addr, 4, PAGE_READWRITE, 0)
    r = WriteProcessMemory(GameData.ProcessID, ByVal Addr, value, 4, 0)
    'CloseHandle lProcess
    
    WriteLong = (r = 1)
End Function

Public Function WriteFloat(ByVal Addr As Long, value As Single, Optional Offset As Long = 0) As Boolean
    On Error Resume Next
    Dim lProcess As Long, r As Long
    
    Addr = Offset + Addr
    ''lProcess = OpenProcess(PROCESS_READ_WRITE_QUERY, False, p.ID)
    r = VirtualProtectEx(GameData.ProcessID, ByVal Addr, 4, PAGE_READWRITE, 0)
    r = WriteProcessMemory(GameData.ProcessID, ByVal Addr, value, 4, 0)
    CloseHandle lProcess
    
    WriteFloat = (r = 1)
End Function

Public Function WriteString(ByVal Addr As Long, value As String, Optional Offset As Long = 0) As Boolean
    On Error Resume Next
    Dim i As Long
    
    For i = 1 To Len(value)
        WriteByte Addr + i - 1, Asc(Mid(value, i, 1)), Offset
    Next
End Function

Public Sub UpdatePlayers()
    Dim i As Long
    Dim ii As Integer
    Dim Math As Long

    If Not GameData.Checks.VehiclesSpawned Then Exit Sub
    
    lNumPlayers = GetNumberOfActivePlayers
    

    WriteLong lAddrNumPlayers, lNumPlayers
    
    For i = 0 To 31
        If ClientData.Players(i).Nickname <> "" Then
            'ClientData.Players(1).Nickname = "BLEH!"
            Math = (GameData.PlayerPointer + ((i + 1) * CLng(1988)))
            If ReadMemoryFLOAT(Math + &H540) > 0 Then
                ClientData.Players(i).lAddr = Math
                
                If i + 1 = ClientData.ConnectionID Then
                    ClientData.Players(i).cB = 0
                    ClientData.Players(i).cG = 0
                    ClientData.Players(i).cR = 255
                    'ClientData.Players(i).lAddr = 0
                End If
                
                SetPlayer CLng(ii), i + 1, ClientData.Players(i).lRank, ClientData.Players(i).lAddr, ClientData.Players(i).cR, ClientData.Players(i).cG, ClientData.Players(i).cB, ClientData.Players(i).Nickname, ClientData.Players(i).Cash
                ii = ii + 1
            End If
        End If
    Next
End Sub

Public Sub SetPlayer(lID As Long, lRconID As Long, lRank As Long, lPedAddr As Long, cR As Byte, cG As Byte, cB As Byte, sPlayerName As String, lScore As Long)
    Dim lAddr As Long
    
    lAddr = lAddrPlayers + (lID * lSizeofPlayer)
    
    WriteLong lAddr, lRconID
    WriteLong lAddr, lRank, 4
    WriteLong lAddr, lPedAddr, 8
    WriteByte lAddr, cR, 12
    WriteByte lAddr, cG, 13
    WriteByte lAddr, cB, 14
    WriteString lAddr, sPlayerName & Chr(0), 15
    WriteLong lAddr, lScore, 16 + 16
End Sub

Function CheckKey(lKey As Long) As Boolean
    CheckKey = (GetAsyncKeyState(lKey) <> 0)
End Function


