Attribute VB_Name = "mod_Public_GTAHOOK_Types"
'Code is COPYRIGHT AlienX Software  2000-2006 - all rights reserved
'Please ASK to use this code - its only polite
'Email: AlienX@AlienXSoftware.co.uk (Also MSN Enabled)
Option Explicit

Public LastOperation As String

Public FootData As FootData
Public VehicleData(400 To 611) As VehicleData
Public GameData As GameData
Public ClientData As ClientData
Public ChatHookData As ChatHookData
Public Script As Script
Public PLAYERSTATES As PLAYERSTATES
Public FreezeData As FreezeData
Public Vehicles(0 To 5000) As ScriptVehicleData
Public LiveVehicles(0 To 5000) As ScriptVehicleData
Public PlayerState As PLAYERSTATES
Public InfoLoaded As Boolean

Public Enum ENUM_ANIMATION
    Finger = 1
    HandsUp = 2
    Cower = 3
    UseATM = 4
    LookAround = 5
    HandsCower = 6
End Enum

Public Type XYZVertex
    x As Single
    y As Single
    Z As Single
End Type

Public Type LocationData
    x As Single
    y As Single
    Z As Single
End Type

Public Type Matrix
    X1 As Single
    Y1 As Single
    z1 As Single
    X2 As Single
    Y2 As Single
    z2 As Single
    x3 As Single
    y3 As Single
    z3 As Single
End Type

Public Type FreezeData
    Location As LocationData
    Rotation As Matrix
    SpeedX As Single
    SpeedY As Single
    SpeedZ As Single
End Type

Public Type FootData
    Location As LocationData
    Health As Single
    Angle As Single
End Type

Public Type VehicleData
    PassengerSeats As Integer
End Type

Public Type CheckData
    InVehicle As Boolean
    OnFoot As Boolean
    GameStarted As Boolean
    Spawned As Boolean
    SessionNopped As Boolean
    GameSystemAllReady As Boolean
    Passenger As Boolean
    LastOnScreenMessage As String
    VehiclesSpawned As Boolean
    NametagsEnabled As Boolean
End Type

Public Type SPAWNSYSTEMDATA
    CurrentSelectedSpawn As Integer '1 to 10
    SpawnSystemActive As Boolean
End Type

Public Type GameModeData
    GameMode As String
    GameModeName As String
    MaxScore As String
    TimeLeft As String
    TimeLimit As String
End Type

Private Type ROTATIONDATA
    X1 As Single
    Y1 As Single
    z1 As Single
    X2 As Single
    Y2 As Single
    z2 As Single
    x3 As Single
    y3 As Single
    z3 As Single
End Type

Public Enum ENUM_VEHSTATE
    Unknown = 0
    Sunk = 1
    Wrecked = 2
    Fine = 3
    NotExistant = 4
End Enum

Public Type ScriptVehicleData
    Location As LocationData
    Model As Integer
    Rotation As Integer
    Steer1 As Single
    RealRotation As ROTATIONDATA
    VehiclePointer As Long
    VehicleSpawnedInGTA As Boolean
    SCMID As Long
    Pending As Boolean
    PendingDelete As Boolean
    VehicleState As ENUM_VEHSTATE
    LastAnimation As Integer
    Recieved As Boolean
End Type

Public Type GameData
    hwnd As Long
    ProcessID As Long
    PlayerPointer As Long
    VehiclePointer As Long
    LastVehiclePointer As Long
    PlayerSpawned As Boolean
    FirstVehicle As Long
    StartedOnce As Boolean
    DefaultRadioStation As Byte
    DefaultRadioStationApplied As Boolean
    Checks As CheckData
    Weather As Byte
    WeatherText(0 To 45) As String
    WeatherLocked As Integer
    SpawnSystem As SPAWNSYSTEMDATA
    SkinsArray(1 To 32) As Long
    GameMode As GameModeData
    IsRobber As Boolean
End Type

'X1 As Single, Y1 As Single, z1 As Single, X2 As Single, Y2 As Single, z2 As Single, x3 As Single, y3 As Single, z3 As Single

Public Type SCMDATA
    SCMID As Long
    MemoryPointer As Long
    ActorSpawned As Boolean
    Pending As Boolean
    PendingTime As Integer
    PendingDelete As Boolean
    CurrentSkin As Integer
    FightState As Byte
End Type

Public Type PlayerData
    Nickname As String
    State As String
    Cash As Long
    XLoc As Single
    YLoc As Single
    lRconID As Long
    lRank As Long
    lAddr As Long
    cR As Byte
    cG As Byte
    cB As Byte
    sName As String
    lScore As Long
    ActorData As SCMDATA
    AimActorData As SCMDATA
    Dead As Boolean
    LastWeapon As Long
End Type

Public Type SKIN_DATA
    Skin_ID As Long
    Current_Skin As Long
    LastSkin As Long
End Type

Public Type ClientData
    Players(1 To 50) As PlayerData
    ConnectionID As Integer
    Nickname As String
    Servername As String
    Weather As Long
    TimeHour As Byte
    TimeMin As Byte
    VehicleCount As Integer
    VehiclesRecieved As Integer
    Connected As Boolean
    Pinged As Boolean
    FootInterval As Integer
    VehicleInterval As Integer
    ScoreBoardEnabled As Boolean
    VehiclesSpawned As Long
    MOTDURL As String
    SkinsDatabase(0 To 288) As SKIN_DATA
End Type

Public Type ChatHookData
    ChatLine1 As String
    ChatLine2 As String
    ChatLine3 As String
    ChatLine4 As String
    ChatLine5 As String
    ChatLine6 As String
    ChatLine7 As String
    ChatLine8 As String
    ChatLine9 As String
    Message As String
End Type

Public Type Script
    Spawn1 As String
    Spawn1Text As String
    Spawn2 As String
    Spawn2Text As String
    Spawn3 As String
    Spawn3Text As String
    Spawn4 As String
    Spawn4Text As String
    Spawn5 As String
    Spawn5Text As String
    Spawn6 As String
    Spawn6Text As String
    Spawn7 As String
    Spawn7Text As String
    Spawn8 As String
    Spawn8Text As String
    Spawn9 As String
    Spawn9Text As String
    Spawn10 As String
    Spawn10Text As String
    DefaultSpawn As String
    Camera As String
    Camera_Point As String
End Type

Public Enum PLAYERSTATES
    Driving = 1
    OnFoot = 2
    Passenger = 3
End Enum

Public Sub EraseSystemData()
    GameData.hwnd = 0
    GameData.ProcessID = 0
End Sub

Public Function GetNumberOfActivePlayers() As Long
Dim PlayCount As Integer
Dim i As Integer
    
    For i = 0 To 31
        If ClientData.Players(i).Nickname <> "" Then
            PlayCount = PlayCount + 1
        End If
    Next
    
    GetNumberOfActivePlayers = PlayCount
End Function

Public Sub CopySpawnedToLiveVehicles()
Dim i As Integer

    For i = 0 To 5000
        LiveVehicles(i).Location.x = Vehicles(i).Location.x
        LiveVehicles(i).Location.y = Vehicles(i).Location.y
        LiveVehicles(i).Location.Z = Vehicles(i).Location.Z
        LiveVehicles(i).Model = Vehicles(i).Model
        LiveVehicles(i).RealRotation.X1 = Vehicles(i).RealRotation.X1
        LiveVehicles(i).RealRotation.X2 = Vehicles(i).RealRotation.X2
        LiveVehicles(i).RealRotation.x3 = Vehicles(i).RealRotation.x3
        LiveVehicles(i).RealRotation.Y1 = Vehicles(i).RealRotation.Y1
        LiveVehicles(i).RealRotation.Y2 = Vehicles(i).RealRotation.Y2
        LiveVehicles(i).RealRotation.y3 = Vehicles(i).RealRotation.y3
        LiveVehicles(i).RealRotation.z1 = Vehicles(i).RealRotation.z1
        LiveVehicles(i).RealRotation.z2 = Vehicles(i).RealRotation.z2
        LiveVehicles(i).RealRotation.z3 = Vehicles(i).RealRotation.z3
        LiveVehicles(i).Rotation = Vehicles(i).Rotation
        LiveVehicles(i).SCMID = 0
        LiveVehicles(i).Steer1 = 0
        LiveVehicles(i).VehiclePointer = 0
        LiveVehicles(i).VehicleSpawnedInGTA = False
    Next
    
End Sub

Public Sub SetLastOperation(Operation As String)
Dim ff As Integer

    LastOperation = Operation
    
    'Normally writes to a file - Debugger :)
    ff = FreeFile
    Open App.Path & "\Operations.log" For Append As #ff
        Print #ff, "[" & Now & "] - " & Operation
    Close #ff
    'FrmMain.AppendChat "DEBUG[|" & Now & "|] " & Operation, RGB(0, 150, 40)
End Sub


