Attribute VB_Name = "Mod_Functions"
Option Explicit

Public Function FileExists(FilePath As String) As Boolean
'Checks if a file exists from the file path
    If LCase(Dir(FilePath)) = LCase(Mid(FilePath, InStrRev(FilePath, "\") + 1)) Then
        FileExists = True
    Else
        FileExists = False
    End If
End Function

Public Function IsPlayerConnected(PlayerName As String) As Boolean
Dim i As Integer
    For i = 1 To MAX_PLAYERS
        If Players(i).PlayerName = PlayerName Then
            IsPlayerConnected = True
            Exit Function
        End If
    Next
    
    IsPlayerConnected = False
End Function

Function FormatTime(TimeElapsed As Long) As String
   Dim Seconds As Integer
   Dim Minutes As Integer
   Dim Hours As Integer
   
   'Find The Seconds
   Seconds = TimeElapsed Mod 60
   
   'Find The Minutes
   Minutes = (TimeElapsed \ 60) Mod 60
   
   'Find The Hours
   Hours = (TimeElapsed \ 3600)
   
   'Format The Time
   If Hours > 0 Then
      FormatTime = Format(Hours, "00") & ":"
   End If
   FormatTime = Format(Hours, "00") & ":"
   FormatTime = FormatTime & Format(Minutes, "00") & ":"
   FormatTime = FormatTime & Format(Seconds, "00")
End Function
