Attribute VB_Name = "Mod_Global"
Option Explicit

Public Const AppVersion = "0.9c"
Public Const MAX_PLAYERS = 50

Public Players(1 To 50) As PlayerData
Public Server As ServerData
Public IRC As IRCData
Public Vehicles(399 To 611) As VehicleData
Public ScriptVehicles(0 To 5000) As VehicleScriptData
Public ScriptVehicleCount As Integer

Public Const PlayerState_Driving = 1
Public Const PlayerState_OnFoot = 2
Public Const PlayerState_Dead = 3
Public Const PlayerState_Passenger = 4

Private Enum Player_State
    Driving = 1
    OnFoot = 2
    Dead = 3
    Passenger = 4
End Enum

'Vehicle_2131=437:2074.7979 1014.7175 10.8052:359.8557
'VehicleID Model:X Y Z: Rotation
Private Type VehicleScriptData
    Model As String
    X As String
    Y As String
    Z As String
    Rotation As String
    Health As Single
End Type

Public Type PlayerData
    PlayerName As String
    ServerID As Integer
    LoginName As String
    Port As Long
    IP As String
    Ponged As Boolean
    Connected As Boolean
    Score As Long
    CurrentPlayerState As Player_State
    LastVehicleID As Integer
End Type

Public Type GameTimeData
    Hour As Byte
    Minute As Byte
End Type

Public Type IRCData
    Enabled As Boolean
    Server As String
    Port As String
    Nick As String
    Channel As String
    Key As String
End Type

Public Type GameModeData
    GameMode As String
    Settings As String
    Time As String
End Type

Public Type ChatLines
    Line1 As String
    Line2 As String
    Line3 As String
    Line4 As String
    Line5 As String
    Line6 As String
End Type

Public Type ServerData
    GameMode As GameModeData
    ServerName As String
    ServerPort As String
    FootInterval As Integer
    VehicleInterval As Integer
    GameTime As GameTimeData
    MaxPlayers As Integer
    ScriptPath As String
    Weather As Integer
    LockWeather As Integer
    RconPassword As String
    ChatHistory As ChatLines
    MOTDURL As String
End Type

Public Type VehicleData
    VehicleName As String
End Type

Public Sub AppendChatHistory(ChatLine)

    Server.ChatHistory.Line1 = Server.ChatHistory.Line2
    Server.ChatHistory.Line2 = Server.ChatHistory.Line3
    Server.ChatHistory.Line3 = Server.ChatHistory.Line4
    Server.ChatHistory.Line4 = Server.ChatHistory.Line5
    Server.ChatHistory.Line5 = Server.ChatHistory.Line6
    Server.ChatHistory.Line6 = ChatLine

End Sub

Public Sub AppSleep(Time As Single)
Dim t As Single

    t = Timer
    Do While Timer < (t + Time)
        DoEvents
    Loop

End Sub
