Attribute VB_Name = "Mod_Ini"
'+------------------------------------------------------------------+
'| Copyright  2000-2006 AlienX Software - www.alienxsoftware.co.uk |
'|           Mark Phillips AlienX@AlienXSoftware.co.uk              |
'+------------------------------------------------------------------+

'****************************************************
'* INI_sm.BAS                                     *
'****************************************************
Option Explicit

'Check windows version
#If Win16 Then
        Declare Function WritePrivateProfileString Lib "Kernel" (ByVal AppName As String, ByVal KeyName As String, ByVal NewString As String, ByVal filename As String) As Integer
        Declare Function GetPrivateProfileString Lib "Kernel" Alias "GetPrivateProfilestring" (ByVal AppName As String, ByVal KeyName As Any, ByVal default As String, ByVal ReturnedString As String, ByVal MAXSIZE As Integer, ByVal filename As String) As Integer
#Else
        Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
        Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Any, ByVal lpFileName As String) As Long
#End If

'*Returns a string from an INI file.
Function GetFromINI(Section, KeyName, filename As String) As String
        Dim sRet As String
        sRet = String(255, Chr(0))
        GetFromINI = Left(sRet, GetPrivateProfileString(Section, ByVal KeyName, "", sRet, Len(sRet), filename))
End Function

'*Writes a string to an INI file.
Function WriteToINI(sSection As String, sKeyName As String, sNewString As Variant, sFileName) As Integer
        Dim R
        R = WritePrivateProfileString(sSection, sKeyName, CStr(sNewString), sFileName)
End Function

