VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCommands"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Sub LoadScript(Filename As String, StartSub As String)
Dim RealFileName As String
    Filename = Replace(Filename, App.Path, "")
    If InStr(1, Filename, "\") > 0 Then
        RealFileName = Mid(Filename, InStrRev(Filename, "\") + 1)
    Else
        RealFileName = Filename
    End If
    SendIRCMessage "Loading Script: " & RealFileName
    MyScript.ReadInCode App.Path & Filename, RealFileName, MyScript.SControl, False
    MyScript.SControl.Modules(RealFileName).Run StartSub
End Sub

Public Sub SetGameTime(Hour As Variant, Min As Variant)
    Server.GameTime.Hour = Hour
    Server.GameTime.Minute = Min
End Sub

'INI Stuff
Public Sub IOWriteINI(Section As Variant, Key As Variant, Value As Variant, Filename As Variant)
    Filename = App.Path & "\" & Filename
    WriteToINI CStr(Section), CStr(Key), Value, Filename
End Sub

Public Function IOReadINI(Section As Variant, Key As Variant, Filename As Variant) As Variant
    Filename = App.Path & "\" & Filename
    IOReadINI = GetFromINI(Section, Key, CStr(Filename))
    
End Function

Public Function GetInstalledPath() As Variant
    GetInstalledPath = App.Path
End Function

Public Sub DoTheEvents()
    DoEvents
End Sub

Public Sub SendMessageToPlayer(PlayerID As Variant, ChatMessage As Variant, Optional Red As Variant = 255, Optional Green As Variant = 255, Optional Blue As Variant = 255)
    FrmServer.SendData "M2A" & Chr(10) & Red & Chr(10) & Green & Chr(10) & Blue & Chr(10) & ChatMessage, CInt(PlayerID), True
End Sub

Public Sub SendMessageAll(Message As Variant, Optional Red As Variant = 255, Optional Green As Variant = 255, Optional Blue As Variant = 255)
    FrmServer.SendData "M2A" & Chr(10) & Red & Chr(10) & Green & Chr(10) & Blue & Chr(10) & Message
End Sub

Public Sub SendMessageToAll(Message As Variant, Optional Red As Variant = 255, Optional Green As Variant = 255, Optional Blue As Variant = 255)
    FrmServer.SendData "M2A" & Chr(10) & Red & Chr(10) & Green & Chr(10) & Blue & Chr(10) & Message
End Sub

Public Sub KillFile(FilePath As String)
Dim FP As String
    FP = App.Path & "\" & FilePath
    
    If Len(Dir(FP)) > 0 Then
        Kill FP
    End If
End Sub

Public Sub SendIRCMessage(Message As Variant)
    FrmServer.IRCClient.PrivMSG IRC.Channel, CStr(Message)
End Sub

Public Function GetPlayerName(PlayerID As Variant) As Variant
    If PlayerID > 32 Or PlayerID < 0 Then Exit Function
    GetPlayerName = Players(PlayerID).PlayerName
End Function

Public Function GetPlayerVehicle(PlayerID As Variant) As Variant
    GetPlayerVehicle = Players(PlayerID).LastVehicleID
End Function

Public Function GetPlayerLevel(PlayerID As Variant) As Variant
    GetPlayerLevel = PlayerLogins(Players(PlayerID).ServerID).Level
End Function

Public Sub SetPlayerLevel(PlayerID As Variant, Level As Variant)
    If CInt(Val(Level)) > 60 Then
        Level = 60
    End If
    
    PlayerLogins(Players(PlayerID).ServerID).Level = CLng(Level)
    FrmServer.SendData "SCR" & Chr(10) & "PLVL" & Chr(10) & PlayerLogins(Players(PlayerID).ServerID).Level, CInt(PlayerID), True
End Sub

Public Function GetPlayerXP(PlayerID As Variant) As Variant
    GetPlayerXP = PlayerLogins(Players(PlayerID).ServerID).XP
End Function

Public Sub SetPlayerXP(PlayerID As Variant, XP As Variant)
    PlayerLogins(Players(PlayerID).ServerID).XP = CLng(XP)
    FrmServer.SendData "SCR" & Chr(10) & "PXP" & Chr(10) & XP
End Sub

Public Function IsPlayerAdmin(PlayerID As Variant) As Boolean
    If PlayerLogins(Players(PlayerID).ServerID).Admin = True Then IsPlayerAdmin = True Else IsPlayerAdmin = False
End Function

Public Sub KillPlayer(PlayerID As Variant)
    FrmServer.SendData "SCR" & Chr(10) & "KIL", CInt(PlayerID), True
End Sub

Public Sub KickPlayer(PlayerID As Variant)
    FrmServer.SendData "SCR" & Chr(10) & "KICK"
    FrmServer.EraseClient CInt(PlayerID)
End Sub

Public Sub BanPlayer(PlayerID As Variant)
    SaveBan Players(PlayerID).IP, Players(PlayerID).PlayerName
    PlayerLogins(Players(PlayerID).ServerID).Banned = True
    SavePlayerLogins
    FrmServer.SendData "SCR" & Chr(10) & "BAN"
End Sub

Public Function GetPlayerID(PlayerName As Variant) As Variant
Dim i As Integer
Dim pID As Variant

    pID = -1
    For i = 1 To MAX_PLAYERS
        If Players(i).PlayerName = PlayerName Then
            pID = i
            Exit Function
        End If
    Next
    
    GetPlayerID = pID
    
End Function

Public Function GetPlayerIDFromPartName(PlayerName As Variant) As Variant
Dim i As Integer
Dim pID As Variant
Dim iFound As Integer

    pID = -1
    For i = 1 To MAX_PLAYERS
        If InStr(1, LCase(Players(i).PlayerName), LCase(PlayerName)) > 0 Then
            pID = i
            iFound = iFound + 1
        End If
    Next
    
    If iFound > 1 Then
        'More than 1 found
        GetPlayerIDFromPartName = -2
    ElseIf iFound = 0 Then
        'None found
        GetPlayerIDFromPartName = -1
    Else
        '
        GetPlayerIDFromPartName = pID
    End If

End Function

Public Function GetPlayerCount() As Variant
Dim i As Integer
Dim Count As Integer

    For i = 0 To 32
        If Players(i).Connected Then Count = Count + 1
    Next
        
    GetPlayerCount = Count
End Function

Public Function GetPlayerLocation(PlayerID As Variant) As Variant
Dim Data(2) As Variant
    
    If IsPlayerDriving(PlayerID) Then
        Data(0) = ScriptVehicles(Players(PlayerID).LastVehicleID).X
        Data(1) = ScriptVehicles(Players(PlayerID).LastVehicleID).Y
        Data(2) = ScriptVehicles(Players(PlayerID).LastVehicleID).Z
    Else
        Data(0) = PlayerLogins(Players(PlayerID).ServerID).GameData.CurrentX
        Data(1) = PlayerLogins(Players(PlayerID).ServerID).GameData.CurrentY
        Data(2) = PlayerLogins(Players(PlayerID).ServerID).GameData.CurrentZ
    End If

    GetPlayerLocation = Data()

End Function

Public Function IsPlayerDriving(PlayerID As Variant) As Boolean
    If PlayerID > 0 Then
        If PlayerID < 51 Then
            If Players(PlayerID).CurrentPlayerState = PlayerState_Driving Then
                IsPlayerDriving = 1
            Else
                IsPlayerDriving = 0
            End If
        Else
            IsPlayerDriving = 0
        End If
    Else
        IsPlayerDriving = 0
    End If
End Function

Public Sub CreateTimer(Filename As Variant, TimerName As Variant, Interval As Variant)

    If Interval > 60000 Then
        MsgBox "Timer " & TimerName & " in file " & Filename & " error: Interval exceeds 60000", vbCritical, "Script Error"
        Exit Sub
    End If
    
    If ScriptTimers.ScriptTimerCount = 0 Then
        ScriptTimersUsed = True
        ReDim Preserve ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount)
        ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount).Filename = Filename
        ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount).Interval = Interval
        ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount).TimerName = TimerName
                
        Set ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount).TheTimer = FrmServer.ScriptTimer(ScriptTimers.ScriptTimerCount)
        ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount).TheTimer.Interval = ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount).Interval
        ScriptTimers.ScriptTimerCount = ScriptTimers.ScriptTimerCount + 1
    Else
        ScriptTimersUsed = True
        ReDim Preserve ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount)
        ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount).Filename = Filename
        ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount).Interval = Interval
        ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount).TimerName = TimerName
        
        'Make a new timer.
        Load FrmServer.ScriptTimer(ScriptTimers.ScriptTimerCount)
        Set ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount).TheTimer = FrmServer.ScriptTimer(ScriptTimers.ScriptTimerCount)
        ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount).TheTimer.Interval = ScriptTimers.TheTimers(ScriptTimers.ScriptTimerCount).Interval
        ScriptTimers.ScriptTimerCount = ScriptTimers.ScriptTimerCount + 1
    End If
End Sub

Public Sub DestroyTimer(TimerName As Variant)
Dim i As Integer
Dim FoundID As Integer

    FoundID = -1
    For i = 0 To ScriptTimers.ScriptTimerCount
        If ScriptTimers.TheTimers(i).TimerName = TimerName Then
            FoundID = i
            Exit For
        End If
    Next
    
    If FoundID = -1 Then
        MsgBox "Error in Destroy Timer: " & TimerName & " does not exist!"
    Else
        ScriptTimers.TheTimers(FoundID).TheTimer.Interval = 0
    End If
End Sub

Public Sub CreateGlobalVariable(VariableName As Variant, InitValue As Variant)
Dim i As Integer
Dim FoundID As Integer

    If ScriptGlobalVars.ScriptGlobalVarsCount = -1 Then
        FoundID = -1
    End If

    If ScriptGlobalVars.ScriptGlobalVarsCount <> -1 Then
        
        FoundID = -1
        For i = 0 To ScriptGlobalVars.ScriptGlobalVarsCount
            If ScriptGlobalVars.xScriptGlobalVars(i).VarName = VariableName Then
                FoundID = i
                Exit For
            End If
        Next
        
    End If
    
    If FoundID = -1 Then
        'It does not exist, lets make a new one!
        ScriptGlobalVars.ScriptGlobalVarsCount = ScriptGlobalVars.ScriptGlobalVarsCount + 1
        ScriptGlobalVars.xScriptGlobalVars(ScriptGlobalVars.ScriptGlobalVarsCount).VarName = VariableName
        ScriptGlobalVars.xScriptGlobalVars(ScriptGlobalVars.ScriptGlobalVarsCount).Value = InitValue
    Else
        'The Variable Allready Exists, Just edit it with the new value they want.
        SetGlobalVariable VariableName, InitValue
    End If

End Sub

Public Sub SetGlobalVariable(VariableName As Variant, NewValue As Variant)
Dim FoundID As Integer
Dim i As Integer

    If ScriptGlobalVars.ScriptGlobalVarsCount <> -1 Then
        
        FoundID = -1
        For i = 0 To ScriptGlobalVars.ScriptGlobalVarsCount
            If ScriptGlobalVars.xScriptGlobalVars(i).VarName = VariableName Then
                FoundID = i
                Exit For
            End If
        Next

        If FoundID > -1 Then
            ScriptGlobalVars.xScriptGlobalVars(FoundID).Value = NewValue
        End If

    End If
End Sub

Public Function ExistGlobalVariable(VariableName As Variant) As Boolean
Dim FoundID As Integer
Dim i As Integer

    If ScriptGlobalVars.ScriptGlobalVarsCount = -1 Then
        ExistGlobalVariable = False
        Exit Function
    End If

    If ScriptGlobalVars.ScriptGlobalVarsCount <> -1 Then
        
        FoundID = -1
        For i = 0 To ScriptGlobalVars.ScriptGlobalVarsCount
            If ScriptGlobalVars.xScriptGlobalVars(i).VarName = VariableName Then
                FoundID = i
                Exit For
            End If
        Next
        
        If FoundID > -1 Then ExistGlobalVariable = True
        
    Else
        ExistGlobalVariable = False
    End If

End Function

Public Function GetGlobalVariable(VariableName As Variant) As Variant
Dim FoundID As Integer
Dim i As Integer

    If ScriptGlobalVars.ScriptGlobalVarsCount <> -1 Then
        
        FoundID = -1
        For i = 0 To ScriptGlobalVars.ScriptGlobalVarsCount
            If ScriptGlobalVars.xScriptGlobalVars(i).VarName = VariableName Then
                FoundID = i
                Exit For
            End If
        Next
        
        If FoundID > -1 Then
            GetGlobalVariable = ScriptGlobalVars.xScriptGlobalVars(FoundID).Value
            Debug.Print "GLB_VAR_GET " & VariableName & " IS " & ScriptGlobalVars.xScriptGlobalVars(FoundID).Value
        Else
            GetGlobalVariable = ""
        End If
    End If
End Function

Public Sub Reboot_Scripts()
    SendMessageAll "Reloading Scripts On Request", 150, 150, 0
    'FrmServer.LoadAndInitScripts
    'SendMessageAll "Scripts Reloaded", 150, 150, 0
End Sub

Public Function GetVehicleNameByID(VehicleID As Variant) As Variant
    
    If VehicleID > ScriptVehicleCount Then
        GetVehicleNameByID = "Unknown Vehicle"
        Exit Function
    End If
    
    If VehicleID < 0 Then
        GetVehicleNameByID = "Unknown Vehicle"
        Exit Function
    End If

    GetVehicleNameByID = Vehicles(ScriptVehicles(VehicleID).Model).VehicleName
End Function

Public Function GetVehicleModelByID(VehicleID As Variant) As Variant
    If VehicleID > ScriptVehicleCount Then
        GetVehicleModelByID = "0"
        Exit Function
    End If
    
    If VehicleID < 0 Then
        GetVehicleModelByID = "0"
        Exit Function
    End If
    
    GetVehicleModelByID = ScriptVehicles(VehicleID).Model
End Function

Public Function GetVehicleHealth(VehicleID As Variant) As Variant
    If VehicleID > ScriptVehicleCount Then
        GetVehicleHealth = "0"
        Exit Function
    End If
    
    If VehicleID < 0 Then
        GetVehicleHealth = "0"
        Exit Function
    End If
    
    GetVehicleHealth = ScriptVehicles(VehicleID).Health
End Function

Public Function GetVehicleCount() As Variant
    GetVehicleCount = ScriptVehicleCount
End Function

Public Function GetDistanceBetween2Points(aX As Variant, aY As Variant, aZ As Variant, bX As Variant, bY As Variant, bZ As Variant) As Variant
Dim dX As Single
Dim dy As Single
Dim dZ As Single

    dX = (CSng(aX) - CSng(bX))
    dy = (CSng(aY) - CSng(bY))
    dZ = (CSng(aZ) - CSng(bZ))
    
    GetDistanceBetween2Points = Sqr(dX * dX + dy * dy + dZ * dZ)
End Function

Public Sub SetPlayerLocation(PlayerID As Variant, X As Variant, Y As Variant, Z As Variant)
    FrmServer.SendData "SCR" & Chr(10) & "MOV" & Chr(10) & X & Chr(10) & Y & Chr(10) & Z, CInt(PlayerID), True
End Sub

Public Sub SetPlayerGlobalTimer(PlayerID As Variant, TimerInterval As Variant)
    FrmServer.SendData "SCR" & Chr(10) & "GLT" & Chr(10) & TimerInterval
End Sub

Public Function GetVehicleModel(VehicleID As Variant) As Variant
    GetVehicleModel = ScriptVehicles(VehicleID).Model
End Function

Public Sub CreateSphereMarker(PlayerID As Variant, Filename As Variant, ProcedureName As Variant, Spherename As Variant, X As Variant, Y As Variant, Z As Variant, Radius As Variant)
    CreateSphere CInt(PlayerID), CStr(Filename), CStr(ProcedureName), CStr(Spherename), CSng(X), CSng(Y), CSng(Z), CSng(Radius)
End Sub

Public Sub DestroySphereMarker(PlayerID As Variant, Spherename As Variant)
    ScriptSpheres.DestroySphere CInt(PlayerID), CStr(Spherename)
End Sub

Public Sub ExecuteExternalSub(Filename As Variant, Subname As Variant, Optional Param1 As Variant = "NIL", Optional Param2 As Variant = "NIL", Optional Param3 As Variant = "NIL", Optional Param4 As Variant = "NIL", Optional Param5 As Variant = "NIL")
Dim Data(4) As Variant
    Data(0) = Param1
    Data(1) = Param2
    Data(2) = Param3
    Data(3) = Param4
    Data(4) = Param5
    MyScript.SControl.Modules(Filename).Run Subname, Data()
End Sub

Public Function IsPlayerInSphere(PlayerID As Variant, Spherename As Variant) As Boolean
Dim i As Integer
    IsPlayerInSphere = ScriptSpheres.IsPlayerInSphere(PlayerID, Spherename)
End Function

Public Function FileExists(Filename As Variant) As Boolean
    If Len(Dir(Filename)) > 0 Then
        FileExists = True
    Else
        FileExists = False
    End If
End Function

Public Function Validate(Whatever As Variant) As Double
    Validate = Val(Whatever)
End Function

Public Sub SendOnscreenMessage(PlayerID As Variant, Message As Variant, Time As Variant)
Dim i As Integer

    '0SCR| 1OSM| 2TIME| 3MESSAGE
    If CStr(PlayerID) = "255" Then
        FrmServer.SendData "SCR" & Chr(10) & "OSM" & Chr(10) & Time & Chr(10) & Message
    Else
        FrmServer.SendData "SCR" & Chr(10) & "OSM" & Chr(10) & Time & Chr(10) & Message, CInt(PlayerID), True
    End If

End Sub

'MarkerColourMarkerIDColourID - Sets the colour of MarkerID. Colour is an int from 0/1 to something.

'MaxSpeedLimitMaxSpeed - This sets a speed to check if any vehicle is exceeding. To deactivate set to 999
Public Sub SetMaxSpeedLimit(PlayerID As Variant, MaxSpeed As Variant)
    
End Sub

'MinSpeedLimitMinSpeed - Minimum speed to check if a vehcile speed drops below. E.G. Set to 20, car drops to 19mph and it signals the client.
'CreatePropertyPickupXYZPrice - Creates a buy property pickup marker at X Y Z and puts the price above the marker. Detection can be same as spheres
'DestroyPickupPickupID - Destroys the pickup specified
'CreatePickupModelIDXYZ - Creates a pickup with modelID as the icon at X Y Z
'CreateWeaponPickupModelIDXYZAmmo - Creates a weapon pickup at X Y Z with the ammo specified
'CreateCheckpointServerIDTypeXYZX1Y1Z1Size - Creates a checkpoint of Type. If type has an arrow it will point to X1 Y1 Z1. Also includes a marker
'DestroyCheckpointCheckpointIDMarkerID - Destroys a checkpoint (DUH)
'ESCMplay_soundSoundID - Plays a sound
'ESCMrepair_carCarID - Repairs a car
'ESCMexplode_carCarID - Makes a car explode
'ESCMset_car_door_statusCarIDStatus - Sets the door status of a car. Can lock doors
'ESCMopen_garageGarageID - Opens a garage
'ESCMclose_garageGarageID - Closes a garage
'ESCMset_garage_typeGarageIDType - Sets a garage type


