Attribute VB_Name = "Mod_SUBMAIN"
Public Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long
Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public SERVER_District_IP As String
Public SERVER_District_PORT As String
Public WeaponIDtoModelID(1 To 46) As Integer
Public WeaponIDtoName(1 To 46) As String
Public WeaponModelIDtoID(321 To 372) As Integer
Public Const MAX_HEIGHT_AIMS = 100
Public PlayerLevelXPValues(1 To 60) As Long
Public m_iCamIndex As Integer
Private Type WeaponAims_TYPE
    Model As Integer
    Distance As Single
    Angle As Single
    Height As Single
    HeightMultiplier As Single
    CrouchHeight As Single
    CrouchHeightMultiplier As Single
End Type

Private Type Weapon_Cam_TYPE
    fCamVert As Single
    fHeightFromCam As Single
End Type

Public WeaponCam() As Weapon_Cam_TYPE
Public WeaponAims(0 To 100) As WeaponAims_TYPE


Public Sub newCWeaponAim(iModel As Integer, Distance As Single, Angle As Single, Height As Single, HeightMultiplier As Single, CrouchHeight As Single, CrouchHeightMultiplier As Single)
    WeaponAims(WeaponModelIDtoID(iModel)).Angle = Angle
    WeaponAims(WeaponModelIDtoID(iModel)).CrouchHeight = CrouchHeight
    WeaponAims(WeaponModelIDtoID(iModel)).CrouchHeightMultiplier = CrouchHeightMultiplier
    WeaponAims(WeaponModelIDtoID(iModel)).Distance = Distance
    WeaponAims(WeaponModelIDtoID(iModel)).Height = Height
    WeaponAims(WeaponModelIDtoID(iModel)).HeightMultiplier = HeightMultiplier
    WeaponAims(WeaponModelIDtoID(iModel)).Model = iModel
End Sub

Public Sub Main()
Dim ff As Integer
Dim Buffer As String
Dim splitdata() As String
Dim i As Integer

    If Not DoesFileExist(App.Path & "\gta_sa.exe") Then
        MsgBox "Unable to find GTA_SA.exe, make sure this is installed in your GTA:SA directory!", vbCritical, "Error"
        End
    End If

    If Not DoesFileExist(App.Path & "\Districtlist.cfg") Then
        MsgBox "Unable to find Districtlist.cfg, please reinstall RPGAndreas", vbCritical, "Critical File Missing"
        End
    End If

    'Load the default District server ip etc.
    ff = FreeFile
    Open App.Path & "\Districtlist.cfg" For Input As #ff
        Line Input #ff, Buffer
    Close #ff
    
    splitdata = Split(Buffer, ":")
    SERVER_District_IP = splitdata(0)
    SERVER_District_PORT = splitdata(1)
    
    AddWeapon 1, 331, "Brass Knuckles"
    AddWeapon 2, 333, "Golf Club"
    AddWeapon 3, 334, "Nitestick"
    AddWeapon 4, 335, "Knife"
    AddWeapon 5, 336, "Baseball Bat"
    AddWeapon 6, 337, "Shovel"
    AddWeapon 7, 338, "Katana"
    AddWeapon 8, 339, "Pool Cue"
    AddWeapon 9, 341, "Chainsaw"    'Chainsaw
    AddWeapon 10, 321, "Dildo"   'Dildo 1
    AddWeapon 11, 322, "Dildo"  'Dildo 2
    AddWeapon 12, 323, "Vibrator"   'Vibe 1
    AddWeapon 13, 324, "Vibrator"   'Vibe 2
    AddWeapon 14, 325, "Flowers"   'Flowers
    AddWeapon 15, 326, "Cane"   'Cane
    AddWeapon 16, 342, "Grenade"   'Grenade
    AddWeapon 17, 343, "Teargas"  'Teargas
    AddWeapon 18, 344, "Molotov Cocktail"   'Molotov Cocktail
    AddWeapon 22, 346, "Pistol"   'Pistol
    AddWeapon 23, 347, "Silenced Pistol"   'Silenced Pistol
    AddWeapon 24, 348, "Desert Eagle"   'Desert Eagle
    AddWeapon 25, 349, "Shotgun"   'Shotgun
    AddWeapon 26, 350, "Sawn-Off Shotgun"   'Sawn-Off Shotgun
    AddWeapon 27, 351, "SPAZ-12"   'SPAZ12
    AddWeapon 28, 352, "Micro UZI"   'Micro UZI
    AddWeapon 29, 353, "MP5"   'MP5
    AddWeapon 30, 355, "AK47"   'AK47
    AddWeapon 31, 356, "M4"  'M4
    AddWeapon 32, 372, "TEK-9"   'Tech9
    AddWeapon 33, 357, "Country Rifle"   'Country Rifle
    AddWeapon 34, 358, "Sniper Rifle"   'Sniper Rifle
    AddWeapon 35, 359, "Rocket Launcher"   'Rocket Launcher
    AddWeapon 36, 360, "Heat Seaking RPG"   'Heat Seaking RPG
    AddWeapon 37, 361, "Flame Thrower"   'Flame Thrower
    AddWeapon 38, 362, "Minigun"   'Minigun
    AddWeapon 39, 363, "Remote Explosive"   'Remote Explosives
    AddWeapon 40, 364, "Detonator"   'Detonator(for remote explosives)
    AddWeapon 41, 365, "Spray Can"   'Spray Can
    AddWeapon 42, 366, "Fire Extinguisher"   'Fire Extinguisher
    AddWeapon 43, 367, "Camera"   'Camera
    AddWeapon 44, 368, "NV Goggles"   'NV Goggles
    AddWeapon 45, 369, "IR Goggles"   'IR Goggles (CRASH)
    AddWeapon 46, 371, "Parachute"   'Parachute
    
    newCWeaponAim 342, 2, 0, 0, 0, 0, 0                    ' Grenade
    newCWeaponAim 343, 2, 0, 0, 0, 0, 0                    ' Teargas
    newCWeaponAim 344, 2, 0, 0, 0, 0, 0                    ' Molotov
    newCWeaponAim 362, 3, 4.5, 1.1, 0.63, 0, 0          ' Minigun
    newCWeaponAim 356, 0, 4.4, 0, 0.49, 0.24, 0.49     ' M4
    newCWeaponAim 349, 0, 4.4, 0, 0, 0.4, 0            ' Shotty
    newCWeaponAim 353, 0, 4.7, 0, 0, 0.3, 0            ' MP5
    newCWeaponAim 348, 0, 5.12, 0, 0, 0.37, 0              ' Desert Eagle
    newCWeaponAim 358, 0, 2, 0.8, 0.6, 0, 0             ' Sniper Rile
    newCWeaponAim 357, 0, 4.345, 0, 0, 0, 0                ' Country Rile
    newCWeaponAim 355, 0, 4.37, 0, 0.3, 0.2, 0         ' AK-47
    newCWeaponAim 352, 0, 4.5, 0, 0, 0.4, 0            ' Uzi
    newCWeaponAim 351, 0, 4.55, 0, 0, 0.5, 0           ' Spaz
    newCWeaponAim 346, 0, 4.6, 0, 0, 0.4, 0            ' Colt45
    newCWeaponAim 361, 3, 6.5, 0, 0.63, 0, 0           ' Flamer
    newCWeaponAim 359, 8, 0, 0, 0.5, 0, 0             ' Rocket Launcher
    newCWeaponAim 360, 8, 0, 0, 0.5, 0, 0             ' Heat Seaker
    newCWeaponAim 347, 0, 4.8, 0, 0, 0.4, 0                 ' Silenced Pistol
    newCWeaponAim 350, 0, 4, 0, 0, 0, 0                    ' Sawno Shotgun
    newCWeaponAim 372, 0, 4.9, 0, 0, 0, 0                   ' Tec9
    
    AddCorrectionAngle 355, 0.707107, 2.469998
    AddCorrectionAngle 355, 0.693725, 2.359998
    AddCorrectionAngle 355, 0.688304, 2.349998
    AddCorrectionAngle 355, 0.682844, 2.269998
    AddCorrectionAngle 355, 0.677345, 2.219998
    AddCorrectionAngle 355, 0.669026, 2.159998
    AddCorrectionAngle 355, 0.663433, 2.109998
    AddCorrectionAngle 355, 0.660623, 2.069999
    AddCorrectionAngle 355, 0.654974, 2.039999
    AddCorrectionAngle 355, 0.646431, 1.969999
    AddCorrectionAngle 355, 0.640691, 1.919999
    AddCorrectionAngle 355, 0.632013, 1.859999
    AddCorrectionAngle 355, 0.617372, 1.779999
    AddCorrectionAngle 355, 0.608483, 1.709999
    AddCorrectionAngle 355, 0.599517, 1.659999
    AddCorrectionAngle 355, 0.590475, 1.619999
    AddCorrectionAngle 355, 0.584406, 1.559999
    AddCorrectionAngle 355, 0.569089, 1.499999
    AddCorrectionAngle 355, 0.559803, 1.439999
    AddCorrectionAngle 355, 0.544168, 1.379999
    AddCorrectionAngle 355, 0.53786, 1.359999
    AddCorrectionAngle 355, 0.528342, 1.309999
    AddCorrectionAngle 355, 0.518758, 1.289999
    AddCorrectionAngle 355, 0.509107, 1.269999
    AddCorrectionAngle 355, 0.496139, 1.239999
    AddCorrectionAngle 355, 0.48634, 1.199999
    AddCorrectionAngle 355, 0.47648, 1.159999
    AddCorrectionAngle 355, 0.463239, 1.129999
    AddCorrectionAngle 355, 0.446542, 1.089999
    AddCorrectionAngle 355, 0.426298, 1.069999
    AddCorrectionAngle 355, 0.412682, 1.029999
    AddCorrectionAngle 355, 0.388632, 0.99
    AddCorrectionAngle 355, 0.364314, 0.97
    AddCorrectionAngle 355, 0.34327, 0.95
    AddCorrectionAngle 355, 0.322052, 0.94
    AddCorrectionAngle 355, 0.304246, 0.92
    AddCorrectionAngle 355, 0.279138, 0.89
    AddCorrectionAngle 355, 0.253839, 0.89
    AddCorrectionAngle 355, 0.228364, 0.89
    AddCorrectionAngle 355, 0.06535, 0.91
    AddCorrectionAngle 355, -0.080765, 0.96
    AddCorrectionAngle 355, -0.129241, 0.97
    AddCorrectionAngle 355, -0.166327, 0.98
    AddCorrectionAngle 355, -0.210516, 0.98
    AddCorrectionAngle 355, -0.210516, 1#
    AddCorrectionAngle 355, -0.261526, 1.01
    AddCorrectionAngle 355, -0.30825, 1.029999
    AddCorrectionAngle 355, -0.368229, 1#
    AddCorrectionAngle 355, -0.41651, 0.96
    AddCorrectionAngle 355, -0.460317, 0.94
    AddCorrectionAngle 355, -0.509499, 0.86
    AddCorrectionAngle 355, -0.525543, 0.84
    AddCorrectionAngle 355, -0.547692, 0.78
    AddCorrectionAngle 355, -0.566377, 0.74
    AddCorrectionAngle 355, -0.578675, 0.7
    AddCorrectionAngle 355, -0.590843, 0.66
    AddCorrectionAngle 355, -0.608845, 0.6
    AddCorrectionAngle 355, -0.623611, 0.57
    AddCorrectionAngle 355, -0.641041, 0.5
    AddCorrectionAngle 355, -0.652481, 0.46
    AddCorrectionAngle 355, -0.666574, 0.38
    AddCorrectionAngle 355, -0.67768, 0.33
    AddCorrectionAngle 355, -0.691349, 0.25
    AddCorrectionAngle 355, -0.699433, 0.2
    AddCorrectionAngle 355, -0.71271, 0.11
    AddCorrectionAngle 355, -0.725736, 0#
    AddCorrectionAngle 355, -0.741031, -0.14
    AddCorrectionAngle 355, -0.751019, -0.21
    AddCorrectionAngle 355, -0.765684, -0.35
    AddCorrectionAngle 355, -0.782303, -0.54
    AddCorrectionAngle 355, -0.793844, -0.669999
    AddCorrectionAngle 355, -0.807325, -0.899999
    AddCorrectionAngle 355, -0.813913, -0.949999
    AddCorrectionAngle 355, -0.828881, -1.169999
    AddCorrectionAngle 355, -0.835122, -1.279999
    AddCorrectionAngle 355, -0.847286, -1.509999
    AddCorrectionAngle 355, -0.859021, -1.779998
    AddCorrectionAngle 355, -0.868469, -1.939998
    AddCorrectionAngle 355, -0.873991, -2.089998
    AddCorrectionAngle 355, -0.881181, -2.409998
    AddCorrectionAngle 355, -0.894966, -2.849998
    AddCorrectionAngle 355, -0.901557, -3.069997
    AddCorrectionAngle 355, -0.911063, -3.489997
    AddCorrectionAngle 355, -0.917144, -3.749997
    AddCorrectionAngle 355, -0.924455, -4.069998
    AddCorrectionAngle 355, -0.93007, -4.500008
    AddCorrectionAngle 355, -0.936795, -4.880016
    AddCorrectionAngle 355, -0.944429, -5.680035
    AddCorrectionAngle 355, -0.949254, -6.160046
    AddCorrectionAngle 355, -0.954984, -6.820061
    AddCorrectionAngle 355, -0.961416, -7.500076
    AddCorrectionAngle 355, -0.96445, -7.920086
    AddCorrectionAngle 355, -0.966405, -8.220093
    AddCorrectionAngle 355, -0.969235, -8.580101
    AddCorrectionAngle 355, -0.972818, -9.000111
    AddCorrectionAngle 355, -0.976182, -9.650126
    AddCorrectionAngle 355, -0.980078, -10.810152
    AddCorrectionAngle 355, -0.986835, -12.340187
    AddCorrectionAngle 355, -0.991242, -14.400234

    AddCorrectionAngle 346, 0.707107, 3.059998
    AddCorrectionAngle 346, 0.680649, 2.889998
    AddCorrectionAngle 346, 0.665115, 2.739998
    AddCorrectionAngle 346, 0.649288, 2.589998
    AddCorrectionAngle 346, 0.633175, 2.419998
    AddCorrectionAngle 346, 0.616782, 2.269998
    AddCorrectionAngle 346, 0.591686, 2.159998
    AddCorrectionAngle 346, 0.570322, 2.009999
    AddCorrectionAngle 346, 0.544169, 1.899999
    AddCorrectionAngle 346, 0.526432, 1.799999
    AddCorrectionAngle 346, 0.508463, 1.739999
    AddCorrectionAngle 346, 0.485687, 1.619999
    AddCorrectionAngle 346, 0.457915, 1.559999
    AddCorrectionAngle 346, 0.429689, 1.469999
    AddCorrectionAngle 346, 0.405841, 1.389999
    AddCorrectionAngle 346, 0.367108, 1.329999
    AddCorrectionAngle 346, 0.342567, 1.269999
    AddCorrectionAngle 346, 0.31779, 1.259999
    AddCorrectionAngle 346, 0.282739, 1.199999
    AddCorrectionAngle 346, 0.221788, 1.159999
    AddCorrectionAngle 346, 0.180651, 1.119999
    AddCorrectionAngle 346, 0.128789, 1.119999
    AddCorrectionAngle 346, 0.097493, 1.099999
    AddCorrectionAngle 346, 0.034641, 1.099999
    AddCorrectionAngle 346, -0.351434, 1.059999
    AddCorrectionAngle 346, -0.404884, 1.029999
    AddCorrectionAngle 346, -0.44762, 0.98
    AddCorrectionAngle 346, -0.498487, 0.95
    AddCorrectionAngle 346, -0.547691, 0.82
    AddCorrectionAngle 346, -0.578062, 0.74
    AddCorrectionAngle 346, -0.615958, 0.66
    AddCorrectionAngle 346, -0.664334, 0.44
    AddCorrectionAngle 346, -0.721074, 0.08
    AddCorrectionAngle 346, -0.746044, -0.03
    AddCorrectionAngle 346, -0.770007, -0.26
    AddCorrectionAngle 346, -0.792929, -0.47
    AddCorrectionAngle 346, -0.808648, -0.669999
    AddCorrectionAngle 346, -0.820823, -0.869999
    AddCorrectionAngle 346, -0.841255, -1.229999
    AddCorrectionAngle 346, -0.855156, -1.489999
    AddCorrectionAngle 346, -0.876166, -1.929998
    AddCorrectionAngle 346, -0.888516, -2.219998
    AddCorrectionAngle 346, -0.902526, -2.729998
    AddCorrectionAngle 346, -0.91137, -3.019997
    AddCorrectionAngle 346, -0.923881, -3.549997
    AddCorrectionAngle 346, -0.933607, -4.210001
    AddCorrectionAngle 346, -0.946141, -4.980019
    AddCorrectionAngle 346, -0.955868, -5.840038
    AddCorrectionAngle 346, -0.962506, -6.640057
    AddCorrectionAngle 346, -0.969294, -7.550077
    AddCorrectionAngle 346, -0.976558, -8.440098
    AddCorrectionAngle 346, -0.979827, -9.250116
    AddCorrectionAngle 346, -0.983807, -9.930132

    AddCorrectionAngle 356, 0.707107, 2.309998
    AddCorrectionAngle 356, 0.691019, 2.199998
    AddCorrectionAngle 356, 0.682844, 2.109998
    AddCorrectionAngle 356, 0.671809, 2.009999
    AddCorrectionAngle 356, 0.657803, 1.909999
    AddCorrectionAngle 356, 0.637807, 1.769999
    AddCorrectionAngle 356, 0.614417, 1.619999
    AddCorrectionAngle 356, 0.596511, 1.519999
    AddCorrectionAngle 356, 0.578303, 1.439999
    AddCorrectionAngle 356, 0.562906, 1.349999
    AddCorrectionAngle 356, 0.54731, 1.309999
    AddCorrectionAngle 356, 0.534695, 1.259999
    AddCorrectionAngle 356, 0.512331, 1.209999
    AddCorrectionAngle 356, 0.499392, 1.149999
    AddCorrectionAngle 356, 0.479774, 1.089999
    AddCorrectionAngle 356, 0.45324, 1.039999
    AddCorrectionAngle 356, 0.426298, 1#
    AddCorrectionAngle 356, 0.392085, 0.95
    AddCorrectionAngle 356, 0.34679, 0.9
    AddCorrectionAngle 356, 0.29351, 0.87
    AddCorrectionAngle 356, 0.257464, 0.85
    AddCorrectionAngle 356, 0.076572, 0.89
    AddCorrectionAngle 356, 0.020396, 0.93
    AddCorrectionAngle 356, -0.032097, 0.96
    AddCorrectionAngle 356, -0.080765, 1#
    AddCorrectionAngle 356, -0.118077, 1.029999
    AddCorrectionAngle 356, -0.170023, 1.039999
    AddCorrectionAngle 356, -0.239745, 1.079999
    AddCorrectionAngle 356, -0.340175, 1.079999
    AddCorrectionAngle 356, -0.470275, 1.01
    AddCorrectionAngle 356, -0.506269, 0.97
    AddCorrectionAngle 356, -0.538245, 0.9
    AddCorrectionAngle 356, -0.566377, 0.84
    AddCorrectionAngle 356, -0.599882, 0.75
    AddCorrectionAngle 356, -0.620675, 0.66
    AddCorrectionAngle 356, -0.652481, 0.56
    AddCorrectionAngle 356, -0.669365, 0.48
    AddCorrectionAngle 356, -0.688634, 0.36
    AddCorrectionAngle 356, -0.704774, 0.28
    AddCorrectionAngle 356, -0.71271, 0.19
    AddCorrectionAngle 356, -0.735974, 0.04
    AddCorrectionAngle 356, -0.751019, -0.04
    AddCorrectionAngle 356, -0.763267, -0.19
    AddCorrectionAngle 356, -0.777609, -0.34
    AddCorrectionAngle 356, -0.784634, -0.42
    AddCorrectionAngle 356, -0.798383, -0.61
    AddCorrectionAngle 356, -0.807325, -0.719999
    AddCorrectionAngle 356, -0.828881, -1.079999
    AddCorrectionAngle 356, -0.837179, -1.239999
    AddCorrectionAngle 356, -0.847287, -1.369999
    AddCorrectionAngle 356, -0.855158, -1.479999
    AddCorrectionAngle 356, -0.866603, -1.849998
    AddCorrectionAngle 356, -0.877611, -2.209998
    AddCorrectionAngle 356, -0.88989, -2.439998
    AddCorrectionAngle 356, -0.901557, -2.679998
    AddCorrectionAngle 356, -0.90951, -3.329997
    AddCorrectionAngle 356, -0.917144, -3.739997
    AddCorrectionAngle 356, -0.925879, -4.089998
    AddCorrectionAngle 356, -0.932799, -4.59001
    AddCorrectionAngle 356, -0.939392, -5.03002
    AddCorrectionAngle 356, -0.945655, -5.46003
    AddCorrectionAngle 356, -0.951586, -6.090044

    AddCorrectionAngle 347, 0.703385, 3.119998
    AddCorrectionAngle 347, 0.707107, 3.209997
    AddCorrectionAngle 347, 0.688304, 2.999998
    AddCorrectionAngle 347, 0.672919, 2.819998
    AddCorrectionAngle 347, 0.653272, 2.649998
    AddCorrectionAngle 347, 0.63723, 2.479998
    AddCorrectionAngle 347, 0.616782, 2.309998
    AddCorrectionAngle 347, 0.604309, 2.219998
    AddCorrectionAngle 347, 0.591686, 2.169998
    AddCorrectionAngle 347, 0.574627, 2.039999
    AddCorrectionAngle 347, 0.561666, 1.949999
    AddCorrectionAngle 347, 0.548567, 1.879999
    AddCorrectionAngle 347, 0.526432, 1.789999
    AddCorrectionAngle 347, 0.508463, 1.699999
    AddCorrectionAngle 347, 0.499394, 1.679999
    AddCorrectionAngle 347, 0.47186, 1.559999
    AddCorrectionAngle 347, 0.434424, 1.449999
    AddCorrectionAngle 347, 0.401037, 1.349999
    AddCorrectionAngle 347, 0.357322, 1.299999
    AddCorrectionAngle 347, 0.332685, 1.259999
    AddCorrectionAngle 347, 0.287771, 1.219999
    AddCorrectionAngle 347, 0.237118, 1.159999
    AddCorrectionAngle 347, 0.201264, 1.119999
    AddCorrectionAngle 347, 0.144392, 1.139999
    AddCorrectionAngle 347, 0.087038, 1.099999
    AddCorrectionAngle 347, 0.018898, 1.099999
    AddCorrectionAngle 347, -0.070293, 1.129999
    AddCorrectionAngle 347, -0.153739, 1.099999
    AddCorrectionAngle 347, -0.230996, 1.129999
    AddCorrectionAngle 347, -0.286768, 1.109999
    AddCorrectionAngle 347, -0.366134, 1.089999
    AddCorrectionAngle 347, -0.414462, 1.039999
    AddCorrectionAngle 347, -0.466298, 0.98
    AddCorrectionAngle 347, -0.503031, 0.92
    AddCorrectionAngle 347, -0.543291, 0.85
    AddCorrectionAngle 347, -0.586598, 0.73
    AddCorrectionAngle 347, -0.615958, 0.63
    AddCorrectionAngle 347, -0.648492, 0.52
    AddCorrectionAngle 347, -0.672145, 0.38
    AddCorrectionAngle 347, -0.695131, 0.29
    AddCorrectionAngle 347, -0.710073, 0.19
    AddCorrectionAngle 347, -0.724702, 0.07
    AddCorrectionAngle 347, -0.739011, -0.02
    AddCorrectionAngle 347, -0.763684, -0.23
    AddCorrectionAngle 347, -0.777072, -0.33
    AddCorrectionAngle 347, -0.799673, -0.669999
    AddCorrectionAngle 347, -0.815157, -0.829999
    AddCorrectionAngle 347, -0.83008, -0.969999
    AddCorrectionAngle 347, -0.84443, -1.279999
    AddCorrectionAngle 347, -0.858198, -1.469999
    AddCorrectionAngle 347, -0.858198, -1.479999
    AddCorrectionAngle 347, -0.868788, -1.709998
    AddCorrectionAngle 347, -0.881486, -2.039998
    AddCorrectionAngle 347, -0.888813, -2.319998
    AddCorrectionAngle 347, -0.900535, -2.649998
    AddCorrectionAngle 347, -0.907271, -2.819998
    AddCorrectionAngle 347, -0.917997, -3.259997
    AddCorrectionAngle 347, -0.92809, -3.809997
    AddCorrectionAngle 347, -0.937543, -4.320004
    AddCorrectionAngle 347, -0.948034, -4.910017
    AddCorrectionAngle 347, -0.952927, -5.380028
    AddCorrectionAngle 347, -0.959084, -5.980042
    AddCorrectionAngle 347, -0.964818, -6.470053
    AddCorrectionAngle 347, -0.971386, -7.110067
    AddCorrectionAngle 347, -0.977285, -7.790083
    AddCorrectionAngle 347, -0.985322, -9.120113

    AddCorrectionAngle 349, -0.979326, -9.100113
    AddCorrectionAngle 349, -0.971232, -8.150091
    AddCorrectionAngle 349, -0.966018, -7.050066
    AddCorrectionAngle 349, -0.954313, -5.830038
    AddCorrectionAngle 349, -0.931713, -4.129999
    AddCorrectionAngle 349, -0.904776, -2.929997
    AddCorrectionAngle 349, -0.873625, -1.999998
    AddCorrectionAngle 349, -0.855157, -1.579999
    AddCorrectionAngle 349, -0.835533, -1.189999
    AddCorrectionAngle 349, -0.80555, -0.77
    AddCorrectionAngle 349, -0.776664, -0.49
    AddCorrectionAngle 349, -0.752996, -0.17
    AddCorrectionAngle 349, -0.742539, -0.04
    AddCorrectionAngle 349, -0.717428, 0.07
    AddCorrectionAngle 349, -0.687546, 0.25
    AddCorrectionAngle 349, -0.640465, 0.53
    AddCorrectionAngle 349, -0.611815, 0.67
    AddCorrectionAngle 349, -0.58234, 0.76
    AddCorrectionAngle 349, -0.552077, 0.82
    AddCorrectionAngle 349, -0.503032, 0.87
    AddCorrectionAngle 349, -0.456986, 0.959999
    AddCorrectionAngle 349, -0.40008, 1.039999
    AddCorrectionAngle 349, -0.28677, 1.119999
    AddCorrectionAngle 349, -0.169284, 1.119999
    AddCorrectionAngle 349, -0.038844, 1.119999
    AddCorrectionAngle 349, 0.092265, 1.099999
    AddCorrectionAngle 349, 0.190966, 1.099999
    AddCorrectionAngle 349, 0.242213, 1.169999
    AddCorrectionAngle 349, 0.322762, 1.209999
    AddCorrectionAngle 349, 0.35732, 1.299999
    AddCorrectionAngle 349, 0.410632, 1.409999
    AddCorrectionAngle 349, 0.443856, 1.509999
    AddCorrectionAngle 349, 0.481089, 1.669999
    AddCorrectionAngle 349, 0.530887, 1.769999
    AddCorrectionAngle 349, 0.566001, 1.979998
    AddCorrectionAngle 349, 0.604308, 2.199998
    AddCorrectionAngle 349, 0.633173, 2.409998
    AddCorrectionAngle 349, 0.672918, 2.819998
    AddCorrectionAngle 349, 0.695881, 2.959998

    AddCorrectionAngle 352, 0.707107, 3.129997
    AddCorrectionAngle 352, 0.688304, 2.969998
    AddCorrectionAngle 352, 0.676794, 2.859998
    AddCorrectionAngle 352, 0.657238, 2.639998
    AddCorrectionAngle 352, 0.645287, 2.519998
    AddCorrectionAngle 352, 0.620906, 2.329998
    AddCorrectionAngle 352, 0.600118, 2.159998
    AddCorrectionAngle 352, 0.578916, 2.039999
    AddCorrectionAngle 352, 0.566002, 1.909999
    AddCorrectionAngle 352, 0.53533, 1.799999
    AddCorrectionAngle 352, 0.512976, 1.689999
    AddCorrectionAngle 352, 0.481091, 1.589999
    AddCorrectionAngle 352, 0.448556, 1.499999
    AddCorrectionAngle 352, 0.420185, 1.389999
    AddCorrectionAngle 352, 0.391396, 1.379999
    AddCorrectionAngle 352, 0.357322, 1.379999
    AddCorrectionAngle 352, 0.342568, 1.289999
    AddCorrectionAngle 352, 0.312809, 1.249999
    AddCorrectionAngle 352, 0.272652, 1.219999
    AddCorrectionAngle 352, 0.232015, 1.169999
    AddCorrectionAngle 352, 0.154774, 1.129999
    AddCorrectionAngle 352, 0.113156, 1.129999
    AddCorrectionAngle 352, 0.0661, 1.129999
    AddCorrectionAngle 352, 0.013648, 1.129999
    AddCorrectionAngle 352, -0.301821, 1.089999
    AddCorrectionAngle 352, -0.380745, 1.039999
    AddCorrectionAngle 352, -0.466298, 0.98
    AddCorrectionAngle 352, -0.503031, 0.9
    AddCorrectionAngle 352, -0.57377, 0.78
    AddCorrectionAngle 352, -0.603475, 0.69
    AddCorrectionAngle 352, -0.644487, 0.52
    AddCorrectionAngle 352, -0.672145, 0.37
    AddCorrectionAngle 352, -0.691347, 0.31
    AddCorrectionAngle 352, -0.710073, 0.16
    AddCorrectionAngle 352, -0.728309, 0.02
    AddCorrectionAngle 352, -0.739011, -0.09
    AddCorrectionAngle 352, -0.763265, -0.24
    AddCorrectionAngle 352, -0.783234, -0.46
    AddCorrectionAngle 352, -0.796117, -0.61
    AddCorrectionAngle 352, -0.808649, -0.789999
    AddCorrectionAngle 352, -0.820823, -0.889999
    AddCorrectionAngle 352, -0.829717, -1.029999
    AddCorrectionAngle 352, -0.835532, -1.139999
    AddCorrectionAngle 352, -0.844082, -1.269999
    AddCorrectionAngle 352, -0.855156, -1.489999
    AddCorrectionAngle 352, -0.868467, -1.789998
    AddCorrectionAngle 352, -0.878685, -2.009998
    AddCorrectionAngle 352, -0.888516, -2.359998
    AddCorrectionAngle 352, -0.897955, -2.639998
    AddCorrectionAngle 352, -0.91137, -3.159997
    AddCorrectionAngle 352, -0.921859, -3.619997
    AddCorrectionAngle 352, -0.933607, -4.15
    AddCorrectionAngle 352, -0.944428, -4.830015
    AddCorrectionAngle 352, -0.947828, -5.06002
    AddCorrectionAngle 352, -0.957397, -5.810038
    AddCorrectionAngle 352, -0.967361, -6.860062
    AddCorrectionAngle 352, -0.971232, -7.470076

    AddCorrectionAngle 348, 0.707107, 3.179997
    AddCorrectionAngle 348, 0.692103, 3.039998
    AddCorrectionAngle 348, 0.680649, 2.859998
    AddCorrectionAngle 348, 0.657238, 2.699998
    AddCorrectionAngle 348, 0.645287, 2.539998
    AddCorrectionAngle 348, 0.625013, 2.389998
    AddCorrectionAngle 348, 0.612642, 2.269998
    AddCorrectionAngle 348, 0.591686, 2.119998
    AddCorrectionAngle 348, 0.566002, 2.029999
    AddCorrectionAngle 348, 0.548566, 1.899999
    AddCorrectionAngle 348, 0.53533, 1.789999
    AddCorrectionAngle 348, 0.503935, 1.699999
    AddCorrectionAngle 348, 0.47186, 1.569999
    AddCorrectionAngle 348, 0.448556, 1.529999
    AddCorrectionAngle 348, 0.429689, 1.459999
    AddCorrectionAngle 348, 0.405841, 1.379999
    AddCorrectionAngle 348, 0.371987, 1.329999
    AddCorrectionAngle 348, 0.332684, 1.259999
    AddCorrectionAngle 348, 0.297811, 1.219999
    AddCorrectionAngle 348, 0.252389, 1.179999
    AddCorrectionAngle 348, 0.201264, 1.179999
    AddCorrectionAngle 348, 0.159958, 1.139999
    AddCorrectionAngle 348, 0.0661, 1.109999
    AddCorrectionAngle 348, -0.028348, 1.119999
    AddCorrectionAngle 348, -0.189941, 1.129999
    AddCorrectionAngle 348, -0.225885, 1.129999
    AddCorrectionAngle 348, -0.261525, 1.109999
    AddCorrectionAngle 348, -0.366135, 1.079999
    AddCorrectionAngle 348, -0.419234, 1.039999
    AddCorrectionAngle 348, -0.456984, 1#
    AddCorrectionAngle 348, -0.507561, 0.92
    AddCorrectionAngle 348, -0.543291, 0.86
    AddCorrectionAngle 348, -0.57377, 0.76
    AddCorrectionAngle 348, -0.59928, 0.68
    AddCorrectionAngle 348, -0.624196, 0.68
    AddCorrectionAngle 348, -0.6604, 0.48
    AddCorrectionAngle 348, -0.676023, 0.38
    AddCorrectionAngle 348, -0.698895, 0.26
    AddCorrectionAngle 348, -0.721074, 0.14
    AddCorrectionAngle 348, -0.742538, 0#
    AddCorrectionAngle 348, -0.752995, -0.14
    AddCorrectionAngle 348, -0.773346, -0.28
    AddCorrectionAngle 348, -0.796117, -0.52
    AddCorrectionAngle 348, -0.817814, -0.809999
    AddCorrectionAngle 348, -0.838405, -1.119999
    AddCorrectionAngle 348, -0.852423, -1.359999
    AddCorrectionAngle 348, -0.865852, -1.679999
    AddCorrectionAngle 348, -0.881179, -2.059998
    AddCorrectionAngle 348, -0.893285, -2.399998
    AddCorrectionAngle 348, -0.900253, -2.619998
    AddCorrectionAngle 348, -0.91137, -2.959997
    AddCorrectionAngle 348, -0.921859, -3.479997
    AddCorrectionAngle 348, -0.947827, -4.750013

    AddCorrectionAngle 350, 0.707107, 3.179997
    AddCorrectionAngle 350, 0.692103, 3.049998
    AddCorrectionAngle 350, 0.672919, 2.839998
    AddCorrectionAngle 350, 0.649288, 2.549998
    AddCorrectionAngle 350, 0.633175, 2.429998
    AddCorrectionAngle 350, 0.608483, 2.279998
    AddCorrectionAngle 350, 0.587445, 2.089998
    AddCorrectionAngle 350, 0.566002, 1.939999
    AddCorrectionAngle 350, 0.53533, 1.819999
    AddCorrectionAngle 350, 0.494838, 1.649999
    AddCorrectionAngle 350, 0.467224, 1.559999
    AddCorrectionAngle 350, 0.434424, 1.469999
    AddCorrectionAngle 350, 0.410633, 1.359999
    AddCorrectionAngle 350, 0.367108, 1.359999
    AddCorrectionAngle 350, 0.33763, 1.299999
    AddCorrectionAngle 350, 0.312808, 1.239999
    AddCorrectionAngle 350, 0.226905, 1.159999
    AddCorrectionAngle 350, 0.159958, 1.109999
    AddCorrectionAngle 350, 0.092267, 1.069999
    AddCorrectionAngle 350, -0.122543, 1.119999
    AddCorrectionAngle 350, -0.246292, 1.099999
    AddCorrectionAngle 350, -0.341584, 1.099999
    AddCorrectionAngle 350, -0.423995, 1.029999
    AddCorrectionAngle 350, -0.484772, 0.95
    AddCorrectionAngle 350, -0.521069, 0.84
    AddCorrectionAngle 350, -0.582339, 0.67
    AddCorrectionAngle 350, -0.648492, 0.53
    AddCorrectionAngle 350, -0.698896, 0.27
    AddCorrectionAngle 350, -0.724702, 0.11
    AddCorrectionAngle 350, -0.746045, -0.06
    AddCorrectionAngle 350, -0.759863, -0.16
    AddCorrectionAngle 350, -0.77996, -0.37
    AddCorrectionAngle 350, -0.78972, -0.5
    AddCorrectionAngle 350, -0.808649, -0.699999
    AddCorrectionAngle 350, -0.826776, -0.949999
    AddCorrectionAngle 350, -0.835533, -1.039999
    AddCorrectionAngle 350, -0.849666, -1.429999
    AddCorrectionAngle 350, -0.868467, -1.749998
    AddCorrectionAngle 350, -0.88118, -2.049998
    AddCorrectionAngle 350, -0.895633, -2.469998
    AddCorrectionAngle 350, -0.909197, -3.029997

    AddCorrectionAngle 353, 0.707107, 3.109998
    AddCorrectionAngle 353, 0.680649, 2.889998
    AddCorrectionAngle 353, 0.665115, 2.689998
    AddCorrectionAngle 353, 0.641267, 2.509998
    AddCorrectionAngle 353, 0.620906, 2.359998
    AddCorrectionAngle 353, 0.600118, 2.259998
    AddCorrectionAngle 353, 0.583189, 2.159998
    AddCorrectionAngle 353, 0.570323, 2.029999
    AddCorrectionAngle 353, 0.557315, 1.949999
    AddCorrectionAngle 353, 0.530888, 1.849999
    AddCorrectionAngle 353, 0.485687, 1.679999
    AddCorrectionAngle 353, 0.462576, 1.609999
    AddCorrectionAngle 353, 0.439147, 1.539999
    AddCorrectionAngle 353, 0.410633, 1.449999
    AddCorrectionAngle 353, 0.371987, 1.369999
    AddCorrectionAngle 353, 0.33763, 1.279999
    AddCorrectionAngle 353, 0.292795, 1.219999
    AddCorrectionAngle 353, 0.257466, 1.169999
    AddCorrectionAngle 353, 0.196119, 1.169999
    AddCorrectionAngle 353, 0.154774, 1.119999
    AddCorrectionAngle 353, 0.113155, 1.069999
    AddCorrectionAngle 353, 0.013648, 1.089999
    AddCorrectionAngle 353, -0.044087, 1.109999
    AddCorrectionAngle 353, -0.132957, 1.109999
    AddCorrectionAngle 353, -0.316798, 1.079999
    AddCorrectionAngle 353, -0.366135, 1.029999
    AddCorrectionAngle 353, -0.461648, 0.98
    AddCorrectionAngle 353, -0.498486, 0.92
    AddCorrectionAngle 353, -0.534446, 0.86
    AddCorrectionAngle 353, -0.57377, 0.75
    AddCorrectionAngle 353, -0.628289, 0.61
    AddCorrectionAngle 353, -0.664334, 0.41
    AddCorrectionAngle 353, -0.695131, 0.25
    AddCorrectionAngle 353, -0.721074, 0.14
    AddCorrectionAngle 353, -0.739011, 0#
    AddCorrectionAngle 353, -0.766646, -0.22
    AddCorrectionAngle 353, -0.786488, -0.48
    AddCorrectionAngle 353, -0.802427, -0.61
    AddCorrectionAngle 353, -0.817814, -0.809999
    AddCorrectionAngle 353, -0.835533, -1.039999
    AddCorrectionAngle 353, -0.846886, -1.249999
    AddCorrectionAngle 353, -0.863214, -1.609999
    AddCorrectionAngle 353, -0.876167, -1.919998
    AddCorrectionAngle 353, -0.900253, -2.529998
    AddCorrectionAngle 353, -0.917739, -3.289997
    AddCorrectionAngle 353, -0.927848, -3.749997
    AddCorrectionAngle 353, -0.933607, -4.119999
    AddCorrectionAngle 353, -0.942689, -4.720013
    AddCorrectionAngle 353, -0.952731, -5.240025

    AddCorrectionAngle 351, 0.707107, 3.019998
    AddCorrectionAngle 351, 0.684486, 2.909998
    AddCorrectionAngle 351, 0.657238, 2.649998
    AddCorrectionAngle 351, 0.63723, 2.479998
    AddCorrectionAngle 351, 0.620906, 2.319998
    AddCorrectionAngle 351, 0.600118, 2.169998
    AddCorrectionAngle 351, 0.583189, 2.069999
    AddCorrectionAngle 351, 0.557315, 1.979999
    AddCorrectionAngle 351, 0.53533, 1.819999
    AddCorrectionAngle 351, 0.512976, 1.719999
    AddCorrectionAngle 351, 0.485687, 1.619999
    AddCorrectionAngle 351, 0.462576, 1.549999
    AddCorrectionAngle 351, 0.420184, 1.409999
    AddCorrectionAngle 351, 0.391396, 1.409999
    AddCorrectionAngle 351, 0.36222, 1.319999
    AddCorrectionAngle 351, 0.322764, 1.299999
    AddCorrectionAngle 351, 0.297811, 1.289999
    AddCorrectionAngle 351, 0.247306, 1.199999
    AddCorrectionAngle 351, 0.206404, 1.159999
    AddCorrectionAngle 351, 0.154774, 1.129999
    AddCorrectionAngle 351, 0.11837, 1.129999
    AddCorrectionAngle 351, -0.153739, 1.129999
    AddCorrectionAngle 351, -0.301821, 1.109999
    AddCorrectionAngle 351, -0.341584, 1.109999
    AddCorrectionAngle 351, -0.366135, 1.059999
    AddCorrectionAngle 351, -0.404884, 1.059999
    AddCorrectionAngle 351, -0.475561, 0.95
    AddCorrectionAngle 351, -0.521068, 0.89
    AddCorrectionAngle 351, -0.569462, 0.85
    AddCorrectionAngle 351, -0.590842, 0.71
    AddCorrectionAngle 351, -0.620085, 0.61
    AddCorrectionAngle 351, -0.65248, 0.5
    AddCorrectionAngle 351, -0.676022, 0.39
    AddCorrectionAngle 351, -0.691347, 0.3
    AddCorrectionAngle 351, -0.710073, 0.2
    AddCorrectionAngle 351, -0.735464, 0.05
    AddCorrectionAngle 351, -0.74953, -0.07
    AddCorrectionAngle 351, -0.770006, -0.3
    AddCorrectionAngle 351, -0.783234, -0.45
    AddCorrectionAngle 351, -0.796117, -0.56
    AddCorrectionAngle 351, -0.817813, -0.839999
    AddCorrectionAngle 351, -0.829717, -1.019999
    AddCorrectionAngle 351, -0.844082, -1.269999
    AddCorrectionAngle 351, -0.863214, -1.609999
    AddCorrectionAngle 351, -0.876166, -1.949998
    AddCorrectionAngle 351, -0.886095, -2.249998
    AddCorrectionAngle 351, -0.897955, -2.609998
    AddCorrectionAngle 351, -0.91137, -3.049997
    AddCorrectionAngle 351, -0.921859, -3.499997
    AddCorrectionAngle 351, -0.929793, -3.839997
    AddCorrectionAngle 351, -0.937317, -4.210001
    AddCorrectionAngle 351, -0.944428, -4.750013
    AddCorrectionAngle 351, -0.949488, -5.170023

    AddCorrectionAngle 357, 0.707107, 2.439998
    AddCorrectionAngle 357, 0.695883, 2.319998
    AddCorrectionAngle 357, 0.686397, 2.249998
    AddCorrectionAngle 357, 0.680649, 2.169998
    AddCorrectionAngle 357, 0.670975, 2.119998
    AddCorrectionAngle 357, 0.663153, 2.069999
    AddCorrectionAngle 357, 0.651283, 1.959999
    AddCorrectionAngle 357, 0.643279, 1.889999
    AddCorrectionAngle 357, 0.633175, 1.839999
    AddCorrectionAngle 357, 0.622962, 1.769999
    AddCorrectionAngle 357, 0.610565, 1.729999
    AddCorrectionAngle 357, 0.600118, 1.639999
    AddCorrectionAngle 357, 0.591686, 1.579999
    AddCorrectionAngle 357, 0.576774, 1.529999
    AddCorrectionAngle 357, 0.559493, 1.439999
    AddCorrectionAngle 357, 0.559493, 1.439999
    AddCorrectionAngle 357, 0.54417, 1.379999
    AddCorrectionAngle 357, 0.533111, 1.289999
    AddCorrectionAngle 357, 0.510722, 1.249999
    AddCorrectionAngle 357, 0.492556, 1.199999
    AddCorrectionAngle 357, 0.478788, 1.149999
    AddCorrectionAngle 357, 0.464902, 1.119999
    AddCorrectionAngle 357, 0.446209, 1.089999
    AddCorrectionAngle 357, 0.432059, 1.059999
    AddCorrectionAngle 357, 0.424944, 1.01
    AddCorrectionAngle 357, 0.410634, 1.01
    AddCorrectionAngle 357, 0.393812, 0.98
    AddCorrectionAngle 357, 0.374423, 0.95
    AddCorrectionAngle 357, 0.35487, 0.91
    AddCorrectionAngle 357, 0.337631, 0.91
    AddCorrectionAngle 357, 0.315302, 0.88
    AddCorrectionAngle 357, 0.280221, 0.85
    AddCorrectionAngle 357, 0.260002, 0.84
    AddCorrectionAngle 357, 0.234569, 0.82
    AddCorrectionAngle 357, 0.208973, 0.79
    AddCorrectionAngle 357, 0.188392, 0.79
    AddCorrectionAngle 357, 0.034643, 0.79
    AddCorrectionAngle 357, -0.281734, 0.79
    AddCorrectionAngle 357, -0.331696, 0.74
    AddCorrectionAngle 357, -0.37345, 0.7
    AddCorrectionAngle 357, -0.421615, 0.63
    AddCorrectionAngle 357, -0.503029, 0.47
    AddCorrectionAngle 357, -0.538874, 0.41
    AddCorrectionAngle 357, -0.569461, 0.32
    AddCorrectionAngle 357, -0.592956, 0.26
    AddCorrectionAngle 357, -0.607651, 0.18
    AddCorrectionAngle 357, -0.642476, 0.03
    AddCorrectionAngle 357, -0.683721, -0.24
    AddCorrectionAngle 357, -0.702639, -0.29
    AddCorrectionAngle 357, -0.719251, -0.44
    AddCorrectionAngle 357, -0.733681, -0.62
    AddCorrectionAngle 357, -0.749528, -0.749999
    AddCorrectionAngle 357, -0.766644, -0.929999
    AddCorrectionAngle 357, -0.776662, -1.039999
    AddCorrectionAngle 357, -0.791325, -1.249999
    AddCorrectionAngle 357, -0.805547, -1.479999
    AddCorrectionAngle 357, -0.816298, -1.639999
    AddCorrectionAngle 357, -0.829716, -1.829998
    AddCorrectionAngle 357, -0.84267, -2.109998
    AddCorrectionAngle 357, -0.85921, -2.429998
    AddCorrectionAngle 357, -0.867161, -2.639998
    AddCorrectionAngle 357, -0.877428, -2.899997
    AddCorrectionAngle 357, -0.892101, -3.489997
    AddCorrectionAngle 357, -0.906997, -4.019997

    AddCorrectionAngle 358, 0.866026, 4.690012
    AddCorrectionAngle 358, 0.863483, 4.58001
    AddCorrectionAngle 358, 0.861347, 4.520009
    AddCorrectionAngle 358, 0.859628, 4.470007
    AddCorrectionAngle 358, 0.857465, 4.390006
    AddCorrectionAngle 358, 0.854849, 4.330004
    AddCorrectionAngle 358, 0.853093, 4.270003
    AddCorrectionAngle 358, 0.850884, 4.180001
    AddCorrectionAngle 358, 0.84866, 4.109999
    AddCorrectionAngle 358, 0.845521, 4.019997
    AddCorrectionAngle 358, 0.843714, 3.989997
    AddCorrectionAngle 358, 0.840529, 3.899997
    AddCorrectionAngle 358, 0.837776, 3.819997
    AddCorrectionAngle 358, 0.835465, 3.779997
    AddCorrectionAngle 358, 0.833605, 3.709997
    AddCorrectionAngle 358, 0.830798, 3.639997
    AddCorrectionAngle 358, 0.828915, 3.609997
    AddCorrectionAngle 358, 0.825343, 3.529997
    AddCorrectionAngle 358, 0.822341, 3.459997
    AddCorrectionAngle 358, 0.819922, 3.409997
    AddCorrectionAngle 358, 0.81749, 3.359998
    AddCorrectionAngle 358, 0.815655, 3.309998
    AddCorrectionAngle 358, 0.811343, 3.229998
    AddCorrectionAngle 358, 0.809481, 3.169998
    AddCorrectionAngle 358, 0.80636, 3.099998
    AddCorrectionAngle 358, 0.802585, 3.039998
    AddCorrectionAngle 358, 0.799413, 2.989998
    AddCorrectionAngle 358, 0.79622, 2.919998
    AddCorrectionAngle 358, 0.792359, 2.869998
    AddCorrectionAngle 358, 0.789027, 2.829998
    AddCorrectionAngle 358, 0.783985, 2.739998
    AddCorrectionAngle 358, 0.780594, 2.659998
    AddCorrectionAngle 358, 0.776324, 2.609998
    AddCorrectionAngle 358, 0.772881, 2.569998
    AddCorrectionAngle 358, 0.769585, 2.509998
    AddCorrectionAngle 358, 0.766267, 2.459998
    AddCorrectionAngle 358, 0.760693, 2.379998
    AddCorrectionAngle 358, 0.755062, 2.339998
    AddCorrectionAngle 358, 0.747084, 2.239999
    AddCorrectionAngle 358, 0.737832, 2.149999
    AddCorrectionAngle 358, 0.730801, 2.059999
    AddCorrectionAngle 358, 0.7225, 1.979999
    AddCorrectionAngle 358, 0.714092, 1.899999
    AddCorrectionAngle 358, 0.704356, 1.799999
    AddCorrectionAngle 358, 0.690246, 1.709999
    AddCorrectionAngle 358, 0.678764, 1.589999
    AddCorrectionAngle 358, 0.664176, 1.499999
    AddCorrectionAngle 358, 0.655299, 1.409999
    AddCorrectionAngle 358, 0.643321, 1.339999
    AddCorrectionAngle 358, 0.631184, 1.289999
    AddCorrectionAngle 358, 0.612685, 1.22
    AddCorrectionAngle 358, 0.600162, 1.14
    AddCorrectionAngle 358, 0.584299, 1.07
    AddCorrectionAngle 358, 0.56821, 1.02
    AddCorrectionAngle 358, 0.555179, 0.96
    AddCorrectionAngle 358, 0.542012, 0.92
    AddCorrectionAngle 358, 0.522008, 0.87
    AddCorrectionAngle 358, 0.50851, 0.82
    AddCorrectionAngle 358, 0.481139, 0.77
    AddCorrectionAngle 358, 0.467273, 0.72
    AddCorrectionAngle 358, 0.448728, 0.66
    AddCorrectionAngle 358, 0.412965, 0.62
    AddCorrectionAngle 358, 0.366741, 0.56
    AddCorrectionAngle 358, 0.327094, 0.53
    AddCorrectionAngle 358, 0.032, 0.56
    AddCorrectionAngle 358, -0.0578, 0.6
    AddCorrectionAngle 358, -0.139289, 0.65
    AddCorrectionAngle 358, -0.319028, 0.63
    AddCorrectionAngle 358, -0.405188, 0.56
    AddCorrectionAngle 358, -0.459966, 0.5
    AddCorrectionAngle 358, -0.48095, 0.46
    AddCorrectionAngle 358, -0.510776, 0.37
    AddCorrectionAngle 358, -0.528834, 0.32
    AddCorrectionAngle 358, -0.555475, 0.24
    AddCorrectionAngle 358, -0.579405, 0.15
    AddCorrectionAngle 358, -0.604953, 0.07
    AddCorrectionAngle 358, -0.627837, -0.04
    AddCorrectionAngle 358, -0.648182, -0.17
    AddCorrectionAngle 358, -0.673951, -0.379999
    AddCorrectionAngle 358, -0.705154, -0.559999
    AddCorrectionAngle 358, -0.719556, -0.719999
    AddCorrectionAngle 358, -0.736437, -0.859999
    AddCorrectionAngle 358, -0.746079, -0.989999
    AddCorrectionAngle 358, -0.759586, -1.169999
    AddCorrectionAngle 358, -0.767537, -1.289999
    AddCorrectionAngle 358, -0.776665, -1.409999
    AddCorrectionAngle 358, -0.788167, -1.609998
    AddCorrectionAngle 358, -0.798164, -1.779998
    AddCorrectionAngle 358, -0.807947, -1.979998
    AddCorrectionAngle 358, -0.816937, -2.109998
    AddCorrectionAngle 358, -0.82494, -2.329998
    AddCorrectionAngle 358, -0.832782, -2.489998
    AddCorrectionAngle 358, -0.841219, -2.709997
    AddCorrectionAngle 358, -0.846483, -2.849997
    AddCorrectionAngle 358, -0.851667, -3.059997
    AddCorrectionAngle 358, -0.870197, -3.669997
    AddCorrectionAngle 358, -0.880364, -4.009996
    AddCorrectionAngle 358, -0.889502, -4.430006
    AddCorrectionAngle 358, -0.895819, -4.750013

    AddCorrectionAngle 372, 0.707107, 3.119998
    AddCorrectionAngle 372, 0.684486, 2.919998
    AddCorrectionAngle 372, 0.669027, 2.759998
    AddCorrectionAngle 372, 0.653272, 2.609998
    AddCorrectionAngle 372, 0.641267, 2.469998
    AddCorrectionAngle 372, 0.620906, 2.359998
    AddCorrectionAngle 372, 0.604309, 2.189998
    AddCorrectionAngle 372, 0.570323, 2.049999
    AddCorrectionAngle 372, 0.539757, 1.859999
    AddCorrectionAngle 372, 0.512976, 1.759999
    AddCorrectionAngle 372, 0.481091, 1.639999
    AddCorrectionAngle 372, 0.448556, 1.519999
    AddCorrectionAngle 372, 0.410633, 1.409999
    AddCorrectionAngle 372, 0.36222, 1.309999
    AddCorrectionAngle 372, 0.332684, 1.219999
    AddCorrectionAngle 372, 0.201264, 1.159999
    AddCorrectionAngle 372, 0.165138, 1.089999
    AddCorrectionAngle 372, -0.07553, 1.089999
    AddCorrectionAngle 372, -0.395261, 1.039999
    AddCorrectionAngle 372, -0.438206, 0.99
    AddCorrectionAngle 372, -0.484772, 0.95
    AddCorrectionAngle 372, -0.512077, 0.86
    AddCorrectionAngle 372, -0.552076, 0.81
    AddCorrectionAngle 372, -0.578062, 0.72
    AddCorrectionAngle 372, -0.615958, 0.63
    AddCorrectionAngle 372, -0.664333, 0.39
    AddCorrectionAngle 372, -0.70264, 0.21
    AddCorrectionAngle 372, -0.721074, 0.09
    AddCorrectionAngle 372, -0.735464, -0.02
    AddCorrectionAngle 372, -0.759862, -0.18
    AddCorrectionAngle 372, -0.783234, -0.45
    AddCorrectionAngle 372, -0.796117, -0.58
    AddCorrectionAngle 372, -0.814781, -0.849999
    AddCorrectionAngle 372, -0.829717, -1.089999
    AddCorrectionAngle 372, -0.846886, -1.359999
    AddCorrectionAngle 372, -0.857865, -1.589999
    AddCorrectionAngle 372, -0.871057, -1.809998
    AddCorrectionAngle 372, -0.888516, -2.239998
    AddCorrectionAngle 372, -0.897955, -2.559998
    AddCorrectionAngle 372, -0.906998, -2.919997
    AddCorrectionAngle 372, -0.917739, -3.379997
    AddCorrectionAngle 372, -0.931713, -3.989996

    AddCorrectionAngle 359, 0.866025, 10.799992
    AddCorrectionAngle 359, 0.849848, 10.039992
    AddCorrectionAngle 359, 0.835723, 9.079993
    AddCorrectionAngle 359, 0.821021, 8.279994
    AddCorrectionAngle 359, 0.814982, 7.519995
    AddCorrectionAngle 359, 0.808852, 6.999995
    AddCorrectionAngle 359, 0.79314, 6.679996
    AddCorrectionAngle 359, 0.773565, 5.759996
    AddCorrectionAngle 359, 0.746275, 5.119997
    AddCorrectionAngle 359, 0.739245, 4.679997
    AddCorrectionAngle 359, 0.724941, 4.359998
    AddCorrectionAngle 359, 0.706612, 3.999998
    AddCorrectionAngle 359, 0.683975, 3.439999
    AddCorrectionAngle 359, 0.656711, 3.079999
    AddCorrectionAngle 359, 0.624467, 2.48
    AddCorrectionAngle 359, 0.530295, 1.52
    AddCorrectionAngle 359, 0.489659, 1.280001
    AddCorrectionAngle 359, 0.58262, 2.16
    AddCorrectionAngle 359, 0.457293, 1.040001
    AddCorrectionAngle 359, 0.39558, 1.000001
    AddCorrectionAngle 359, 0.351759, 0.720001
    AddCorrectionAngle 359, 0.376206, 0.640001
    AddCorrectionAngle 359, -0.327402, 0.800001
    AddCorrectionAngle 359, -0.438836, 0.480001
    AddCorrectionAngle 359, -0.582908, -0.399999
    AddCorrectionAngle 359, -0.641002, -1.239999
    AddCorrectionAngle 359, -0.695634, -1.839999
    AddCorrectionAngle 359, -0.743007, -3.839997
    AddCorrectionAngle 359, -0.786921, -5.079996
    AddCorrectionAngle 359, -0.830109, -6.639994
    
    'Enables/Disables RPG:A Features
    SetFeatures True, True, True, True, True, True, True, True, True, True
    
    'Set the levels of XP
    PlayerLevelXPValues(1) = 591
    PlayerLevelXPValues(2) = 1182
    PlayerLevelXPValues(3) = 1773
    PlayerLevelXPValues(4) = 2364
    PlayerLevelXPValues(5) = 2955
    PlayerLevelXPValues(6) = 3546
    PlayerLevelXPValues(7) = 4137
    PlayerLevelXPValues(8) = 4728
    PlayerLevelXPValues(9) = 5319
    PlayerLevelXPValues(10) = 5910
    PlayerLevelXPValues(11) = 6501
    PlayerLevelXPValues(12) = 7092
    PlayerLevelXPValues(13) = 7683
    PlayerLevelXPValues(14) = 8274
    PlayerLevelXPValues(15) = 8865
    PlayerLevelXPValues(16) = 9456
    PlayerLevelXPValues(17) = 10047
    PlayerLevelXPValues(18) = 10638
    PlayerLevelXPValues(19) = 11229
    PlayerLevelXPValues(20) = 11820
    PlayerLevelXPValues(21) = 12411
    PlayerLevelXPValues(22) = 13002
    PlayerLevelXPValues(23) = 13593
    PlayerLevelXPValues(24) = 14184
    PlayerLevelXPValues(25) = 14775
    PlayerLevelXPValues(26) = 15366
    PlayerLevelXPValues(27) = 15957
    PlayerLevelXPValues(28) = 16548
    PlayerLevelXPValues(29) = 17139
    PlayerLevelXPValues(30) = 17730
    PlayerLevelXPValues(31) = 18321
    PlayerLevelXPValues(32) = 18912
    PlayerLevelXPValues(33) = 19503
    PlayerLevelXPValues(34) = 20094
    PlayerLevelXPValues(35) = 20685
    PlayerLevelXPValues(36) = 21276
    PlayerLevelXPValues(37) = 21867
    PlayerLevelXPValues(38) = 22458
    PlayerLevelXPValues(39) = 23049
    PlayerLevelXPValues(40) = 23640
    PlayerLevelXPValues(41) = 24231
    PlayerLevelXPValues(42) = 24822
    PlayerLevelXPValues(43) = 25413
    PlayerLevelXPValues(44) = 26004
    PlayerLevelXPValues(45) = 26595
    PlayerLevelXPValues(46) = 27186
    PlayerLevelXPValues(47) = 27777
    PlayerLevelXPValues(48) = 28368
    PlayerLevelXPValues(49) = 28959
    PlayerLevelXPValues(50) = 29550
    PlayerLevelXPValues(51) = 30141
    PlayerLevelXPValues(52) = 30732
    PlayerLevelXPValues(53) = 31323
    PlayerLevelXPValues(54) = 31914
    PlayerLevelXPValues(55) = 32505
    PlayerLevelXPValues(56) = 33096
    PlayerLevelXPValues(57) = 33687
    PlayerLevelXPValues(58) = 34278
    PlayerLevelXPValues(59) = 34869
    PlayerLevelXPValues(60) = 35460

    
    
    
    FrmIntro.Show
End Sub

Public Sub AddCorrectionAngle(iModel As Integer, fCameraVert As Single, fCorrection As Single)
Dim fWeaponAim As Single
    
    fWeaponAim = GetWeaponAim(iModel)
    ReDim Preserve WeaponCam(m_iCamIndex)
    WeaponCam(m_iCamIndex).fCamVert = fCameraVert
    WeaponCam(m_iCamIndex).fHeightFromCam = fCorrection
    m_iCamIndex = m_iCamIndex + 1
End Sub

Public Sub AddWeapon(Wid As Integer, mID As Integer, WeaponName As String)
    WeaponIDtoModelID(Wid) = mID
    WeaponModelIDtoID(mID) = Wid
    WeaponIDtoName(Wid) = WeaponName
End Sub

Public Function DoesFileExist(FilePath As String) As Boolean
Dim Filename As String

    If Len(Dir(FilePath)) > 0 Then
        DoesFileExist = True
    Else
        DoesFileExist = False
    End If

End Function
