Attribute VB_Name = "Mod_WeaponAimMath"
'Players Z Angle
'Position
'Devide angle by 57.3 (radians)
'then what you get from that, is 2 values between -1 and 1, 1 for x and 1 for y
'sin ( angle ) for x
'and cos ( angle ) for y
'so u just multiply those by the distance you wanna move the actor forward
'and add them to the x and y position
Public Const WEAPON_AIMS = 100



Public Function GetAimAngle(Model As Integer, CameraZAngle As Single) As Single
Dim fAngle As Single
Dim WepAngle As Single
Const PI = 3.14159265

    'Get the 360 rotation from the normal rotation
    fAngle = CameraZAngle
    
    WepAngle = GetWeaponAim(WeaponModelIDtoID(Model))
    If WepAngle > 0 Then
        fAngle = fAngle + WepAngle
    End If
    If fAngle > 360 Then fAngle = fAngle - 360
    GetAimAngle = fAngle
    
End Function

Public Function GetWeaponAim(Model As Integer) As Single
Dim i As Integer

    If Model > 100 Then
    GetWeaponAim = WeaponAims(WeaponModelIDtoID(Model)).Angle
    Else
    GetWeaponAim = WeaponAims(Model).Angle
    End If

End Function

Public Function GetAimDistance(WeaponModel As Integer) As Single
Dim fDistance As Single
Dim WeaponDistance As Single

    fDistance = 5.000001
    WeaponDistance = WeaponAims(WeaponModelIDtoID(WeaponModel)).Distance
    GetAimDistance = (fDistance + WeaponDistance)
    
End Function

Public Function GetClosestHeightFromCamera(fAngle As Single) As Single
Dim fDifference As Single
Dim iID As Integer
Dim fCam As Single
Dim fDif As Single

    fDifference = 100
    iID = -1
    i = 0
    Do While (i < (m_icam_index + 1))
        fCam = WeaponCam(i).fCamVert
        fDif = fAngle - fCam
        If fDif < 0 Then
            fDif = 0 - fDif
        End If
        If fDif < fDifference Then
            fDifference = fDif
            iID = i
            Exit Do
        End If
        i = i + 1
    Loop
    If iID <> -1 Then
        GetClosestHeightFromCamera = WeaponCam(iID).fHeightFromCam
    Else
        GetClosestHeightFromCamera = 0
    End If
End Function

Public Function GetAimHeight(iModel As Integer, fZ As Single, fDistance As Single, fCameraVert As Single, bCrouched As Boolean) As Single
Dim fHeight As Single
Dim fWeaponAim As Single
    
    fHeight = 0
    If (iModel = 342 Or iModel = 343 Or iModel = 344) Then 'Rocket/Sniper etc
        GetAimHeight = fZ
        Exit Function
    End If

    fWeaponAim = GetWeaponAim(WeaponModelIDtoID(iModel))
    fHeight = fZ - 0.166 + GetClosestHeightFromCamera(fCameraVert)
    fHeight = fHeight + WeaponAims(WeaponModelIDtoID(iModel)).Height
    fHeight = fHeight + ((fDistance + WeaponAims(WeaponModelIDtoID(iModel)).HeightMultiplier) * fCameraVert)
    
    If bCrouched Then
        fHeight = fhight + 0.036
    End If
    GetAimHeight = fHeight
End Function

Public Sub GetVectorInfrontOf(x As Single, y As Single, Z As Single, Angle As Single, Vert As Single, Distance As Single)
Dim fVX As Single
Dim fVY As Single
Dim fVZ As Single

    fVX = Distance * (Sin(Angle / 57.3))
    fVY = Distance * (Cos(Angle / 57.3))
    fVZ = Distance * (Tan(Vert / 57.3))

    x = x + fVX
    y = y + fVY
    Z = Z + fVZ
End Sub

Public Sub GetWholeWeaponAim(HostPlayer_ZCam_Angle As Single, HostPlayer_Z_Angle As Single, HostPlayer_X_Coord As Single, HostPlayer_Y_Coord As Single, HostPlayer_Z_Coord As Single, WeaponID As Integer, ResultX As Single, ResultY As Single, ResultZ As Single, HostPlayer_VertCam_Angle As Single)
Dim fAngle As Single
Dim fDistance As Single
Dim fDegrees As Single
Dim Distance As Single
Const PI = 3.14159265
    
    fDistance = GetAimDistance(WeaponIDtoModelID(WeaponID))
    fAngle = GetAimAngle(WeaponIDtoModelID(WeaponID), HostPlayer_ZCam_Angle)
    GetVectorInfrontOf HostPlayer_X_Coord, HostPlayer_Y_Coord, HostPlayer_Z_Coord, fAngle, 0, fDistance
    HostPlayer_Z_Coord = GetAimHeight(WeaponIDtoModelID(WeaponID), HostPlayer_Z_Coord, fDistance, HostPlayer_VertCam_Angle, False)
    
    ResultX = HostPlayer_X_Coord
    ResultY = HostPlayer_Y_Coord
    ResultZ = HostPlayer_Z_Coord - 1.3
End Sub

Public Sub CalcAimActorDirection(HostPlayer_ZCam_Angle As Single, HostPlayer_Z_Angle As Single, HostPlayer_X_Coord As Single, HostPlayer_Y_Coord As Single, HostPlayer_Z_Coord As Single, WeaponID As Integer, ResultX As Single, ResultY As Single, ResultZ As Single)
Dim Radian As Single
Dim Devide As Single
Dim AngleX As Single
Dim AngleY As Single
Dim EndX As Single
Dim EndY As Single
Dim fDegrees As Single
Dim Distance As Single
Const PI = 3.14159265


    'Get the 360 rotation from the normal rotation
    fDegrees = 57.2957 * HostPlayer_Z_Angle
    If (fDegrees < 0#) Then fDegrees = fDegrees + 360
    fDegrees = 360 - fDegrees

    'Calc the Radian
    'Radian = (fDegrees * (PI / 180)) / PI
    Radian = (fDegrees / 57.3)
    
    'From this we get 2 values:
    AngleX = Sin(Radian)
    AngleY = Cos(Radian)
    
    WeaponID = 99
    Select Case WeaponID
    
        Case 0 'Fist
            Distance = 4
        Case 30 'AK47
            Distance = 10
        Case 31 'M4
            Distance = 10
        Case 33 'Country Rifle
            Distance = 20
        Case 34 'Sniper Rifle
            Distance = 30
        Case 35 'Rocket Launcer
            Distance = 10
        Case 36 'Flame Thrower
            Distance = 10
        Case 37 'Minigun
            Distance = 30
        Case 16 'Grenade
            
        Case 22 'Pistol
            
        Case 23 'Silenced Pistol
            
        Case 24 'Desert Eagle
            
        Case 25 'Shotgun
            
        Case 26 'Sawn Off Shotgun
            
        Case 27 'Spas-12
            
        Case 28 'Micro UZI
            
        Case 29 'MP5
            
        Case 32 'TEC-9
            Distance = 10
        Case Else
            Distance = 5
                        
    End Select
    
    EndX = (AngleX * Distance)
    EndY = (AngleY * Distance)
    ResultX = EndX + HostPlayer_X_Coord
    ResultY = EndY + HostPlayer_Y_Coord
    
    HostPlayer_ZCam_Angle = Format(HostPlayer_ZCam_Angle, "0.0000000")
    If HostPlayer_ZCam_Angle > 0 Then
        ResultZ = HostPlayer_Z_Coord + ((HostPlayer_ZCam_Angle * 2) * Distance)
    ElseIf HostPlayer_ZCam_Angle <= 0 Then
        HostPlayer_ZCam_Angle = (HostPlayer_ZCam_Angle - HostPlayer_ZCam_Angle) - HostPlayer_ZCam_Angle
        ResultZ = (HostPlayer_Z_Coord - ((HostPlayer_ZCam_Angle * 10) * Distance))
    End If
    
End Sub

Public Function AngleFrom2DVector(fX As Single, fY As Single) As Single
Dim fA As Single

    fA = (Atn(fX / fY) * 57.3)
    If (fX >= 0) And (fY < 0) Then
        fA = fA - 180
    ElseIf (fX < 0) And (fY < 0) Then
        fA = fA + 180
    End If
    
    AngleFrom2DVector = fA
    
    
End Function
