Attribute VB_Name = "basErrorHandling"
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
    
Public Const conHwndTopmost = -1
Public Const conSwpNoActivate = &H10
Public Const conSwpShowWindow = &H40

Public mProcStack As New ProcedureStack


Public Function Process_Error(strModuleName As String, ByRef mErr As ErrObject, strProcName As String)

Dim objProc As Procedure
Dim nFRM As New frmError


nFRM.txtError = "Procedure Name:" & vbTab & strProcName & vbCrLf _
                    & "Module Name:" & vbTab & strModuleName & vbCrLf & vbCrLf _
                    & "Error Number:" & vbTab & mErr.Number & vbCrLf _
                    & "Error Description:" & vbTab & mErr.Description & vbCrLf _
                    & "Error Source:" & vbTab & mErr.Source & vbCrLf _
                    & "Last DLL Error:" & vbTab & mErr.LastDllError & vbCrLf & vbCrLf _
                    & "Call Stack:" & vbCrLf
                    
Set objProc = mProcStack.Top


Do Until objProc Is Nothing
    nFRM.txtError = nFRM.txtError & vbTab & objProc.Name & " in " & objProc.Module & vbCrLf
    Set objProc = objProc.NextProc
Loop

nFRM.Show vbModal

End Function


