Attribute VB_Name = "mod_ActorPoolCheck"
Public ActorPool(0 To 140) As ACT_POOL
Public PoolSize As Long

Public Type ACT_POOL
    MemoryAddress As Long
End Type

Public Sub CheckActorPool()
Dim i As Integer
Dim j As Integer
Dim PlayerFound As Boolean
Dim AimFound As Boolean
Dim Math As Long
Dim CurrentPntr As Long

    'Load the pool first
    LoadPool
    
    'Now its loaded, lets check the pool to make sure that the actors spawned are the ones we know about
    'Method:
    '   check around the pool table looking for the players who have these pointers
    '   log any pointers that are not found, and work out the SCM id from their pointers
    '   Remove the not found actors from the game, and contiune
    'First off, lets start a for loop looping around the pool
    For i = 2 To PoolSize
        'Now check aginst the players
        For j = 1 To 50
            If ClientData.Players(j).ActorData.MemoryPointer = ActorPool(i).MemoryAddress Then PlayerFound = True
            If ClientData.Players(j).AimActorData.MemoryPointer = ActorPool(i).MemoryAddress Then AimFound = True
        Next
        
        'All players have been searched, is this actor address okay?
        If PlayerFound = False Then
            'No, its not good... lets remove this now
            'Work out what player we have here
            '   There are 2 posiblities:
            '       a SCMID > 256 OR
            '       a SCMID < 100
            'each calc will be preformed and taken action apon.
            
            'First work out the "easy" ID for the ped
            'CurrentPntr =
            'math =
            
            If PedID < 256 Then
                Math = (((PedID - 1) * 2584) + FrmMain.GTAHOOK.GetPlayerPointer)
                GetVehiclePointerFromSAID = Math
            Else
                Math = ((((PedID - 1) / 256) * 2584) + FrmMain.GTAHOOK.GetPlayerPointer)
                GetVehiclePointerFromSAID = Math
            End If
            
        End If
        
        If AimFound = False Then
            'Its not good, lets remove it
            
        End If
    Next
    
End Sub

Public Sub LoadPool()
'This loads the actor pool into the vars
'0xB74490 contains a pointer. This pointer:
'+0 contains a pointer to the first element in the pool.
'+8 [DWord] is the maximum number of elements in the pool.
'+12 [DWord] is the current number of elements in the pool.
'+32 is the ped pool start.
Dim PoolAddr As Long
Dim MaxElements As Long
Dim CurrentElements As Long
Dim PoolStart As Long
Dim i As Integer
Dim j As Integer

'0xB74490 contains a pointer. This pointer:
'+0 contains a pointer to the first element in the pool.
'+8 [DWord] is the maximum number of elements in the pool.
'+12 [DWord] is the current number of elements in the pool.
'+32 is the ped pool start.

    If GameData.Checks.GameSystemAllReady = False Then Exit Sub

    PoolAddr = ReadMemoryDWORD(&HB74490)
    MaxElements = ReadMemoryDWORD(PoolAddr + 8)
    CurrentElements = ReadMemoryDWORD(PoolAddr + 12)
    Buffer = ReadMemoryDWORD(PoolAddr + 32)
    PoolSize = CurrentElements
    
    'Start of the ped pool is +32, im guessing +4 each time...
    PoolStart = PoolAddr + 32
    For i = 0 To CurrentElements
        'Fill the pool we have with the pointers
        ActorPool(i).MemoryAddress = ReadMemoryDWORD(&HB74490 + (32 * i))
    Next

End Sub

Public Function DoesActorExist(MemPntr2Check As Long) As Boolean
Dim ActXLoc As Single

    ActXLoc = FrmMain.GTAHOOK.Player_Get_XLocation(MemPntr2Check)
    If ActXLoc = 0 Then
        DoesActorExist = False
    Else
        DoesActorExist = True
    End If

'Old pool shit:
'Dim i As Integer
'Dim Found As Boolean
    'LoadPool
    'Found = False
    'For i = 0 To 140
    '    If MemPntr2Check = ActorPool(i).MemoryAddress Then
    '        Found = True
    '        Exit For
    '    End If
    'Next
'
'    If Found Then
'        DoesActorExist = True
'    Else
'        DoesActorExist = True
'    End If
End Function

Public Sub AttemptActorDelete(ActorPointer As Long)
Dim Math As Long
Dim SCMID1 As Long
Dim SCMID2 As Long

    If ActorPointer < 100000 Then Exit Sub

    'Get the ID of the actor (we can get its playerID this way)
    Math = FrmMain.GTAHOOK.GetActorIDFromPointer(ActorPointer)
    
    'Work out 2 possible SCM ID's
    SCMID1 = (Math * 256)
    SCMID2 = Math
    
    FrmMain.GTAHOOK.DestroyActor SCMID1, -1
    FrmMain.GTAHOOK.DestroyActor SCMID2, -1
End Sub
