VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "mswinsck.ocx"
Begin VB.Form FrmServer 
   Caption         =   "Stunt Andreas Server - "
   ClientHeight    =   7725
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11175
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   7725
   ScaleWidth      =   11175
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer tmr_ClientUpdate 
      Left            =   720
      Top             =   6120
   End
   Begin VB.Timer Tmr_SphereCheck 
      Interval        =   300
      Left            =   4560
      Top             =   5640
   End
   Begin VB.Timer ScriptTimer 
      Index           =   0
      Left            =   3960
      Top             =   5640
   End
   Begin VB.Timer Tmr_AutoSave 
      Interval        =   60000
      Left            =   240
      Top             =   5640
   End
   Begin VB.TextBox txt_ConsoleNet 
      Height          =   615
      Left            =   3360
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   4920
      Visible         =   0   'False
      Width           =   2415
   End
   Begin VB.Timer tmr_PlayerStats 
      Left            =   1200
      Top             =   5640
   End
   Begin MSWinsockLib.Winsock SocketIRC 
      Left            =   3120
      Top             =   5640
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Timer Tmr_Ping 
      Interval        =   2000
      Left            =   2640
      Top             =   5640
   End
   Begin VB.Timer Tmr_Timeout 
      Interval        =   15500
      Left            =   2160
      Top             =   5640
   End
   Begin VB.Timer Tmr_Weather 
      Interval        =   1000
      Left            =   1680
      Top             =   5640
   End
   Begin VB.TextBox txt_ErrorMessage 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H000000C0&
      BorderStyle     =   0  'None
      ForeColor       =   &H00FFFFFF&
      Height          =   195
      Left            =   0
      Locked          =   -1  'True
      TabIndex        =   1
      Top             =   0
      Visible         =   0   'False
      Width           =   8115
   End
   Begin VB.Timer tmr_GameClock 
      Interval        =   1000
      Left            =   720
      Top             =   5640
   End
   Begin MSWinsockLib.Winsock Socket 
      Left            =   3120
      Top             =   5880
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      Protocol        =   1
   End
   Begin VB.TextBox txt_Console 
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ForeColor       =   &H00E0E0E0&
      Height          =   3495
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   0
      Width           =   8115
   End
   Begin MSWinsockLib.Winsock SocketAdmin 
      Left            =   3120
      Top             =   6120
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      Protocol        =   1
   End
End
Attribute VB_Name = "FrmServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim ErrorMessageSelector As Boolean
Public WithEvents IRCClient As CLIRC
Attribute IRCClient.VB_VarHelpID = -1

Private Sub Form_Activate()
Dim WaitTime As Single
    WaitTime = 2.5
    Randomize Timer
    Do While Timer < WaitTime
        DoEvents
    Loop
    
    ScriptGlobalVars.ScriptGlobalVarsCount = -1

    WebChatEnabled = True
    If Server.ServerName <> "" Then Exit Sub
    Me.Caption = "RPG Andreas Server - v" & AppVersion
    Dim TmpBufferString As String
    Dim TmpBufferInteger As Integer
    Dim TmpBufferBoolean As Boolean
    Dim TimerX As Long
    ErrorMessageSelector = True
    If Not FileExists(App.Path & "\Settings.ini") Then
        DisplayError "Unable to start server, Settings.ini does not exist, Reinstalling the server may fix the problem"
        Exit Sub
    End If
    
    If Not FileExists(App.Path & "\Cars.cfg") Then
        DisplayError "Unable to start server, Cars.cfg does not exist, Reinstalling the server may fix the problem"
        Exit Sub
    End If
    
    AppendConsole "Dedicated Server Started, Loading Settings From File"
    
    TmpBufferString = GetFromINI("Server", "ServerName", App.Path & "\Settings.ini")
    If TmpBufferString = "" Then
        txt_Console.Text = ""
        DisplayError "Unable to start server, No servername given in Settings.ini"
        Exit Sub
    Else
        Server.ServerName = TmpBufferString
        AppendConsole "Servername = '" & TmpBufferString & "'"
    End If
    
    TmpBufferString = GetFromINI("Server", "ScriptPath", App.Path & "\Settings.ini")
    If TmpBufferString = "" Then
        txt_Console.Text = ""
        DisplayError "Unable to start server, No Script Path given in Settings.ini"
        Exit Sub
    Else
        Server.ScriptPath = TmpBufferString
        AppendConsole "ScriptPath = '" & TmpBufferString & "'"
    End If
    
    TmpBufferString = GetFromINI("server", "ServerPort", App.Path & "\Settings.ini")
    If TmpBufferString = "" Then
        DisplayError "Unable to start server, No Server Port Given"
        Exit Sub
    Else
        If IsNumeric(TmpBufferString) Then
            If Val(TmpBufferString) > 65535 Then
                DisplayError "Unable to start server, Server Port is over 65535"
                Exit Sub
            Else
                If Val(TmpBufferString) < 1 Then
                    DisplayError "Unable to start server, Server Port is below 1"
                    Exit Sub
                Else
                    Server.ServerPort = Val(TmpBufferString)
                    AppendConsole "Serverport = '" & TmpBufferString & "'"
                End If
            End If
        Else
            DisplayError "Unable to start server, Server Port Is Not Numeric"
            Exit Sub
        End If
    End If
    
    TmpBufferString = GetFromINI("Server", "MaxPlayers", App.Path & "\Settings.ini")
    If TmpBufferString = "" Then
        DisplayError "Unable to start server, Max Players not given"
    Else
        If IsNumeric(TmpBufferString) Then
            If Val(TmpBufferString) > 32 Then
                DisplayError "Unable to start server, Max Players is over 32"
                Exit Sub
            Else
                If Val(TmpBufferString) < 1 Then
                    DisplayError "Unable to start server, Max Players is below 1"
                    Exit Sub
                Else
                    Server.MaxPlayers = Val(TmpBufferString)
                    AppendConsole "Max Players = '" & TmpBufferString & "'"
                End If
            End If
        Else
            DisplayError "Unable to start server, Max Players Is Not Numeric"
            Exit Sub
        End If
    End If
    
    TmpBufferString = GetFromINI("Server", "DataFootSendInterval", App.Path & "\Settings.ini")
    If TmpBufferString = "" Then
        DisplayError "Unable to start server, DataVehicleSendInterval not given"
    Else
        If IsNumeric(TmpBufferString) Then
            If Val(TmpBufferString) > 65535 Then
                DisplayError "Unable to start server, DataFootSendInterval is over 32"
                Exit Sub
            Else
                If Val(TmpBufferString) < 1 Then
                    DisplayError "Unable to start server, DataFootSendInterval is below 1"
                    Exit Sub
                Else
                    Server.FootInterval = Val(TmpBufferString)
                    AppendConsole "DataFootSendInterval = '" & TmpBufferString & "'"
                End If
            End If
        Else
            DisplayError "Unable to start server, Max Players Is Not Numeric"
            Exit Sub
        End If
    End If
    
    TmpBufferString = GetFromINI("Server", "DataVehicleSendInterval", App.Path & "\Settings.ini")
    If TmpBufferString = "" Then
        DisplayError "Unable to start server, DataVehicleSendInterval not given"
    Else
        If IsNumeric(TmpBufferString) Then
            If Val(TmpBufferString) > 65535 Then
                DisplayError "Unable to start server, DataVehicleSendInterval is over 65535"
                Exit Sub
            Else
                If Val(TmpBufferString) < 1 Then
                    DisplayError "Unable to start server, Max Players is below 1"
                    Exit Sub
                Else
                    Server.VehicleInterval = Val(TmpBufferString)
                    AppendConsole "DataVehicleSendInterval = '" & TmpBufferString & "'"
                End If
            End If
        Else
            DisplayError "Unable to start server, Max Players Is Not Numeric"
            Exit Sub
        End If
    End If
    
    TmpBufferString = GetFromINI("Game", "Weather", App.Path & "\Settings.ini")
    If TmpBufferString = "" Then
        DisplayError "Unable to start server, Weather not given"
    Else
        If IsNumeric(TmpBufferString) Then
            If Val(TmpBufferString) > 45 Then
                DisplayError "Unable to start server, Weater is over 45"
                Exit Sub
            Else
                If Val(TmpBufferString) < 0 Then
                    DisplayError "Unable to start server, Weather is below 0"
                    Exit Sub
                Else
                    Server.Weather = Val(TmpBufferString)
                    AppendConsole "Weather = '" & TmpBufferString & "'"
                End If
            End If
        Else
            DisplayError "Unable to start server, Weather Is Not Numeric"
            Exit Sub
        End If
    End If
    
    TmpBufferString = GetFromINI("Game", "LockWeather", App.Path & "\Settings.ini")
    If TmpBufferString = "" Then
        DisplayError "Unable to start server, LockWeather is not set"
    Else
        If IsNumeric(TmpBufferString) Then
            If Val(TmpBufferString) > 1 Then
                DisplayError "Unable to start server, Weater is over 1 (can be either 1 or 0)"
                Exit Sub
            Else
                If Val(TmpBufferString) < 0 Then
                    DisplayError "Unable to start server, Weather is below 0"
                    Exit Sub
                Else
                    Server.LockWeather = Val(TmpBufferString)
                    AppendConsole "Lock Weather = '" & TmpBufferString & "'"
                End If
            End If
        Else
            DisplayError "Unable to start server, LockWeather Is Not Numeric"
            Exit Sub
        End If
    End If
    
    Server.MOTDURL = GetFromINI("Server", "motd", App.Path & "\Settings.ini")
    
    'Load Gamemode Data
    Server.GameMode.GameMode = GetFromINI("GameMode", "GameMode", App.Path & "\Settings.ini")
    Server.GameMode.Settings = GetFromINI("GameMode", "GameModeSettings", App.Path & "\Settings.ini")
    Server.GameMode.Time = GetFromINI("GameMode", "GameModeSettings", App.Path & "\Settings.ini") 'Store full time here
    
    If Server.GameMode.GameMode = "" Then
        Server.GameMode.GameMode = "1"
        Server.GameMode.Settings = "10000"
    End If
    
    If Server.GameMode.GameMode = "1" Then Server.GameMode.Time = "0"
    
    Server.RconPassword = GetFromINI("Server", "Rcon", App.Path & "\Settings.ini")
    
    'Load IRC Data
    TmpBufferString = GetFromINI("Irc", "enabled", App.Path & "\Settings.ini")
    If TmpBufferString = "1" Then
        IRC.Enabled = True
    End If
    
    IRC.Server = GetFromINI("Irc", "server", App.Path & "\Settings.ini")
    IRC.Port = GetFromINI("Irc", "port", App.Path & "\Settings.ini")
    IRC.Channel = GetFromINI("Irc", "channel", App.Path & "\Settings.ini")
    IRC.Key = GetFromINI("Irc", "key", App.Path & "\Settings.ini")
    IRC.Nick = GetFromINI("Irc", "nick", App.Path & "\Settings.ini")
    
    AppendConsole "All settings loaded"
    
    LoadScript App.Path & "\" & Server.ScriptPath
    LoadCars
    LoadPlayerLogins
    LoadMap
    
    LaunchIRC
    If IRC.Enabled Then
        TimerX = Timer
        AppendConsole "Waiting for IRC to connect and join channel (timeout in 20 seconds)"
        Do While Not IRCClient.isConnected
            If (Timer - TimerX) > 20 Then 'Give 20 seconds for the server to join
                GoTo ExitThis
            End If
            DoEvents
        Loop
        
ExitThis:
    End If
    StartServer
    AppendConsole "MIRC classes coded by: Michael Leaney"
End Sub

Private Sub Form_Load()
    StartLogfile
    Set IRCClient = New CLIRC
    LoadPlayerDatabase
    LoadBans
    
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
Dim i As Integer
    If ScriptTimersUsed Then
        For i = ScriptTimer.Count - 1 To 0 Step -1
            ScriptTimer(i).Interval = 0
            If i > 0 Then Unload ScriptTimer(i)
        Next
    End If
    Erase TheTimers
    ScriptTimerCount = 0
    Erase xScriptGlobalVars
    ScriptGlobalVarsCount = 0
    Set MyScript = Nothing
    Set clsScriptCommands = Nothing
End Sub

Private Sub Form_Resize()
On Error Resume Next
    Me.Width = 8160
    Me.Height = txt_Console.Height + 300
End Sub

Public Sub AppendConsole(Data As String)
Dim i As Integer

    If Len(txt_Console.Text) > 35000 Then txt_Console.Text = ""
    
    txt_Console.Text = txt_Console.Text & Data & vbNewLine
    txt_Console.SelStart = Len(txt_Console.Text) - Len(vbNewLine)
    
    For i = 1 To 10
        If ConnectedAdmins(i).IP <> "" Then
            SocketAdmin.RemoteHost = ConnectedAdmins(i).IP
            SocketAdmin.RemotePort = ConnectedAdmins(i).Port
            
            SocketAdmin.SendData "c" & Chr(10) & Data
        End If
    Next
    
    i = FreeFile
    Open App.Path & "\server.log" For Append As #i
        Print #i, "[" & Now & "] " & Data
    Close #i
End Sub

Public Sub StartLogfile()
Dim i As Integer
    i = FreeFile
    Open App.Path & "\server.log" For Append As #i
        Print #i, ""
        Print #i, ""
        Print #i, ""
        Print #i, "[" & Now & "] RPG Andreas Server Started - Logfile Started"
        Print #i, "[" & Now & "] New Logfile Started On: " & Now
    Close #i
End Sub

Public Sub EndLogfile()
Dim i As Integer
    i = FreeFile
    Open App.Path & "\server.log" For Append As #i
        Print #i, "[" & Now & "] RPG Andreas Server Shutting Down"
        Print #i, "[" & Now & "] Saving Player Database... DONE"
        Print #i, "[" & Now & "] Saving Bans... DONE"
        Print #i, "[" & Now & "] Shutting Off Connections... DONE"
        Print #i, "[" & Now & "] Bye Bye! - SERVER DEAD"
        Print #i, "[" & Now & "] Server Died At: " & Now
    Close #i
End Sub

Public Sub AppendNetConsole(Data As String)
Dim i As Integer

    If Len(txt_ConsoleNet.Text) > 35000 Then txt_ConsoleNet.Text = ""
    
    txt_ConsoleNet.Text = txt_Console.Text & Data & vbNewLine
    txt_ConsoleNet.SelStart = Len(txt_ConsoleNet.Text) - Len(vbNewLine)
    
End Sub

Public Sub NotUsed1()

End Sub

Private Sub Form_Unload(Cancel As Integer)
    EndLogfile
    SavePlayerDatabase

    SendData "servershutdown"
    DoEvents

    Set IRCClient = Nothing
    Set MyScript = Nothing
    Set clsScriptCommands = Nothing
    
    Unload FrmHTTPServer
    End
End Sub

Private Sub IRCClient_Connected()
    IRCClient.Join IRC.Channel, IRC.Key
End Sub

Private Sub IRCClient_Notice(Nick As String, User As String, Host As String, Target As String, Message As String)
    AppendConsole "_IRC:" & Nick & "@" & Target & "> " & Message
End Sub

Private Sub IRCClient_PrivateMessage(Nick As String, User As String, Host As String, Target As String, Message As String)
On Error GoTo err_handle
Dim sData() As String
Dim Buffer As String
Dim i As Integer

    AppendConsole "_IRC: " & Nick & "@" & Target & "> " & Message

    If Target = IRCClient.UserNick Then
        Target = User
    End If
    
    ScriptCalls.IRCMessageIn Nick, Message
    
    'public things
    If Message = "!server" Then
        IRCClient.PrivMSG Target, "Server IP: " & Socket.LocalIP & " Port: " & Server.ServerPort & " Version: " & AppVersion
        IRCClient.PrivMSG Target, "Server HTTP Server: http://" & Socket.LocalIP & ":" & (Server.ServerPort + 2)
    End If
    
    sData = Split(Message, " ", 4)
    
    If UBound(sData) > 0 Then
        If sData(0) = "!msg" Then
            sData = Split(Message, " ", 2)
            'Send message to server from irc
            SendData "C[" & Nick & "@IRC]: " & sData(1)
            IRCClient.PrivMSG Target, "[" & Nick & "@IRC]: " & sData(1)
        End If
        If sData(0) = "!rcon" Then
            If sData(1) = Server.RconPassword Then
            
                If sData(2) = "rehash" Then
                    LoadBans
                    Mod_LoginDatabase.SavePlayerLogins True
                    Mod_LoginDatabase.LoadPlayerLogins
                    IRCClient.PrivMSG Target, "Rehash complete."
                End If
            
                If sData(2) = "msg" Then
                    'Send message to server from irc
                    SendData "C[" & Nick & "@IRC]: " & sData(3)
                    IRCClient.PrivMSG Target, "[" & Nick & "@IRC]: " & sData(3)
                End If
                
                If sData(2) = "shutdown" Then
                    'Remote Shutdown
                    If sData(3) = "NOW" Then
                        If Nick = "AlienX" Then
                            IRCClient.PrivMSG Target, "Shutting Down Server... Bye!"
                            DoEvents
                            Unload Me
                        End If
                    End If
                End If
                
                If sData(2) = "status" Then
                    'Status Report - Player Names etc
                    IRCClient.PrivMSG Target, "Player ID | Player Name | Player Score | Player In Timeout"
                    For i = 1 To MAX_PLAYERS
                        If Players(i).Connected Then
                            IRCClient.PrivMSG Target, i & " | " & Players(i).PlayerName & " | " & Players(i).Score & " | " & ReverseBoolean(Players(i).Ponged)
                        End If
                    Next
                End If
                
                If sData(2) = "togglewebchat" Then
                    If WebChatEnabled Then
                        WebChatEnabled = False
                        IRCClient.PrivMSG Target, "WebChat has been disabled"
                    Else
                        WebChatEnabled = True
                        IRCClient.PrivMSG Target, "WebChat has been enabled"
                    End If
                End If
                
                If sData(2) = "kick" Then
                    sData = Split(Message, " ")
                    If Players(sData(3)).Connected Then
                        If UBound(sData) > 4 Then
                            sData = Split(Message, " ", 5)
                            Buffer = sData(4)
                        End If
                        SendData "UP" & Chr(10) & "K" & Chr(10) & Buffer, CInt(sData(3)), True
                        IRCClient.PrivMSG Target, Players(sData(3)).PlayerName & " was kicked from the server reason=" & Buffer
                        EraseClient CInt(sData(3))
                    End If
                End If
                
                If sData(2) = "ban" Then
                    sData = Split(Message, " ")
                    If Players(sData(3)).Connected Then
                        If UBound(sData) > 4 Then
                            sData = Split(Message, " ", 5)
                            Buffer = sData(4)
                        End If
                        SendData "UP" & Chr(10) & "B" & Chr(10) & Buffer, CInt(sData(3)), True
                        IRCClient.PrivMSG Target, Players(sData(3)).PlayerName & " was banned from the server reason=" & Buffer
                        SaveBan Players(sData(3)).IP, Players(sData(3)).PlayerName
                        EraseClient CInt(sData(3))
                    End If
                End If
                
                If sData(2) = "weather" Then
                    If CInt(sData(3)) > 45 Then
                        IRCClient.PrivMSG Target, "Weather code is too high, 0 -> 45 are acceptable"
                        Exit Sub
                    End If
                    If CInt(sData(3)) < 0 Then
                        IRCClient.PrivMSG Target, "Weather code is too low, 0 -> 45 are acceptable"
                        Exit Sub
                    End If
                    
                    SendData "W" & Chr(10) & sData(3)
                    SendData "C*** Weather Changed By Admin"
                    IRCClient.PrivMSG Target, "Weather Changed By Admin"
                End If
            Else
                IRCClient.PrivMSG Target, "Invalid Rcon Password"
            End If
        End If
    End If
    
    Exit Sub
    
err_handle:
    IRCClient.PrivMSG Target, "An unspecified error occurred"
End Sub

Private Sub ScriptTimer_Timer(Index As Integer)
On Error GoTo err_handle
    If ScriptTimer(Index).Interval = 0 Then Exit Sub
    MyScript.SControl.Modules(ScriptTimers.TheTimers(Index).Filename).Run ScriptTimers.TheTimers(Index).TimerName
    Exit Sub
err_handle:
    FrmServer.SendData "M2A" & Chr(10) & 255 & Chr(10) & 0 & Chr(10) & 0 & Chr(10) & "Error in timer " & ScriptTimers.TheTimers(Index).Filename & " | " & ScriptTimers.TheTimers(Index).TimerName & " **" & Err.Description & "=[" & Err.Number & "]="
End Sub

Private Sub Socket_DataArrival(ByVal bytesTotal As Long)
On Error GoTo err_handle
Dim RetData As String
Dim CurrentUserID As Integer
Dim CurrentUsername As String
Dim Buffer As String
Dim Operation() As String
Dim SplitData() As String
Dim ChatMessage As String
Dim i As Integer
Dim ii As Integer
Dim NETCODESPLIT() As String
Dim iiii As Integer

'On connection
Dim ICFreePlayerSlot As Integer
Dim ICBuffer As String

'Player Login CVars
Dim PLAYERLOGIN_ERRORS As String
Dim PLAYERLOGIN_ID As Integer

    If bytesTotal < 4 Then Exit Sub
    
    Socket.GetData RetData ', vbString, bytesTotal
    Debug.Print RetData
    
    NETCODESPLIT = Split(RetData, vbNewLine)
    For iiii = 0 To UBound(NETCODESPLIT)
        Operation = Split(NETCODESPLIT(iiii), Chr(10))
        If Operation(0) = "PL" Then
            Socket.SendData Encrypt("youcantcrackme", "SR" & Chr(10) & "VERSION")
            AppendConsole "Connection Broken For " & Operation(1) & ", Version Differs From Server C[" & Operation(2) & "] S[" & AppVersion & "]"
            'IRCClient.PrivMSG IRC.Channel, "Connection Broken: Version Differs From Server C[" & Operation(2) & "] S[" & AppVersion & "]"
            Exit Sub
        End If
    Next
    
    Erase NETCODESPLIT
    Erase Operation
    
    Buffer = Decrypt("NoLongerUsed", RetData)
    RetData = Buffer & vbNewLine
    
    NETCODESPLIT = Split(RetData, vbNewLine)
    
    For iiii = 0 To UBound(NETCODESPLIT)
        RetData = NETCODESPLIT(i)
        If RetData = "" Then Exit Sub
        
        If CheckUserConnectivity(Socket.RemoteHostIP, Socket.RemotePort, CurrentUserID, CurrentUsername) Then
            
            Players(CurrentUserID).Ponged = True
            
            If RetData = "Trainer" Then
                SendData "UP" & Chr(10) & "K" & Chr(10) & "Suspected Trainer Usage", CurrentUserID, True
                IRCClient.PrivMSG IRC.Channel, Players(CurrentUserID).PlayerName & " was kicked from the server reason=Suspected Trainer Usage"
                EraseClient CurrentUserID
            End If
            
            If RetData = "PONG" Then
                Players(CurrentUserID).Ponged = True
                Exit Sub
            End If
            
            'This user is allready connected
            If Mid(RetData, 1, 1) = "C" Then
                ChatMessage = Mid(RetData, 2)
                
                AppendConsole "_CHAT: " & ChatMessage
                AppendNetConsole "_CHAT: " & ChatMessage
                'SendData RetData
                'IRCClient.PrivMSG IRC.Channel, ChatMessage
                AppendChatHistory ChatMessage
                If InStr(1, ChatMessage, ":") > 0 Then
                    ScriptCalls.ChatMessageIn CurrentUserID, Trim(Replace(Replace(Mid(ChatMessage, InStr(1, ChatMessage, ":") + 1), Chr(10), ""), Chr(13), ""))
                End If
                Exit Sub
            End If
            
            Operation = Split(RetData, Chr(10))
            Select Case Operation(0)
            
                Case "PA"
                    Select Case Operation(1)
                        Case "HandsUp"
                            SendData RetData, CurrentUserID
                            ScriptCalls.PlayerActionStart CurrentUserID, 0
                        Case "Finger"
                            SendData RetData, CurrentUserID
                            ScriptCalls.PlayerActionStart CurrentUserID, 1
                        Case "HandsCower"
                            SendData RetData, CurrentUserID
                            ScriptCalls.PlayerActionStart CurrentUserID, 2
                        Case "Cower"
                            SendData RetData, CurrentUserID
                            ScriptCalls.PlayerActionStart CurrentUserID, 3
                        Case "UseATM"
                            SendData RetData, CurrentUserID
                            ScriptCalls.PlayerActionStart CurrentUserID, 4
                        Case "LookAround"
                            SendData RetData, CurrentUserID
                            ScriptCalls.PlayerActionStart CurrentUserID, 5
                        Case "Kill" 'Known as Death to other people :P
                            'ESCMkill_actorActorID
                            'Action|kill|2PlayerID
                            SendData RetData, CurrentUserID
                            ScriptCalls.PlayerDeath CurrentUserID, 255, 0
                        Case "KillID"
                            '0 PA
                            '1 KillID
                            '2 CONID
                            '3 Nickname (OR UNKWNPLYR)
                            '4 WeaponID (OR Unknown Weapon [ID])
                            ScriptCalls.PlayerKill Operation(2), Operation(3), Operation(4)
                        Case "Respawned"
                            'Action|respawned|playerid
                            SendData RetData, CurrentUserID
                            ScriptCalls.PlayerRespawned CurrentUserID
                    End Select
                    
            
                Case "Status"
                    If Operation(1) = "Started" Then
                        ScriptCalls.PlayerStartedGame CurrentUserID
                    ElseIf Operation(1) = "Playing" Then
                        ScriptCalls.PlayerPlaying CurrentUserID
                    End If
            
                Case "MEC"
                    ChatMessage = Operation(1)
                    
                    AppendConsole "_MECHAT: " & ChatMessage
                    AppendNetConsole "_MECHAT: " & ChatMessage
                    SendData RetData
                    IRCClient.PrivMSG IRC.Channel, ChatMessage
                    AppendChatHistory ChatMessage
    
                Case "GV"
                    i = CInt(Operation(1))
                    Buffer = "GetScriptVehicle" & Chr(10) & i & Chr(9) & ScriptVehicles(i).Model & ":" & ScriptVehicles(i).X & " " & ScriptVehicles(i).Y & " " & ScriptVehicles(i).Z & ":" & ScriptVehicles(i).Rotation & Chr(10)

                    If i + 1 <= ScriptVehicleCount Then
                       Buffer = Buffer & i + 1 & Chr(9) & ScriptVehicles(i + 1).Model & ":" & ScriptVehicles(i + 1).X & " " & ScriptVehicles(i + 1).Y & " " & ScriptVehicles(i + 1).Z & ":" & ScriptVehicles(i + 1).Rotation & Chr(10)
                    End If
                    If i + 2 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 2 & Chr(9) & ScriptVehicles(i + 2).Model & ":" & ScriptVehicles(i + 2).X & " " & ScriptVehicles(i + 2).Y & " " & ScriptVehicles(i + 2).Z & ":" & ScriptVehicles(i + 2).Rotation & Chr(10)
                    End If
                    If i + 3 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 3 & Chr(9) & ScriptVehicles(i + 3).Model & ":" & ScriptVehicles(i + 3).X & " " & ScriptVehicles(i + 3).Y & " " & ScriptVehicles(i + 3).Z & ":" & ScriptVehicles(i + 3).Rotation & Chr(10)
                    End If
                    If i + 4 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 4 & Chr(9) & ScriptVehicles(i + 4).Model & ":" & ScriptVehicles(i + 4).X & " " & ScriptVehicles(i + 4).Y & " " & ScriptVehicles(i + 4).Z & ":" & ScriptVehicles(i + 4).Rotation & Chr(10)
                    End If
                    If i + 5 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 5 & Chr(9) & ScriptVehicles(i + 5).Model & ":" & ScriptVehicles(i + 5).X & " " & ScriptVehicles(i + 5).Y & " " & ScriptVehicles(i + 5).Z & ":" & ScriptVehicles(i + 5).Rotation & Chr(10)
                    End If
                    If i + 6 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 6 & Chr(9) & ScriptVehicles(i + 6).Model & ":" & ScriptVehicles(i + 6).X & " " & ScriptVehicles(i + 6).Y & " " & ScriptVehicles(i + 6).Z & ":" & ScriptVehicles(i + 6).Rotation & Chr(10)
                    End If
                    If i + 7 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 7 & Chr(9) & ScriptVehicles(i + 7).Model & ":" & ScriptVehicles(i + 7).X & " " & ScriptVehicles(i + 7).Y & " " & ScriptVehicles(i + 7).Z & ":" & ScriptVehicles(i + 7).Rotation & Chr(10)
                    End If
                    If i + 8 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 8 & Chr(9) & ScriptVehicles(i + 8).Model & ":" & ScriptVehicles(i + 8).X & " " & ScriptVehicles(i + 8).Y & " " & ScriptVehicles(i + 8).Z & ":" & ScriptVehicles(i + 8).Rotation & Chr(10)
                    End If
                    If i + 9 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 9 & Chr(9) & ScriptVehicles(i + 9).Model & ":" & ScriptVehicles(i + 9).X & " " & ScriptVehicles(i + 9).Y & " " & ScriptVehicles(i + 9).Z & ":" & ScriptVehicles(i + 9).Rotation & Chr(10)
                    End If
                    If i + 10 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 10 & Chr(9) & ScriptVehicles(i + 10).Model & ":" & ScriptVehicles(i + 10).X & " " & ScriptVehicles(i + 10).Y & " " & ScriptVehicles(i + 10).Z & ":" & ScriptVehicles(i + 10).Rotation & Chr(10)
                    End If
                    If i + 11 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 11 & Chr(9) & ScriptVehicles(i + 11).Model & ":" & ScriptVehicles(i + 11).X & " " & ScriptVehicles(i + 11).Y & " " & ScriptVehicles(i + 11).Z & ":" & ScriptVehicles(i + 11).Rotation & Chr(10)
                    End If
                    If i + 12 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 12 & Chr(9) & ScriptVehicles(i + 12).Model & ":" & ScriptVehicles(i + 12).X & " " & ScriptVehicles(i + 12).Y & " " & ScriptVehicles(i + 12).Z & ":" & ScriptVehicles(i + 12).Rotation & Chr(10)
                    End If
                    If i + 13 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 13 & Chr(9) & ScriptVehicles(i + 13).Model & ":" & ScriptVehicles(i + 13).X & " " & ScriptVehicles(i + 13).Y & " " & ScriptVehicles(i + 13).Z & ":" & ScriptVehicles(i + 13).Rotation & Chr(10)
                    End If
                    If i + 14 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 14 & Chr(9) & ScriptVehicles(i + 3).Model & ":" & ScriptVehicles(i + 3).X & " " & ScriptVehicles(i + 3).Y & " " & ScriptVehicles(i + 3).Z & ":" & ScriptVehicles(i + 3).Rotation & Chr(10)
                    End If
                    If i + 15 <= ScriptVehicleCount Then
                        Buffer = Buffer & i + 15 & Chr(9) & ScriptVehicles(i + 3).Model & ":" & ScriptVehicles(i + 3).X & " " & ScriptVehicles(i + 3).Y & " " & ScriptVehicles(i + 3).Z & ":" & ScriptVehicles(i + 3).Rotation & Chr(10)
                    End If
                'Next
                
                    SendData Buffer, CurrentUserID, True
                    
                Case "GM" 'GetMap
                    i = CInt(Operation(1))
                    Buffer = "GetScriptMap" & Chr(10) & i & " " & MapEngine_Storage(i).WholeObject & Chr(10)
                    
                    For ii = (i + 1) To (i + 15)
                        If ii <= MapEngine.Objects Then
                            Buffer = Buffer & ii & " " & MapEngine_Storage(ii).WholeObject & Chr(10)
                        End If
                    Next
                    
                    SendData Buffer, CurrentUserID, True
                    
                Case "QUIT"             'QUIT|ClientID|NickName
                    PlayerQuitProcess Operation(1), Operation(2)
                    
                Case "NC"               'NewCar|CarId
                    If Val(Operation(1)) > UBound(Vehicles) Or Val(Operation(1)) < LBound(Vehicles) Then
                        AppendConsole "_VEHICLE: " & CurrentUsername & "got into a Unknown Vehicle"
                    Else
                        AppendConsole "_VEHICLE: " & CurrentUsername & "got into a " & Vehicles(Operation(1)).VehicleName & " and is now driving the streets"
                        SendData "C**" & CurrentUsername & " Got Into A " & Vehicles(Operation(1)).VehicleName, CurrentUserID
                    End If
                Case "OF"               'OnFoot
                    AppendConsole "_FOOT: " & CurrentUsername & " is now walking the streets"
                Case "SC"               'StateChange|NewState
                    AppendConsole "_STATE: " & CurrentUsername & " changed state, new state: " & Operation(1)
                Case "SG"               'Start Game Request - Allways Accepted Untill Admin Is Coded
                    AppendConsole "_REQUEST: " & CurrentUsername & " attempted to start the game, Allowing attempt now"
                    SendData "SG" & Chr(10) & "ACCEPT", CurrentUserID, True
                Case "SCORE"            'New Score In - Time To Broadcast To users And Update Scoreboards On Clients
                    '0 = Score
                    '1 = ConID
                    '2 = Money Earned
                    '3 = Total Cash
                    Players(Operation(1)).Score = CLng(Operation(3))
                    SendData RetData & Chr(10) & Players(Operation(1)).PlayerName
                    AppendConsole "_SCORE: Player " & Players(Operation(1)).PlayerName & " scored " & Operation(2) & " to leave a total of " & Operation(3)
                    
                    UpdatePlayer Players(Operation(1)).PlayerName, , , Operation(2)
                    UpdatePlayer Players(Operation(1)).PlayerName, , , , , , , , Operation(2)
                    
                    'Check for a winner
                    If Server.GameMode.GameMode = "1" Then
                        For i = 1 To MAX_PLAYERS
                            If CLng(Players(i).Score) >= CLng(Server.GameMode.Settings) Then
                                'A player has won!
                                SendData "C[debug]WINNER: " & Players(i).PlayerName
                                SendData "WIN" & Chr(10) & i & Chr(10) & Operation(3)
                            End If
                        Next
                    End If
                    
                Case "F", "F2", "F3"
                    'Foot Data
                    'X=2
                    'Y=3
                    'Z=4
                    'HP=5
                    
                    If CSng(Operation(2)) = 0 Then Exit Sub
                    If CSng(Operation(3)) = 0 Then Exit Sub
                    If CSng(Operation(4)) = 0 Then Exit Sub
                    If CSng(Operation(5)) = 0 Then Exit Sub
                    SendData RetData, CurrentUserID
                    
                    Players(Operation(1)).LastVehicleID = -1
                    
                    PlayerLogins(Players(CurrentUserID).ServerID).GameData.CurrentX = CSng(Operation(2))
                    PlayerLogins(Players(CurrentUserID).ServerID).GameData.CurrentY = CSng(Operation(3))
                    PlayerLogins(Players(CurrentUserID).ServerID).GameData.CurrentZ = CSng(Operation(4))
                    PlayerLogins(Players(CurrentUserID).ServerID).GameData.Health = CSng(Operation(5))
                                        
                    If Players(CInt(Operation(1))).CurrentPlayerState = 0 Then Players(CInt(Operation(1))).CurrentPlayerState = PlayerState_OnFoot
                                        
                    If Players(CInt(Operation(1))).CurrentPlayerState <> PlayerState_OnFoot Then
                        Players(CInt(Operation(1))).CurrentPlayerState = PlayerState_OnFoot
                        ScriptCalls.PlayerExitVehicle Operation(1), Players(CInt(Operation(1))).LastVehicleID - 1, 1
                    End If
                    
                Case "V", "V2", "VT"
                    'Vehicle Data
                    'X=
                    'Y=
                    'Z=
                    SendData RetData, CurrentUserID
                    
                    If Operation(0) <> "VT" Then
                        Players(CInt(Operation(1))).CurrentPlayerState = PlayerState_Driving
                        Players(CInt(Operation(1))).LastVehicleID = CInt(Operation(2))
                        If Players(CInt(Operation(1))).CurrentPlayerState <> PlayerState_Driving Then
                            'Data(0) = PlayerID
                            'Data(1) = VehicleID
                            'Data(3) = In/Getting in state (In = 1, Gettingin = 0)
                            'Data(4) = SeatID (-1 if its driver)
    
                            ScriptCalls.PlayerEnterVehicle Operation(1), Operation(2), 1, -1
                        End If
                        
                    End If
                    
                    If Operation(0) = "V" Then
                        If CSng(Operation(3)) = 0 Then Exit Sub
                        If CSng(Operation(4)) = 0 Then Exit Sub
                        If CSng(Operation(5)) = 0 Then Exit Sub
                        ScriptVehicles(Operation(2) + 1).X = Operation(3)
                        ScriptVehicles(Operation(2) + 1).Y = Operation(4)
                        ScriptVehicles(Operation(2) + 1).Z = Operation(5)
                        ScriptVehicles(Operation(2) + 1).Health = CSng(Operation(23))
                    End If
                    If Operation(0) = "VT" Then
                        If CSng(Operation(4)) = 0 Then Exit Sub
                        If CSng(Operation(5)) = 0 Then Exit Sub
                        If CSng(Operation(6)) = 0 Then Exit Sub
                        ScriptVehicles(Operation(2) + 1).X = Operation(4)
                        ScriptVehicles(Operation(2) + 1).Y = Operation(5)
                        ScriptVehicles(Operation(2) + 1).Z = Operation(6)
                    End If
                    Players(Operation(1)).LastVehicleID = CInt(Operation(2)) + 1
                    
                'P|ConID|VehID|SeatID
                Case "P"
                    SendData RetData, CurrentUserID
                    
                    If Players(CInt(Operation(1))).CurrentPlayerState <> PlayerState_Passenger Then
                        ScriptCalls.PlayerEnterVehicle Operation(1), Operation(2), 1, Operation(3)
                    End If
                    Players(CInt(Operation(1))).CurrentPlayerState = PlayerState_Passenger
                    
                Case "G"
                    'garage door
                    SendData RetData, CurrentUserID
                    
                'EVDriving|CONID|VehID
                'EVFoot|CONID|VehID
                Case "EVDriving"
                    ScriptCalls.PlayerExitVehicle Operation(1), Operation(2), 0
                    SendData RetData, CurrentUserID
                    
                Case "EVFoot"
                    ScriptCalls.PlayerEnterVehicle Operation(1), Operation(2), 0, -1
                    SendData RetData, CurrentUserID
                    
                'EVFootPassenger|ConID|VehID|SeatID
                Case "EVFootPassenger"
                    ScriptCalls.PlayerEnterVehicle Operation(1), Operation(2), 0, Operation(3)
                    SendData RetData, CurrentUserID
                    
                Case Else               'Normally vehicle and foot data!
                    'Preform General Check For Foot And Vehicle Data ONLY
                    'If Mid(RetData, 1, 1) <> "F" Or Mid(RetData, 1, 1) <> "V" Then Exit Sub
                    SendData RetData, CurrentUserID
            End Select
        Else
            'User isnt connected, should be a connect packet
            Operation = Split(RetData, Chr(10))
            
            If Operation(0) = "PL" Then 'playerlogin
                AppendConsole "Incomming player login request from " & Socket.RemoteHostIP & " - [" & Operation(1) & "]"
                
                If ProcessPlayerLogin(Operation(1), Operation(2), PLAYERLOGIN_ERRORS) = True Then
                    'Player has logged in... Send the packet!
                    Socket.RemoteHost = Socket.RemoteHostIP
                    Socket.SendData Encrypt("youcantcrackme", "LOGIN" & Chr(10) & "PASS")
                    IRCClient.PrivMSG IRC.Channel, "Player Logged In: " & Operation(1)
                    
                    AppendConsole "Incomming connection from " & Socket.RemoteHostIP & " - " & Operation(1)
                    
                    PLAYERLOGIN_ID = ConvertPlayerLoginNameToID(Operation(1))
                    If IsBanned(Socket.RemoteHostIP) Then PlayerLogins(PLAYERLOGIN_ID).Banned = True
                    If PlayerLogins(PLAYERLOGIN_ID).Banned Then
                        Socket.SendData Encrypt("youcantcrackme", "SR" & Chr(10) & "Banned")
                        IRCClient.PrivMSG IRC.Channel, "Player " & Operation(1) & " unable to login, Reason: ACCOUNT BANNED"
                        Exit Sub
                    End If
                    
                    If UBound(Operation) < 3 Then
                        Socket.SendData Encrypt("youcantcrackme", "SR" & Chr(10) & "KICKED")
                        Exit Sub
                    End If
                    If Operation(3) <> AppVersion Then
                        Socket.SendData Encrypt("youcantcrackme", "SR" & Chr(10) & "VERSION")
                        AppendConsole "Connection Broken: Version Differs From Server C[" & Operation(2) & "] S[" & AppVersion & "]"
                        'IRCClient.PrivMSG IRC.Channel, "Connection Broken: Version Differs From Server C[" & Operation(2) & "] S[" & AppVersion & "]"
                        Exit Sub
                    End If
                    
                    ICFreePlayerSlot = FindFreePlayerSlot(Operation(1))
                    If ICFreePlayerSlot = -1 Then
                    
                    ElseIf ICFreePlayerSlot = -2 Then
                        Socket.SendData Encrypt("youcantcrackme", "SR" & Chr(10) & "NICKNAME")
                        AppendConsole "Connection Broken: Username Allready Being Used"
                        Exit Sub
                    ElseIf ICFreePlayerSlot > Server.MaxPlayers Then
                        Socket.SendData Encrypt("youcantcrackme", "SR" & Chr(10) & "FULL")
                        AppendConsole "Connection Broken: Server Is Full"
                        Exit Sub
                    ElseIf ICFreePlayerSlot = -1 Then
                        Socket.SendData Encrypt("youcantcrackme", "SR" & Chr(10) & "FULL")
                        AppendConsole "Connection Broken: Server Is Full"
                        Exit Sub
                    End If
                    
                    Players(ICFreePlayerSlot).Connected = True
                    Players(ICFreePlayerSlot).Ponged = True
                    Players(ICFreePlayerSlot).Port = Socket.RemotePort
                    Players(ICFreePlayerSlot).IP = Socket.RemoteHostIP
                    Players(ICFreePlayerSlot).PlayerName = PlayerLogins(PLAYERLOGIN_ID).Nickname
                    Players(ICFreePlayerSlot).ServerID = PLAYERLOGIN_ID
                    
                    Buffer = "SR" & Chr(10)                             'Server Responce    0
                    Buffer = Buffer & Server.ServerName & Chr(10)       'Server Name        1
                    Buffer = Buffer & ICFreePlayerSlot & Chr(10)        'ConnectionID       2
                    Buffer = Buffer & Server.Weather & Chr(10)          'Weather            3
                    Buffer = Buffer & Server.GameTime.Hour & Chr(10)    'Game time (HOUR)   4
                    Buffer = Buffer & Server.GameTime.Minute & Chr(10)  'Game Time (MIN)    5
                    Buffer = Buffer & Server.FootInterval & Chr(10)     'Foot Interval      6
                    Buffer = Buffer & Server.MOTDURL & Chr(10)          'MOTD URL           7
                    Buffer = Buffer & ScriptVehicleCount & Chr(10)     'Vehicle Count      8
                    
                    'Now the player data
                    'admin, nick, x, y, z, hp, cash, rot, skin, id
                    Buffer = Buffer & PlayerLogins(Players(ICFreePlayerSlot).ServerID).Admin & Chr(10)   'Admin 9
                    Buffer = Buffer & PlayerLogins(Players(ICFreePlayerSlot).ServerID).Nickname & Chr(10)   'Nickname 10
                    Buffer = Buffer & PlayerLogins(Players(ICFreePlayerSlot).ServerID).GameData.CurrentX & Chr(10)    'X 11
                    Buffer = Buffer & PlayerLogins(Players(ICFreePlayerSlot).ServerID).GameData.CurrentY & Chr(10)    'Y 12
                    Buffer = Buffer & PlayerLogins(Players(ICFreePlayerSlot).ServerID).GameData.CurrentZ & Chr(10)    'Z 13
                    Buffer = Buffer & PlayerLogins(Players(ICFreePlayerSlot).ServerID).GameData.Health & Chr(10)    'Health 14
                    Buffer = Buffer & PlayerLogins(Players(ICFreePlayerSlot).ServerID).GameData.Money & Chr(10)    'Money 15
                    Buffer = Buffer & PlayerLogins(Players(ICFreePlayerSlot).ServerID).GameData.Rotation & Chr(10) 'Rotation 16
                    Buffer = Buffer & PlayerLogins(Players(ICFreePlayerSlot).ServerID).GameData.Skin & Chr(10) 'Skin 17
                    Buffer = Buffer & Players(ICFreePlayerSlot).ServerID & Chr(10) 'ServerID 18
                    Buffer = Buffer & MapEngine.Objects & Chr(10) 'Map Object Count 19
                    Buffer = Buffer & PlayerLogins(Players(ICFreePlayerSlot).ServerID).Level & Chr(10) 'Player Level 20
                    Buffer = Buffer & PlayerLogins(Players(ICFreePlayerSlot).ServerID).Level & Chr(10) 'Player XP 21
                    
                    For i = 1 To MAX_PLAYERS
                        If Players(i).PlayerName <> "" Then
                            Buffer = Buffer & Players(i).PlayerName & Chr(9) & PlayerLogins(Players(i).ServerID).GameData.Skin & Chr(10)
                        End If
                    Next
                    
                    'Send off the server information
                    Socket.RemoteHost = Socket.RemoteHostIP
                    Socket.SendData Encrypt("youcantcrackme", Buffer)
                    
                    'Save their information for us!
                    AppendConsole "Connection Accepted"
                    AppendConsole "_JOIN: " & Operation(1) & " has joined the game"
                    IRCClient.PrivMSG IRC.Channel, Operation(1) & " has joined the game"
                    SaveNewPlayer Operation(1)
                    SendData "NC" & Chr(10) & Players(ICFreePlayerSlot).PlayerName & Chr(10) & PlayerLogins(Players(ICFreePlayerSlot).ServerID).GameData.Skin & Chr(10) & ICFreePlayerSlot, i
                Else
                    Select Case PLAYERLOGIN_ERRORS
                        Case "WRONGPASSWORD"
                            'The batty has got the password wrong, tell the client this.
                            Socket.RemoteHost = Socket.RemoteHostIP
                            Socket.SendData Encrypt("youcantcrackme", "LOGIN" & Chr(10) & "WRONGPASSWORD")
                        Case "NOACCOUNT"
                            'The account does not exist.
                            Socket.RemoteHost = Socket.RemoteHostIP
                            Socket.SendData Encrypt("youcantcrackme", "LOGIN" & Chr(10) & "NOACCOUNT")
                    End Select
                End If
            End If
            
            If Operation(0) = "PLC" Then 'PlayerLoginCreate
                '0=plc
                '1=uname
                '2=pword
                '3=cname
                '4=email
                'size=4
                
                If IsBanned(Socket.RemoteHostIP) Then
                    IRCClient.PrivMSG IRC.Channel, "Account Creation Pending.... ACCOUNT UNABLE TO BE CREATED [" & Operation(1) & "|" & Operation(3) & "] - ACCOUNT BANNED"
                    Socket.SendData Encrypt("youcantcrackme", "PLCR" & Chr(10) & "ERROR")
                    Exit Sub
                End If
                
                IRCClient.PrivMSG IRC.Channel, "Account Creation Pending.... ACCOUNT CREATED [" & Operation(1) & "|" & Operation(3) & "]"
                
                If UBound(Operation) = 4 Then
                    CreatePlayerLogin Operation(1), Operation(2), Operation(4), Operation(3), False
                    Socket.SendData Encrypt("youcantcrackme", "PLCR" & Chr(10) & "OKAY")
                    Exit Sub
                Else
                    Socket.SendData Encrypt("youcantcrackme", "PLCR" & Chr(10) & "ERROR")
                    Exit Sub
                End If
            End If
            
            If Operation(0) = "IC" Then

            End If
        End If
        
        Exit Sub
    Next
err_handle:
End Sub

Public Sub NotUsed2()

End Sub

Private Sub Socket_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    DisplayError "Socket Error: " & Description
End Sub

Private Sub SocketAdmin_DataArrival(ByVal bytesTotal As Long)
On Error GoTo err_handle
Dim RetData As String
Dim SplitData() As String
Dim CurrentUser As Integer
Dim i As Integer
    
    SocketAdmin.GetData RetData
    
    SplitData = Split(RetData, Chr(10))
    
    If CheckUserConnectivityADMIN(SocketAdmin.RemoteHostIP, SocketAdmin.RemotePort, CurrentUser) Then
        If UBound(SplitData) > 1 Then
            Select Case SplitData(0)

                Case "logout"
                    
            End Select
        End If
    Else
        If UBound(SplitData) > 0 Then
            Select Case SplitData(0)
            
                Case "login"
                    If SplitData(1) = Server.RconPassword Then
                        For i = 1 To 10
                            If ConnectedAdmins(i).IP = "" Then
                                ConnectedAdmins(i).IP = SocketAdmin.RemoteHostIP
                                ConnectedAdmins(i).Port = SocketAdmin.RemotePort
                                ConnectedAdmins(i).Ponged = True
                                
                                IRCClient.PrivMSG IRC.Channel, "Remote Admin connected"
                                Exit For
                            End If
                        Next
                    End If
                    
            End Select
        End If
    End If
    
    Exit Sub
    
err_handle:
End Sub

Private Sub SocketIRC_Close()
    IRCClient.Quit ""
End Sub

Private Sub SocketIRC_Connect()
    IRCClient.Connected
End Sub

Private Sub SocketIRC_DataArrival(ByVal bytesTotal As Long)
On Error Resume Next
Dim RetData As String
    SocketIRC.GetData RetData
    IRCClient.RecvData RetData
End Sub

Private Sub Tmr_AutoSave_Timer()
Static Tmr_AutoSave_Counter As Integer

    Tmr_AutoSave_Counter = Tmr_AutoSave_Counter + 1
    If Tmr_AutoSave_Counter = 5 Then
        Mod_LoginDatabase.SavePlayerLogins
        Tmr_AutoSave_Counter = 0
    End If
End Sub

Private Sub tmr_ClientUpdate_Timer()
Dim Buffer As String
Dim i As Integer

    Buffer = "PLU" & Chr(10)
    For i = 1 To MAX_PLAYERS
        If Players(i).PlayerName <> "" Then
            Buffer = Buffer & Players(i).PlayerName & Chr(9) & PlayerLogins(Players(i).ServerID).GameData.Skin & Chr(10)
        End If
    Next
    
    SendData Buffer
End Sub

Private Sub tmr_GameClock_Timer()
Dim Winner As String

    SendData "T" & Chr(10) & Server.GameTime.Hour & Chr(10) & Server.GameTime.Minute

    If txt_ErrorMessage.Visible Then
        If ErrorMessageSelector Then
            txt_ErrorMessage.ForeColor = txt_ErrorMessage.BackColor
            ErrorMessageSelector = False
            tmr_GameClock.Interval = 1000
        Else
            txt_ErrorMessage.ForeColor = vbWhite
            ErrorMessageSelector = True
            tmr_GameClock.Interval = 3000
        End If
    End If
    
    tmr_ClientUpdate.Interval = 30000
    
End Sub

Public Sub DisplayError(Data As String)
    tmr_GameClock.Interval = 3000
    txt_ErrorMessage.Visible = True
    txt_Console.Text = ""
    txt_ErrorMessage.Text = Data
End Sub

Public Sub LoadScript(Path As String)
Dim Strdata As String
Dim SplitData() As String
Dim SplitVehicle() As String
Dim i As Integer
Dim t As Double
Dim ff As Integer

        AppendConsole "Loading Script"
                    
        'Camera_Point
        'Strdata = GetFromINI("scriptstart", "Camera_Point", Path)
        'If Strdata <> "" Then
        '    SplitData = Split(Strdata, " ")
        '    If UBound(SplitData) = 2 Then
        '        Script.Camera_Point = Strdata
        '    Else
        '        DisplayError "Script Error: Invalid Camera_Point Value"
        '        Exit Sub
        '    End If
        'Else
        '    DisplayError "Script Contains Errors: Camera Point Empty"
        '    Exit Sub
        'End If
        '
        ''camera
        'Strdata = GetFromINI("scriptstart", "Camera", Path)
        'If Strdata <> "" Then
        '    SplitData = Split(Strdata, " ")
        '    If UBound(SplitData) = 2 Then
        '        Script.Camera = Strdata
        '
        '    Else
        '        DisplayError "Script Error: Invalid Camera Value"
        '        Exit Sub
        '    End If
        'Else
        '    DisplayError "Script Contains Errors: Camera Empty"
        '    Exit Sub
        'End If
        '
        ''Default Spawn
        'Strdata = GetFromINI("scriptstart", "DefaultSpawn", Path)
        'If Strdata <> "" Then
        '    SplitData = Split(Strdata, " ")
        '    If UBound(SplitData) = 2 Then
        '        Script.DefaultSpawn = Strdata
        '    Else
        '        DisplayError "Script Error: Invalid DefaultSpawn Value"
        '        Exit Sub
        '    End If
        'Else
        '    DisplayError "Script Contains Errors: DefaultSpawn Empty"
        '    Exit Sub
        'End If
        '
        'For i = 1 To 10
        '    'Default Spawn
        '    Strdata = GetFromINI("spawnsystem", "Spawn" & i, Path)
        '    If Strdata <> "" Then
        '        SplitData = Split(Strdata, ":")
        '        SplitVehicle = Split(SplitData(0), " ")
        '        If UBound(SplitVehicle) = 2 Then
        '            If UBound(SplitData) = 1 Then
        '                Select Case i
        '                    Case 1: Script.Spawn1 = SplitData(0) & ":" & SplitData(1)
        '                    Case 2: Script.Spawn2 = SplitData(0) & ":" & SplitData(1)
        '                    Case 3: Script.Spawn3 = SplitData(0) & ":" & SplitData(1)
        '                    Case 4: Script.Spawn4 = SplitData(0) & ":" & SplitData(1)
        '                    Case 5: Script.Spawn5 = SplitData(0) & ":" & SplitData(1)
        '                    Case 6: Script.Spawn6 = SplitData(0) & ":" & SplitData(1)
        '                    Case 7: Script.Spawn7 = SplitData(0) & ":" & SplitData(1)
        '                    Case 8: Script.Spawn8 = SplitData(0) & ":" & SplitData(1)
        '                    Case 9: Script.Spawn9 = SplitData(0) & ":" & SplitData(1)
        '                    Case 10: Script.Spawn10 = Strdata
        '                End Select
        '            Else
        '                DisplayError "Script Error: invalid [spawnsystem] Values"
        '            End If
        '        Else
        '            DisplayError "Script Error: Invalid [spawnsystem] Values"
        '            Exit Sub
        '        End If
        '    Else
        '        DisplayError "Script Contains Errors: Invlid [spawnsystem] (You MUST have 10 spawn points)"
        '        Exit Sub
        '    End If
        '    DoEvents
        'Next
        
        Strdata = " "
        i = 0
        Do While Strdata <> ""
            Strdata = GetFromINI("vehicles", "Vehicle_" & i, Path)
            If Strdata = "" Then Exit Do
                SplitData = Split(Strdata, ":")
                If UBound(SplitData) = 2 Then
                    ScriptVehicles(i).Model = SplitData(0)
                    ScriptVehicles(i).Rotation = SplitData(2)
                    SplitData = Split(SplitData(1), " ")
                    If UBound(SplitData) = 2 Then
                        ScriptVehicles(i).X = SplitData(0)
                        ScriptVehicles(i).Y = SplitData(1)
                        ScriptVehicles(i).Z = SplitData(2)
                    Else
                        DisplayError "Vehicle_ " & i & " Coords Contains Errors"
                        Exit Sub
                    End If
                Else
                    DisplayError "Vehicle_ " & i & " Contains Errors"
                    Exit Sub
                End If
            i = i + 1
            If i = 5001 Then Exit Do
            DoEvents
        Loop
        
        If i > 5000 Then
            DisplayError "You have over 5000 vehicles in the script, the limit is 5000"
            Exit Sub
        End If
        
        ScriptVehicleCount = i - 1
        
        'Script.Vehicles = i - 1 & Chr(10) & Script.VehiclesBuffer
                
        AppendConsole "Loading Script... OKAY!"
        AppendConsole "There are " & ScriptVehicleCount + 1 & " vehicles in this script"
End Sub

Public Sub LoadCars()
Dim i As Integer
Dim RetData As String
Dim CarSplit() As String
Dim ff As Integer

    AppendConsole "Loading Cars"
    
    ff = FreeFile
    Open App.Path & "\Cars.cfg" For Input As #ff
        Do While Not EOF(ff)
            Line Input #ff, RetData
            CarSplit = Split(RetData, ",")
            Vehicles(Val(CarSplit(0))).VehicleName = CarSplit(1)
        Loop
    Close #ff
    
    AppendConsole "Loading Cars... OKAY!"
End Sub

Public Sub StartServer()
On Error GoTo err_handle
    Tmr_Weather.Interval = 1000
    tmr_PlayerStats.Interval = 1000
    AppendConsole "Preparing To Start Server"
    Socket.Bind Server.ServerPort
    SocketAdmin.Bind Server.ServerPort + 1
    FrmHTTPServer.Show
    AppendConsole "Server Started!"
    AppendConsole "----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------"
    
    IRCClient.PrivMSG IRC.Channel, "4RPG: Andreas Server Started, Welcome to RPG: Andreas Players!"
    
    LoadAndInitScripts
    
    Exit Sub
err_handle:
    DisplayError "Socket Error: " & Err.Description
End Sub

Public Sub SendData(Data As String, Optional SkipUserID As Integer, Optional SendTooSkipUserIDOnly As Boolean)
On Error Resume Next
Dim i As Integer
            
            
    Data = Encrypt("youcantcrackme", Data)
            
    If SkipUserID > 0 Then
        If SendTooSkipUserIDOnly Then
            If Players(SkipUserID).Connected Then
                Socket.RemoteHost = Players(SkipUserID).IP
                Socket.RemotePort = Players(SkipUserID).Port
                Socket.SendData Data
            End If
        Else
            For i = 1 To MAX_PLAYERS
                If i <> SkipUserID Then
                    If Players(i).Connected Then
                        Socket.RemoteHost = Players(i).IP
                        Socket.RemotePort = Players(i).Port
                        Socket.SendData Data
                    End If
                End If
            Next
        End If
    Else
        For i = 1 To MAX_PLAYERS
            If Players(i).Connected Then
                Socket.RemoteHost = Players(i).IP
                Socket.RemotePort = Players(i).Port
                Socket.SendData Data
            End If
        Next
    End If
End Sub

Public Function CheckUserConnectivity(IP As String, Port As String, UserID As Integer, UserNick As String) As Boolean
Dim i As Integer
    CheckUserConnectivity = False
    For i = 1 To MAX_PLAYERS
        If Players(i).Connected Then
            If Players(i).IP = IP Then
                If Players(i).Port = Port Then
                    UserID = i
                    UserNick = Players(i).PlayerName
                    CheckUserConnectivity = True
                    Exit Function
                End If
            End If
        End If
    Next
End Function

Public Function CheckUserConnectivityADMIN(IP As String, Port As String, UserID As Integer) As Boolean
Dim i As Integer
    CheckUserConnectivityADMIN = False
    For i = 1 To 10
        If ConnectedAdmins(i).IP = IP Then
            If ConnectedAdmins(i).Port = Port Then
                UserID = i
                CheckUserConnectivityADMIN = True
                Exit Function
            End If
        End If
    Next
End Function

Public Sub EraseClient(UserID As Integer)
    SavePlayerLogins
    Players(UserID).Connected = False
    Players(UserID).IP = ""
    Players(UserID).PlayerName = ""
    Players(UserID).Ponged = False
    Players(UserID).Port = 0
    Players(UserID).Score = 0
    Players(UserID).CurrentPlayerState = 0
End Sub

Public Function FindFreePlayerSlot(Nickname As String) As Integer
Dim i As Integer
    FindFreePlayerSlot = -1
    For i = 1 To MAX_PLAYERS
        If Players(i).Connected Then
            If Players(i).PlayerName = Nickname Then
                FindFreePlayerSlot = -2
                Exit Function
            End If
        End If
    Next
    
    For i = 1 To MAX_PLAYERS
        If Not Players(i).Connected Then
            FindFreePlayerSlot = i
            Exit Function
        End If
    Next

End Function

Private Sub Tmr_Ping_Timer()
    SendData "PING"
End Sub

Private Sub tmr_PlayerStats_Timer()
Dim i As Integer
Dim ii As Integer

    For i = 1 To 30000
        If PlayerStats(i).PlayerName <> "" Then
            If IsPlayerConnected(PlayerStats(i).PlayerName) Then
                'Update the time the user has been online
                If PlayerStats(i).TotalTimePlayed = "" Then PlayerStats(i).TotalTimePlayed = 0
                PlayerStats(i).TotalTimePlayed = (PlayerStats(i).TotalTimePlayed + 1)
            End If
        End If
    Next
End Sub

Private Sub Tmr_SphereCheck_Timer()
    ScanSpheres
End Sub

Private Sub Tmr_Timeout_Timer()

Dim i As Integer
    For i = 1 To MAX_PLAYERS
        If Players(i).Connected Then
            If Not Players(i).Ponged Then
                PlayerQuitProcess i, Players(i).PlayerName
                Exit For
            Else
                Players(i).Ponged = False
            End If
        End If
    Next
End Sub

Private Sub Tmr_Weather_Timer()
Static WeatherClock As Integer
Dim TheNewWeather As Integer

    If Server.LockWeather Then Exit Sub
    
    WeatherClock = WeatherClock + 1
    
    If WeatherClock = 1020 Then
        WeatherClock = 0
        
ScanAgain:
        TheNewWeather = Int(19 * Rnd)
        If TheNewWeather = Server.Weather Then
            GoTo ScanAgain
        End If
        
        Server.Weather = TheNewWeather
        SendData "W" & Chr(10) & TheNewWeather
    End If
End Sub

Public Sub LaunchIRC()
    If Not IRC.Enabled Then Exit Sub
    
    IRCClient.SocketHandle = SocketIRC
    IRCClient.UserFullName = "RPG Andreas Server"
    IRCClient.UserName = IRC.Nick
    IRCClient.UserNick = IRC.Nick
    IRCClient.UserServName = "SAServerSERV"
    IRCClient.UserHostName = "SASERVALIENX"
    IRCClient.Connect IRC.Server, IRC.Port

End Sub

'Simple function which gets the winner from amount of cash a person has
Public Function ProcessGamemodeTimelimitWinner() As String
Dim i As Integer
Dim LastAmount As Long
Dim WinningID As String
    
    'Set default
    WinningID = -1
    
    'Get the winner
    For i = 1 To MAX_PLAYERS
        If Players(i).PlayerName <> "" Then
            If Players(i).Score > LastAmount Then
                LastAmount = Players(i).Score
                WinningID = i
            End If
        End If
    Next
    
    If WinningID = -1 Then
        ProcessGamemodeTimelimitWinner = WinningID
        Exit Function
    End If
    
    'Search again just incase some 1 allready has this value (a draw!)
    For i = 1 To MAX_PLAYERS
        If Players(i).PlayerName <> "" Then
            If Players(i).Score = Players(WinningID).Score Then
                If i <> WinningID Then
                    'we have a draw - so lets get both ID's send return them
                    WinningID = WinningID & "-" & i
                End If
            End If
        End If
    Next
    
    'Return
    ProcessGamemodeTimelimitWinner = WinningID
End Function

Public Sub ResetPlayersScores()
Dim i As Integer
    For i = 1 To MAX_PLAYERS
        Players(i).Score = 0 'easy
    Next
End Sub

Public Function ReverseBoolean(What As Boolean) As Boolean
    If What Then
        ReverseBoolean = False
    Else
        ReverseBoolean = True
    End If
End Function


Public Sub ControlRconMessage(ChatMessage As String, UserID As Integer)
On Error GoTo err_handle
Dim SplitLine() As String
Dim Buffer As String

Dim WEATHER_TYPE As String

    SplitLine = Split(Mid(ChatMessage, InStr(1, ChatMessage, "!rcon")), " ", 5)
    
    If UBound(SplitLine) >= 3 Then
        
        If SplitLine(1) <> Server.RconPassword Then
            SendData "C***Rcon Control: Invalid Rcon Password Given", UserID, True
            Exit Sub
        End If
        
        Select Case SplitLine(2)
            Case "kick"
                If UBound(SplitLine) = 4 Then
                    Buffer = SplitLine(4)
                End If
                SendData "C*** " & Players(SplitLine(3)).PlayerName & " was kicked by " & Players(UserID).PlayerName & " for " & Buffer, UserID
                SendData "UP" & Chr(10) & "K" & Chr(10) & Buffer, CInt(SplitLine(3)), True
                IRCClient.PrivMSG IRC.Channel, Players(SplitLine(3)).PlayerName & " was kicked from the server [IGA KICK BY:" & Players(UserID).PlayerName & "] reason=" & Buffer
                EraseClient CInt(SplitLine(3))
            Case "ban"
                If UBound(SplitLine) = 4 Then
                    Buffer = SplitLine(4)
                End If
                SendData "C*** " & Players(SplitLine(3)).PlayerName & " was banned by " & Players(UserID).PlayerName & " for " & Buffer, UserID
                SendData "UP" & Chr(10) & "B" & Chr(10) & Buffer, CInt(SplitLine(3)), True
                IRCClient.PrivMSG IRC.Channel, Players(SplitLine(3)).PlayerName & " was banned from the server [IGA KICK BY:" & Players(UserID).PlayerName & "] reason=" & Buffer
                SaveBan Players(SplitLine(3)).IP, Players(SplitLine(3)).PlayerName
                EraseClient CInt(SplitLine(3))
            Case "weather"
                SplitLine(3) = LCase(SplitLine(3))
                
                If SplitLine(3) = "sun" Then
                    WEATHER_TYPE = 11
                ElseIf SplitLine(3) = "rain" Then
                    WEATHER_TYPE = 16
                ElseIf SplitLine(3) = "storm" Then
                    WEATHER_TYPE = 8
                ElseIf SplitLine(3) = "sand" Then
                    WEATHER_TYPE = 19
                Else
                    If IsNumeric(SplitLine(3)) Then
                        WEATHER_TYPE = Val(SplitLine(3))
                    Else
                        SendData "C***Rcon Control: Invalid Weather Type Given, Allowed: sun,rain,storm,sand OR 0 -> 45", UserID, True
                    End If
                End If
                
                If CInt(WEATHER_TYPE) > 45 Then
                    SendData "C***Rcon Control: Error Weather code is too high - must be between 0 and 45", UserID, True
                    Exit Sub
                End If
                If CInt(WEATHER_TYPE) < 0 Then
                    SendData "C***Rcon Control: Error Weather code is too high - must be between 0 and 45", UserID, True
                    Exit Sub
                End If
                
                SendData "W" & Chr(10) & WEATHER_TYPE
                SendData "C*** Weather Changed By Admin " & Players(UserID).PlayerName
                IRCClient.PrivMSG IRC.Channel, "Weather Changed By IGA Admin: " & Players(UserID).PlayerName
                
            Case "time"
                
        End Select
        
    End If
    
    Exit Sub
err_handle:
    SendData "C***Rcon Control: Error " & Err.Description & " [" & Err.Number & "]", UserID, True
End Sub

Public Function GetGameModeString(Game As String) As String
    Select Case Game
        Case 1
            GetGameModeString = "Time Limit"
        Case 2
            GetGameModeString = "Mainiac Stunters"
        Case 3
            GetGameModeString = "Freeroam"
        Case 4
            GetGameModeString = "Cops and Robbers"
    End Select
End Function

Public Function CreateRandomString(Length As Long)
Dim i As Integer
Dim Base As String
Dim builder As String
Dim rndlng As Long

    Base = "mtpxnyeo7c0434sxdfZqC%P%DK<|!^ZS#d>}<C?B6Xc9WW~x8miG\Ouenfuena[03,I(OW&G+.>~Y:HM&LJP9&]CTtHXD%*..h9-$bpQl}R&[?:aFE4s.FZTe,?!jx<5Io5eu5}|sR^K/]ZqC%P%DK<|!^ZS#d>}<C?B6Xc9WW~x8miG\OO-|1Xa*^fjI(OW&G+.>~Y:HM&LJz:0PAQF9&]/]ZqC%P%DK<|!^ZS#d>}<C?B6Xc9WW~x8miG\OO-|"

    builder = ""
    For i = 1 To Length
tryagain:
        rndlng = CLng(Len(Base) * Rnd)
        If rndlng = 0 Then GoTo tryagain
        builder = builder & Mid(Base, rndlng, 1)
    Next
    
    CreateRandomString = builder

End Function

Public Sub LoadAndInitScripts()
Dim sTemp As String
Dim i As Integer

    Set MyScript = Nothing
    Set clsScriptCommands = Nothing
    Erase xScriptGlobalVars
    ScriptGlobalVarsCount = 0
    
    If ScriptTimersUsed Then
        For i = ScriptTimer.Count - 1 To 0 Step -1
            ScriptTimer(i).Interval = 0
            If i > 0 Then Unload ScriptTimer(i)
        Next
    End If
    Erase TheTimers
    ScriptTimerCount = 0
    
    'MyScript is a new instance of clsSadScript
    Set MyScript = New clsSadScript
    'Set new instance of the commands listed in clsCommands
    Set clsScriptCommands = New clsCommands
    'ReadInCode reads in the file, sets the module name in the script control
    'and attaches the file read in, into the module.
    MyScript.Path = App.Path
    MyScript.ReadInCode App.Path & "\code.sad", "code.sad", MyScript.SControl, False
    'MyScript.ReadInCode App.Path & "\scripts\player_functions.sad", "player_functions.sad", MyScript.SControl, False
    'MyScript.ReadInCode App.Path & "\scripts\system_functions.sad", "system_functions.sad", MyScript.SControl, False
    'MyScript.ReadInCode App.Path & "\scripts\irc_functions.sad", "irc_functions.sad", MyScript.SControl, False
    'This adds the clsCommands (dimed as clsScriptCommands) to the ScriptControl
    'ScriptHardCode is the name of this script controls module, the True on
    'the end specifies the module as being GLOBAL to all the script modules
    'contained inside the script control.
    MyScript.SControl.AddObject "ScriptHardCode", clsScriptCommands, True
    
    'This adds the picMoveMe picturebox control that is in the main form into the
    'scripting control for public use (set by the last propertie being TRUE) and
    'manipulation by the scripting functions that are read in.
    IRCClient.PrivMSG IRC.Channel, "[BETA] Starting Scripting Engine... Please wait"
    
    'Start the script.
    MyScript.SControl.Modules("code.sad").Run "Start"
End Sub

Public Sub PlayerQuitProcess(PlayerID As Variant, Nickname As Variant)
    '0 = quit | 1 = conid | 2 = playername
    DestroyPlayerSpheres CInt(PlayerID)
    AppendConsole "_QUIT: " & Nickname & " has left the game"
    ScriptCalls.PlayerQuit CInt(PlayerID) 'Call the script
    SendData "QUIT" & Chr(10) & PlayerID & Chr(10) & Nickname, CInt(PlayerID)
    EraseClient CInt(PlayerID)
End Sub

