Attribute VB_Name = "Mod_MapEngine"
Public MapEngine As MAPENG_Default
Public MapEngine_Storage(1 To 5000) As MAPENG_Storage

Public Type XYZVertex
    X As Single
    Y As Single
    Z As Single
End Type

Private Type MAPENG_Storage
    Location As XYZVertex
    Rotation As XYZVertex
    Model As Long
    WholeObject As String
End Type

Private Type MAPENG_Default
    Objects As Long
End Type

Public Sub LoadMap()
'Loads the map into the variables
Dim sMap As String
Dim sMapData() As String
Dim i As Integer
Dim FS As Integer
    
    FrmServer.AppendConsole "Loading Map Definition Files"
    
    sMap = "default"
    Do While sMap <> ""
        If i = 5001 Then Exit Do
        sMap = GetFromINI("MapEditor", "MapObject_" & i, App.Path & "\" & Server.ScriptPath)
        If sMap <> "" Then
            '0=ModelID
            'Location:
            '   1=lX
            '   2=lY
            '   3=lZ
            'Rotations:
            '   4=rX
            '   5=rY
            '   6=rZ
            sMapData = Split(sMap, " ")
            FS = FindFreeMapDataSlot
            MapEngine_Storage(FS).Model = CLng(sMapData(0))
            MapEngine_Storage(FS).Location.X = CSng(sMapData(1))
            MapEngine_Storage(FS).Location.Y = CSng(sMapData(2))
            MapEngine_Storage(FS).Location.Z = CSng(sMapData(3))
            MapEngine_Storage(FS).Rotation.X = CSng(sMapData(4))
            MapEngine_Storage(FS).Rotation.Y = CSng(sMapData(5))
            MapEngine_Storage(FS).Rotation.Z = CSng(sMapData(6))
            MapEngine_Storage(FS).WholeObject = sMap
        End If
        i = i + 1
    Loop
    
    MapEngine.Objects = (i - 1)
    FrmServer.AppendConsole "Done loading map files, Loaded " & (CInt(i) - 1) & " objects..."

End Sub

Public Function FindFreeMapDataSlot() As Integer
Dim i As Integer
    For i = 1 To 5000
        If MapEngine_Storage(i).Model = 0 Then
            FindFreeMapDataSlot = i
            Exit Function
        End If
    Next
End Function
