Attribute VB_Name = "Mod_httpfuncs"
Public wwwRoot As String
Public DefaultPage As String
Public PortNum As Integer
Public WebChatEnabled As Boolean

Public Declare Function GetPrivateProfileInt Lib "kernel32" _
    Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, _
    ByVal lpKeyName As String, ByVal nDefault As Long, _
    ByVal lpFileName As String) As Long

'Public Declare Function GetPrivateProfileString Lib "kernel32" _
    Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, _
    ByVal lpKeyName As String, ByVal lpDefault As String, _
    ByVal lpReturnedString As String, ByVal nSize As Long, _
    ByVal lpFileName As String) As Long

'Public Declare Function WritePrivateProfileString Lib "kernel32" _
    Alias "WritePrivateProfileStringA" _
    (ByVal lpApplicationName As String, ByVal lpKeyName As String, _
    ByVal lpString As String, ByVal lpFileName As String) As Long


Public Declare Function GetCurrentDirectory Lib "kernel32" _
        Alias "GetCurrentDirectoryA" (ByVal nBufferLength As Long, _
        ByVal lpBuffer As String) As Long


' Constants with OpenFile API call.
Private Const OF_READ = &H0

' Structure filled in by OpenFile API call.
Private Type OFSTRUCT
        cBytes As Byte
        fFixedDisk As Byte
        nErrCode As Integer
        Reserved1 As Integer
        Reserved2 As Integer
        szPathName(128) As Byte
End Type

' declarations for the API functions that this class uses.
Private Declare Function OpenFile Lib "kernel32" _
    (ByVal lpFileName As String, _
     lpReOpenBuff As OFSTRUCT, _
     ByVal wStyle As Long) As Long

Private Declare Function hread Lib "kernel32" Alias "_hread" _
    (ByVal hFile As Long, lpBuffer As Any, ByVal lBytes As Long) As Long

Private Declare Function lclose Lib "kernel32" Alias "_lclose" _
    (ByVal hFile As Long) As Long


Public Function readFile(sFile As String, Params As String) As String
    Dim hInp As Long
    Dim size As Long
    Dim inpOFS As OFSTRUCT
    
    Dim ff As Integer
    Dim Buffer As String
    Dim Line As String
    
    'size = FileLen(sFile)
    'hInp = OpenFile(sFile, inpOFS, OF_READ)
    'If (hInp <> -1) Then
    '    readFile = String(size, "*")
    '    hread hInp, ByVal readFile, size
    'End If
    
    ff = FreeFile
    Open sFile For Input As #ff
        Do While Not EOF(ff)
            Line Input #ff, Line
            Buffer = Buffer & Line & vbNewLine
        Loop
    Close #ff
    
    readFile = SortFileBuffer(Buffer, Params)
    
    lclose hInp
End Function

Public Function SortFileBuffer(InFile As String, Params As String) As String
'Currently used HTTP stuff:
Dim strOutput As String
Dim StrBuffer As String
Dim i As Integer
Dim PlayerCount As Integer

'Param Stuff
Dim SplitParam() As String
Dim SplitParamLine() As String

Dim PARAM_LOCATION As String

Dim CHAT_PARAM_NICK As String
Dim CHAT_PARAM_MSG As String

Dim PLAYER_ID_LOCATOR As Integer
Dim PLAYER_ID_FOUND As Integer
Dim PLAYER_ID_NAME As Integer
Dim PLAYER_IS_DATABASE_QUERY As Boolean
Dim PLAYER_KICK As Boolean
Dim PLAYER_BAN As Boolean
Dim PLAYER_RCON As String
Dim PLAYER_OUTCOME As String

Dim StrError As String

'Sort out the params...


strOutput = InFile
strOutput = Replace(strOutput, "%servername%", Server.ServerName)
strOutput = Replace(strOutput, "%serverversion%", AppVersion)
strOutput = Replace(strOutput, "%serverip%", FrmServer.Socket.LocalIP)
strOutput = Replace(strOutput, "%serverport%", Server.ServerPort)

If Server.GameMode.GameMode = 1 Then
    strOutput = Replace(strOutput, "%servergamemode%", "Speedy Stunters")
ElseIf Server.GameMode.GameMode = 2 Then
    strOutput = Replace(strOutput, "%servergamemode%", "Stunt Mainicas")
ElseIf Server.GameMode.GameMode = 3 Then
    strOutput = Replace(strOutput, "%servergamemode%", "Freeroam")
End If

strOutput = Replace(strOutput, "%servergamemodesettings%", Server.GameMode.Settings)

'<table width="75%" border="1">
'  <tr>
'    <td><div align="center">Player ID</div></td>
'    <td><div align="center">Player Name</div></td>
'    <td><div align="center">Player Score</div></td>
'  </tr>
'  <tr>
'    <td><div align="center"></div></td>
'    <td><div align="center"></div></td>
'    <td><div align="center"></div></td>
'  </tr>
'</table>

StrBuffer = StrBuffer & "<table width=" & """" & "75%" & """" & " border=" & """" & "1" & """" & " align='center'>" & vbNewLine
StrBuffer = StrBuffer & "<tr>" & vbNewLine
StrBuffer = StrBuffer & "<td><div align=" & """" & "center" & """" & "><b><font color='#FFFFFF'>Player ID</font></b></div></td>" & vbNewLine
StrBuffer = StrBuffer & "<td><div align=" & """" & "center" & """" & "><b><font color='#FFFFFF'>Player Name</font></b></div></td>" & vbNewLine
StrBuffer = StrBuffer & "<td><div align=" & """" & "center" & """" & "><b><font color='#FFFFFF'>Player Score</font></b></div></td>" & vbNewLine
StrBuffer = StrBuffer & "<td><div align=" & """" & "center" & """" & "><b><font color='#FFFFFF'>Kick</font></b></div></td>" & vbNewLine
StrBuffer = StrBuffer & "<td><div align=" & """" & "center" & """" & "><b><font color='#FFFFFF'>Ban</font></b></div></td>" & vbNewLine
StrBuffer = StrBuffer & "</tr>" & vbNewLine

For i = 1 To MAX_PLAYERS
    If Players(i).PlayerName <> "" Then
        PlayerCount = PlayerCount + 1
    End If
Next
    
If PlayerCount > 0 Then
    For i = 1 To MAX_PLAYERS
        If Players(i).PlayerName <> "" Then
            StrBuffer = StrBuffer & "<tr>" & vbNewLine
            StrBuffer = StrBuffer & "<td><div align=" & """" & "center" & """" & "><font color='#999999'>" & i & "</font></div></td>" & vbNewLine
            StrBuffer = StrBuffer & "<td><div align=" & """" & "center" & """" & "><font color='#999999'><a href=" & """" & "player.htm?Player_id=" & i & """" & ">" & Players(i).PlayerName & "</a></font></div></td>" & vbNewLine
            StrBuffer = StrBuffer & "<td><div align=" & """" & "center" & """" & "><font color='#999999'>$" & Players(i).Score & "</font></div></td>" & vbNewLine
            StrBuffer = StrBuffer & "<td><div align=" & """" & "center" & """" & "><font color='#999999'><a href=" & """" & "playercontrol.htm?PlayerKick_ID=" & i & """" & ">" & "Kick" & "</a></font></div></td>" & vbNewLine
            StrBuffer = StrBuffer & "<td><div align=" & """" & "center" & """" & "><font color='#999999'><a href=" & """" & "playercontrol.htm?PlayerBan_ID=" & i & """" & ">" & "Ban" & "</a></font></div></td>" & vbNewLine
            StrBuffer = StrBuffer & "</tr>" & vbNewLine
        End If
    Next
    
    StrBuffer = StrBuffer & "</table>" & vbNewLine

Else
    StrBuffer = "<font color='#FFFFFF'>There are no players on this server</font>"
End If



strOutput = Replace(strOutput, "%buildplayerlist%", StrBuffer)

StrBuffer = ""

'Check for that chat params etc
If Params <> "" Then
    Params = Replace(Params, "+", " ")
    SplitParam = Split(Params, "&")
    
    'Seek out param data
    For i = 0 To UBound(SplitParam)
        SplitParamLine = Split(SplitParam(i), "=")
        
        If SplitParamLine(0) = "CHAT_MESSAGE_NICKNAME" Then
            CHAT_PARAM_NICK = SplitParamLine(1)
        End If
        If SplitParamLine(0) = "CHAT_MESSAGE_MESSAGE" Then
            CHAT_PARAM_MSG = SplitParamLine(1)
        End If
        If SplitParamLine(0) = "Submit" Then
            PARAM_LOCATION = SplitParamLine(1)
        End If
    Next
    
    If PARAM_LOCATION = "Message Server" Then
        If WebChatEnabled Then
            If CHAT_PARAM_NICK <> "" Then
                If CHAT_PARAM_MSG <> "" Then
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%20", " ")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%21", "!")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%22", """")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%23", "#")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%24", "$")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%25", "%")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%26", "&")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%27", "'")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%28", "(")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%29", ")")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%2A", "*")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%2B", "+")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%2C", ",")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%2D", "-")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%2E", ".")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%2F", "/")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%3F", "?")
                    CHAT_PARAM_MSG = Replace(CHAT_PARAM_MSG, "%5E", "^")
                    AppendChatHistory "[" & CHAT_PARAM_NICK & "@Web] " & CHAT_PARAM_MSG & vbNewLine
                    FrmServer.SendData "C[" & CHAT_PARAM_NICK & "@Web] " & CHAT_PARAM_MSG
                    FrmServer.IRCClient.PrivMSG IRC.Channel, "[" & CHAT_PARAM_NICK & "@Web] " & CHAT_PARAM_MSG
                Else
                    StrError = "SERVER: You need to supply a message" & vbNewLine
                End If
            Else
                StrError = "SERVER: You need to supply a nickname" & vbNewLine
            End If
        End If
    End If
End If

If Server.ChatHistory.Line6 <> "" Then
    StrBuffer = StrBuffer & Server.ChatHistory.Line6 & "<br>" & vbNewLine
End If
If Server.ChatHistory.Line5 <> "" Then
    StrBuffer = StrBuffer & Server.ChatHistory.Line5 & "<br>" & vbNewLine
End If
If Server.ChatHistory.Line4 <> "" Then
    StrBuffer = StrBuffer & Server.ChatHistory.Line4 & "<br>" & vbNewLine
End If
If Server.ChatHistory.Line3 <> "" Then
    StrBuffer = StrBuffer & Server.ChatHistory.Line3 & "<br>" & vbNewLine
End If
If Server.ChatHistory.Line2 <> "" Then
    StrBuffer = StrBuffer & Server.ChatHistory.Line2 & "<br>" & vbNewLine
End If
If Server.ChatHistory.Line1 <> "" Then
    StrBuffer = StrBuffer & Server.ChatHistory.Line1 & "<br>" & vbNewLine
End If


strOutput = Replace(strOutput, "%buildchatlist%", StrBuffer)


'<form name="form1" id="form1" method="submit" action="chat.html">
'            <font color='#FFFFFF'>Nick:
'            <input name='CHAT_MESSAGE_NICKNAME' type='text' maxlength='16' />
'            Msg:</font>
'            <input name='CHAT_MESSAGE_MESSAGE' type='text' id='ChatMessageField' maxlength='60' />
'            # <br />
'            <input type='submit' name='Submit' value='Message Server' />
'            <input type='submit' name='Submit2' value='Refresh' />
'          </form>

If WebChatEnabled Then
    StrBuffer = ""
    StrBuffer = StrBuffer & "<form name='form1' id='form1' method='submit' action='chat.htm'>"
    StrBuffer = StrBuffer & "            <font color='#FFFFFF'>Nick:"
    StrBuffer = StrBuffer & "            <input name='CHAT_MESSAGE_NICKNAME' type='text' maxlength='16' />"
    StrBuffer = StrBuffer & "            <br>Msg:</font>"
    StrBuffer = StrBuffer & "            <input name='CHAT_MESSAGE_MESSAGE' width='300' type='text' id='ChatMessageField' maxlength='60' />"
    StrBuffer = StrBuffer & "            <br />"
    StrBuffer = StrBuffer & "            <input type='submit' name='Submit' value='Message Server' />"
    StrBuffer = StrBuffer & "            <input type='submit' name='Submit2' value='Refresh' />"
    StrBuffer = StrBuffer & "          </form>"
Else
    StrError = "Web Chat is disabled by an admin"
    StrBuffer = ""
End If
strOutput = Replace(strOutput, "%chatform%", StrBuffer)


'Output PlayerCount and Max
strOutput = Replace(strOutput, "%playercount%", PlayerCount)
strOutput = Replace(strOutput, "%playermax%", Server.MaxPlayers)

'output the console
Set re = New clsStringStuff
'Debug.Print re.IsValid(EmailAddress, "mat-sje+h.gf_123@boll-ocks.net")
'Debug.Print re.IsValid(IPAddress, "200.100.100.10")

'output Player Database
1   '<table width='75%' border='1' align='center'>
2   '                <tr>
3   '                  <td width='9%'>ID</td>
4   '                  <td width='91%'>Playername</td>
5   '                </tr>
6   '                <tr>
7   '                  <td>%id%</td>
8   '                  <td>%pname%</td>
9   '                </tr>
10  '                <tr>
11  '                  <td>%id%</td>
12  '                  <td>%pname%</td>
13  '                </tr>
14  '              </table>

If InStr(1, strOutput, "%buildplayerdatabase%") > 0 Then
    StrBuffer = ""
    StrBuffer = StrBuffer & "<table width='75%' border='1' align='center'>" & vbNewLine
    StrBuffer = StrBuffer & " <tr>" & vbNewLine
    StrBuffer = StrBuffer & "  <td width='9%'>ID</td>" & vbNewLine
    StrBuffer = StrBuffer & "  <td width='91%'>Playername</td>" & vbNewLine
    StrBuffer = StrBuffer & " </tr>" & vbNewLine
    
    For i = 1 To 30000
        If PlayerStats(i).PlayerName <> "" Then
            StrBuffer = StrBuffer & " <tr>" & vbNewLine
            StrBuffer = StrBuffer & "  <td>" & i & "</td>" & vbNewLine
            StrBuffer = StrBuffer & "  <td><a href='viewplayer.htm?ViewPlayer_ID=" & i & "'>" & PlayerStats(i).PlayerName & "</a></td>" & vbNewLine
            StrBuffer = StrBuffer & " </tr>" & vbNewLine
        End If
    Next
    

    StrBuffer = StrBuffer & "</table>" & vbNewLine
    
    strOutput = Replace(strOutput, "%buildplayerdatabase%", StrBuffer)
    StrBuffer = ""
End If

Dim GoodAddy As Match
Dim Mymatches As MatchCollection

StrBuffer = "<font color='#993300' size='4'>Trailing Server Console</font><br><br>"
StrBuffer = StrBuffer & Replace(Right(FrmServer.txt_Console.Text, 2000), vbNewLine, "<br>")
Set Mymatches = re.Extract(ipaddress, Replace(Right(FrmServer.txt_Console.Text, 2000), vbNewLine, "<br>"))

'Debug.Print Mymatches.Count
For Each GoodAddy In Mymatches
    'Debug.Print GoodAddy.Value
    StrBuffer = Replace(StrBuffer, GoodAddy.Value, "xxx.xxx.xxx.xxx")
Next

Set re = Nothing

StrBuffer = Replace(StrBuffer, "----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------", "--------------------------------------------------------------------------------------------------------------------------------------")
strOutput = Replace(strOutput, "%buildconsole%", StrBuffer)

'Detect Player Page
'If InStr(1, Params, "Player_id=") > 0 Then
If Params <> "" Then
    SplitParam = Split(Params, "&")
    
    'Seek out param data
    For i = 0 To UBound(SplitParam)
        SplitParamLine = Split(SplitParam(i), "=")
        
        If SplitParamLine(0) = "Player_id" Then
            PLAYER_ID_NAME = SplitParamLine(1)
        End If
        If SplitParamLine(0) = "ViewPlayer_ID" Then
            PLAYER_ID_NAME = SplitParamLine(1)
            PLAYER_IS_DATABASE_QUERY = True
        End If
        If SplitParamLine(0) = "PlayerKick_ID" Then
            PLAYER_KICK = True
            PLAYER_ID_NAME = SplitParamLine(1)
        End If
        If SplitParamLine(0) = "PlayerBan_ID" Then
            PLAYER_BAN = True
            PLAYER_ID_NAME = SplitParamLine(1)
        End If
        If SplitParamLine(0) = "PlayerRcon_Password" Then
            PLAYER_RCON = SplitParamLine(1)
        End If
        If SplitParamLine(0) = "Outcome" Then
            PLAYER_OUTCOME = SplitParamLine(1)
        End If
    Next
    
    If PLAYER_KICK Or PLAYER_BAN Then
    
        strOutput = Replace(strOutput, "%playerid%", PLAYER_ID_NAME)
    
        If PLAYER_KICK Then
            If PLAYER_ID_NAME > 0 Then
                strOutput = Replace(strOutput, "%action%", "Kick")
                strOutput = Replace(strOutput, "%playername%", Players(PLAYER_ID_NAME).PlayerName)
                If PLAYER_OUTCOME = "Yes" Then
                    If PLAYER_RCON <> "" Then
                        If PLAYER_RCON = Server.RconPassword Then
                            FrmServer.SendData "UP" & Chr(10) & "K" & Chr(10) & "Web Admin Kick", CInt(PLAYER_ID_NAME), True
                            FrmServer.IRCClient.PrivMSG IRC.Channel, Players(PLAYER_ID_NAME).PlayerName & " was kicked from the server reason=Web Admin Kick"
                            StrError = "Player Was Kicked <a href='players.htm'>Click here to return to player list</a>"
                        Else
                            StrError = "Invalid Rcon Password"
                        End If
                    End If
                ElseIf PLAYER_OUTCOME = "No" Then
                    StrError = "Player Kick Aborted <br> <a href='players.htm'>Click here to return to player list</a>"
                End If
            Else
                StrError = "Invalid Player ID"
            End If
        End If

        If PLAYER_BAN Then
            If PLAYER_ID_NAME > 0 Then
                strOutput = Replace(strOutput, "%action%", "Ban")
                strOutput = Replace(strOutput, "%playername%", Players(PLAYER_ID_NAME).PlayerName)
                If PLAYER_OUTCOME = "Yes" Then
                    If PLAYER_RCON <> "" Then
                        If PLAYER_RCON = Server.RconPassword Then
                            FrmServer.SendData "UP" & Chr(10) & "B" & Chr(10) & "Web Admin Kick", CInt(PLAYER_ID_NAME), True
                            FrmServer.IRCClient.PrivMSG IRC.Channel, Players(PLAYER_ID_NAME).PlayerName & " was banned from the server reason=Web Admin Kick"
                            SaveBan Players(PLAYER_ID_NAME).IP, Players(PLAYER_ID_NAME).PlayerName
                            StrError = "Player Was Banned <br> <a href='players.htm'>Click here to return to player list</a>"
                        Else
                            StrError = "Invalid Rcon Password"
                        End If
                    End If
                ElseIf PLAYER_OUTCOME = "No" Then
                    StrError = "Player Ban Aborted <br> <a href='players.htm'>Click here to return to player list</a>"
                End If
            Else
                StrError = "Invalid Player ID"
            End If
        End If
        
        PLAYER_ID_NAME = 0
        
    End If
    
    If PLAYER_ID_NAME > 0 Then
        If PLAYER_IS_DATABASE_QUERY Then
            For PLAYER_ID_LOCATOR = 1 To 30000
                If PlayerStats(PLAYER_ID_LOCATOR).PlayerName = PlayerStats(PLAYER_ID_NAME).PlayerName Then
                    PLAYER_ID_FOUND = PLAYER_ID_LOCATOR
                    Exit For
                End If
            Next
        Else
            For PLAYER_ID_LOCATOR = 1 To 30000
                If PlayerStats(PLAYER_ID_LOCATOR).PlayerName = Players(PLAYER_ID_NAME).PlayerName Then
                    PLAYER_ID_FOUND = PLAYER_ID_LOCATOR
                    Exit For
                End If
            Next
        End If
        
        If Players(PLAYER_ID_NAME).PlayerName <> "" And Not PLAYER_IS_DATABASE_QUERY Then
            
            If PLAYER_ID_FOUND > 0 Then
            '<form name='form1' id='form1' method='submit' action='player.htm?Player_id=%playerid%'>
            '        <center>
            '          <font color='#993300' size='4'>Viewing Player: %playername%
            '          -</font>
            '          <input type='button' name='Button' value='Refresh Player' />
            '        </center>
            '      </form>
                
                StrBuffer = ""
                StrBuffer = StrBuffer & "<font color='#993300' size='4'>Viewing Player: %playername% <a href='player.htm?Player_id=" & PLAYER_ID_FOUND & "'>refresh</a>" & vbNewLine
                StrBuffer = StrBuffer & "</font>" & vbNewLine
                
                strOutput = Replace(strOutput, "%playerheader%", StrBuffer)
            
                strOutput = Replace(strOutput, "%playerid%", PLAYER_ID_NAME)
                strOutput = Replace(strOutput, "%player_name%", Players(PLAYER_ID_NAME).PlayerName)
                strOutput = Replace(strOutput, "%playername%", Players(PLAYER_ID_NAME).PlayerName)
                strOutput = Replace(strOutput, "%player_deaths%", PlayerStats(PLAYER_ID_FOUND).Deaths)
                strOutput = Replace(strOutput, "%player_carsjacked%", PlayerStats(PLAYER_ID_FOUND).CarsJacked)
                strOutput = Replace(strOutput, "%player_score%", "$" & PlayerStats(PLAYER_ID_FOUND).OverallScore)
                strOutput = Replace(strOutput, "%player_chatmessages%", PlayerStats(PLAYER_ID_FOUND).ChatMessagesSent)
                strOutput = Replace(strOutput, "%player_gameswon%", PlayerStats(PLAYER_ID_FOUND).GamesWon)
                strOutput = Replace(strOutput, "%player_stuntcount%", PlayerStats(PLAYER_ID_FOUND).StuntsPreformed)
                strOutput = Replace(strOutput, "%player_higheststunt%", "$" & PlayerStats(PLAYER_ID_FOUND).zHighestScoreInOneStunt)
                strOutput = Replace(strOutput, "%player_timeplayed%", FormatTime(CLng(PlayerStats(PLAYER_ID_FOUND).TotalTimePlayed)))
                strOutput = Replace(strOutput, "%player_servercount%", PlayerStats(PLAYER_ID_FOUND).NumberOfTimesOnServer)
                strOutput = Replace(strOutput, "%player_favvehicle%", PlayerStats(PLAYER_ID_FOUND).LastVehicleUsed)
                If IsPlayerConnected(PlayerStats(PLAYER_ID_FOUND).PlayerName) Then
                    strOutput = Replace(strOutput, "%player_isactive%", Replace(IsPlayerConnected(PlayerStats(PLAYER_ID_FOUND).PlayerName), "True", "Yes"))
                Else
                    strOutput = Replace(strOutput, "%player_isactive%", Replace(IsPlayerConnected(PlayerStats(PLAYER_ID_FOUND).PlayerName), "False", "No"))
                End If
            Else
                strOutput = Replace(strOutput, "%playerheader%", "")
                strOutput = Replace(strOutput, "%player_name%", Players(PLAYER_ID_NAME).PlayerName)
                strOutput = Replace(strOutput, "%playername%", Players(PLAYER_ID_NAME).PlayerName)
                strOutput = Replace(strOutput, "%player_deaths%", "")
                strOutput = Replace(strOutput, "%player_carsjacked%", "")
                strOutput = Replace(strOutput, "%player_score%", "")
                strOutput = Replace(strOutput, "%player_chatmessages%", "")
                strOutput = Replace(strOutput, "%player_gameswon%", "")
                strOutput = Replace(strOutput, "%player_stuntcount%", "")
                strOutput = Replace(strOutput, "%player_higheststunt%", "")
                strOutput = Replace(strOutput, "%player_timeplayed%", "")
                strOutput = Replace(strOutput, "%player_servercount%", "")
                strOutput = Replace(strOutput, "%player_favvehicle%", "")
                StrError = "The player cannot be found!"
            End If
        Else
            If Not PLAYER_IS_DATABASE_QUERY Then
                strOutput = Replace(strOutput, "%playerheader%", "")
                strOutput = Replace(strOutput, "%player_name%", "Unknown")
                strOutput = Replace(strOutput, "%playername%", "Unknown")
                strOutput = Replace(strOutput, "%player_deaths%", "Unknown")
                strOutput = Replace(strOutput, "%player_carsjacked%", "Unknown")
                strOutput = Replace(strOutput, "%player_score%", "Unknown")
                strOutput = Replace(strOutput, "%player_chatmessages%", "Unknown")
                strOutput = Replace(strOutput, "%player_gameswon%", "Unknown")
                strOutput = Replace(strOutput, "%player_stuntcount%", "Unknown")
                strOutput = Replace(strOutput, "%player_higheststunt%", "Unknown")
                strOutput = Replace(strOutput, "%player_timeplayed%", "Unknown")
                strOutput = Replace(strOutput, "%player_servercount%", "Unknown")
                strOutput = Replace(strOutput, "%player_favvehicle%", "Unknown")
                '%player_isactive%
                strOutput = Replace(strOutput, "%player_isactive%", "No")
                StrError = "PlayerID " & PLAYER_ID_NAME & " is not in use"
            Else
                StrBuffer = ""
                StrBuffer = StrBuffer & "<font color='#993300' size='4'>Viewing Player %playername% From Database <a href='viewplayer.htm?ViewPlayer_ID=" & PLAYER_ID_FOUND & "'>refresh</a>" & vbNewLine
                StrBuffer = StrBuffer & "</font>" & vbNewLine
                
                strOutput = Replace(strOutput, "%playerheader%", StrBuffer)
            
                strOutput = Replace(strOutput, "%playerid%", PLAYER_ID_FOUND)
                strOutput = Replace(strOutput, "%player_name%", PlayerStats(PLAYER_ID_FOUND).PlayerName)
                strOutput = Replace(strOutput, "%playername%", PlayerStats(PLAYER_ID_FOUND).PlayerName)
                strOutput = Replace(strOutput, "%player_deaths%", PlayerStats(PLAYER_ID_FOUND).Deaths)
                strOutput = Replace(strOutput, "%player_carsjacked%", PlayerStats(PLAYER_ID_FOUND).CarsJacked)
                strOutput = Replace(strOutput, "%player_score%", "$" & PlayerStats(PLAYER_ID_FOUND).OverallScore)
                strOutput = Replace(strOutput, "%player_chatmessages%", PlayerStats(PLAYER_ID_FOUND).ChatMessagesSent)
                strOutput = Replace(strOutput, "%player_gameswon%", PlayerStats(PLAYER_ID_FOUND).GamesWon)
                strOutput = Replace(strOutput, "%player_stuntcount%", PlayerStats(PLAYER_ID_FOUND).StuntsPreformed)
                strOutput = Replace(strOutput, "%player_higheststunt%", "$" & PlayerStats(PLAYER_ID_FOUND).zHighestScoreInOneStunt)
                strOutput = Replace(strOutput, "%player_timeplayed%", FormatTime(CLng(PlayerStats(PLAYER_ID_FOUND).TotalTimePlayed)))
                strOutput = Replace(strOutput, "%player_servercount%", PlayerStats(PLAYER_ID_FOUND).NumberOfTimesOnServer)
                strOutput = Replace(strOutput, "%player_favvehicle%", PlayerStats(PLAYER_ID_FOUND).LastVehicleUsed)
                
                If IsPlayerConnected(PlayerStats(PLAYER_ID_FOUND).PlayerName) Then
                    strOutput = Replace(strOutput, "%player_isactive%", Replace(IsPlayerConnected(PlayerStats(PLAYER_ID_FOUND).PlayerName), "True", "Yes"))
                Else
                    strOutput = Replace(strOutput, "%player_isactive%", Replace(IsPlayerConnected(PlayerStats(PLAYER_ID_FOUND).PlayerName), "False", "No"))
                End If
            End If
        End If
    ElseIf Not PLAYER_KICK And Not PLAYER_BAN Then
            strOutput = Replace(strOutput, "%playerheader%", "")
            strOutput = Replace(strOutput, "%player_name%", "Unknown")
            strOutput = Replace(strOutput, "%playername%", "Unknown")
            strOutput = Replace(strOutput, "%player_deaths%", "Unknown")
            strOutput = Replace(strOutput, "%player_carsjacked%", "Unknown")
            strOutput = Replace(strOutput, "%player_score%", "Unknown")
            strOutput = Replace(strOutput, "%player_chatmessages%", "Unknown")
            strOutput = Replace(strOutput, "%player_gameswon%", "Unknown")
            strOutput = Replace(strOutput, "%player_stuntcount%", "Unknown")
            strOutput = Replace(strOutput, "%player_higheststunt%", "Unknown")
            strOutput = Replace(strOutput, "%player_timeplayed%", "Unknown")
            strOutput = Replace(strOutput, "%player_servercount%", "Unknown")
            strOutput = Replace(strOutput, "%player_favvehicle%", "Unknown")
            StrError = "incorrect page url synax"
    End If
End If
    
'End If

'Output errors
If StrError <> "" Then strOutput = Replace(strOutput, "%error%", "Error: " & StrError) Else strOutput = Replace(strOutput, "%error%", "")

SortFileBuffer = strOutput

End Function


