Attribute VB_Name = "ScriptCalls"
'This file contains all the calls to the script

Public Sub ChatMessageIn(PlayerID As Integer, ChatMessage As String)
Dim Data(1) As Variant
    Data(0) = PlayerID
    Data(1) = ChatMessage

    MyScript.SControl.Modules("system_functions.sad").Run "on_player_chat", Data()
End Sub

Public Sub PlayerJoined(PlayerID As Integer)
    MyScript.SControl.Modules("player_functions.sad").Run "on_player_join", PlayerID
End Sub

Public Sub PlayerQuit(PlayerID As Integer)
    MyScript.SControl.Modules("player_functions.sad").Run "on_player_quit", PlayerID
End Sub

Public Sub PlayerPlaying(PlayerID As Integer)
    MyScript.SControl.Modules("player_functions.sad").Run "on_player_playing", PlayerID
End Sub

Public Sub PlayerStartedGame(PlayerID As Integer)
    MyScript.SControl.Modules("player_functions.sad").Run "on_player_startgame", PlayerID
End Sub

Public Sub PlayerMoneyChange(PlayerID As Integer, OldMoney As Long, NewMoney As Long)
Dim Data(2) As Variant

    Data(0) = PlayerID
    Data(1) = OldMoney
    Data(2) = NewMoney
    MyScript.SControl.Modules("player_functions.sad").Run "on_player_money_change", Data()
End Sub

Public Sub PlayerEnterVehicle(PlayerID As Variant, VehicleID As Variant, State As Variant, SeatID As Variant)
Dim Data(3) As Variant
    
    Data(0) = PlayerID
    Data(1) = CInt(VehicleID) + 1
    Data(2) = State
    Data(3) = SeatID
    MyScript.SControl.Modules("player_functions.sad").Run "on_player_enter_vehicle", Data()
End Sub

Public Sub PlayerExitVehicle(PlayerID As Variant, VehicleID As Variant, State As Variant)
Dim Data(2) As Variant

    Data(0) = PlayerID
    Data(1) = CInt(VehicleID) + 1
    Data(2) = State
    MyScript.SControl.Modules("player_functions.sad").Run "on_player_exit_vehicle", Data()
End Sub

Public Sub PlayerActionStart(PlayerID As Variant, ActionID As Variant)
Dim Data(1) As Variant
    Data(0) = PlayerID
    Data(1) = ActionID
    MyScript.SControl.Modules("player_functions.sad").Run "on_player_action", Data()
End Sub

Public Sub PlayerDeath(PlayerID As Variant, DeathType As Variant, WeaponID As Variant)
    Dim Data(2) As Variant
    Data(0) = PlayerID
    Data(1) = DeathType
    Data(2) = WeaponID
    MyScript.SControl.Modules("player_functions.sad").Run "on_player_death", Data()
End Sub

Public Sub PlayerKill(KillerID As Variant, PreyID As Variant, WeaponID As Variant)
    Dim Data(2) As Variant
    Data(0) = KillerID
    Data(1) = PreyID
    Data(2) = WeaponID
    MyScript.SControl.Modules("player_functions.sad").Run "on_player_kill", Data()
End Sub

Public Sub PlayerRespawned(PlayerID As Variant)
    MyScript.SControl.Modules("player_functions.sad").Run "on_player_respawn", PlayerID
End Sub

Public Sub PlayerFirstJoin(PlayerID As Variant)
    MyScript.SControl.Modules("player_functions.sad").Run "on_player_first_join", PlayerID
End Sub

'IRC Based ones:
Public Sub IRCMessageIn(Nickname As String, Message As String)
Dim PamArray(1) As Variant

    PamArray(0) = Nickname
    PamArray(1) = Message
    MyScript.SControl.Modules("irc_functions.sad").Run "on_irc_chatmessage", PamArray
End Sub
