VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsStringStuff"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Enum RegExpTypes
 EmailAddress
 ipaddress
End Enum
Private MyRegExp As RegExp

Private Function GetPattern(Ptype As RegExpTypes) As String
  If Ptype = EmailAddress Then
    'set pattern for email
    GetPattern = "^([a-zA-Z0-9_\-\.\+]+)@(((25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])|(\w+((-\w+)|(\w*))\.)+[a-z]{2,4}))$"
  ElseIf Ptype = ipaddress Then
    'set pattern for ip addresses
    GetPattern = "^(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])$"
  End If
End Function

Public Function IsValid(test As RegExpTypes, s As String) As Boolean
' return true or false depending on whether
' the whole string s is a valid pattern match

' set the pattern
MyRegExp.Pattern = GetPattern(test)

'all the chars must fit pattern
MyRegExp.Global = False
MyRegExp.IgnoreCase = True

' perform test and return result
IsValid = MyRegExp.test(s)
End Function

Public Function Extract(test As RegExpTypes, s As String) As MatchCollection
' searches s for pattern
' return all matches

' set the expression
Dim TestPattern
TestPattern = GetPattern(test)

''this is the fix
' remove the ^ and $, which are the first and last chars of either test
MyRegExp.Pattern = Mid(TestPattern, 2, Len(TestPattern) - 2)

' search for any matches withing s
MyRegExp.Global = True
MyRegExp.IgnoreCase = True
MyRegExp.MultiLine = True

' return a collection of matches
Set Extract = MyRegExp.Execute(s)
End Function

Private Sub Class_Initialize()
Set MyRegExp = New RegExp
End Sub

Private Sub Class_Terminate()
Set MyRegExp = Nothing
End Sub

